(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var global = Package.meteor.global;
var meteorEnv = Package.meteor.meteorEnv;
var ECMAScript = Package.ecmascript.ECMAScript;
var MongoInternals = Package.mongo.MongoInternals;
var Mongo = Package.mongo.Mongo;
var Random = Package.random.Random;
var check = Package.check.check;
var Match = Package.check.Match;
var _ = Package.underscore._;
var Accounts = Package['accounts-base'].Accounts;
var HTTP = Package.http.HTTP;
var HTTPInternals = Package.http.HTTPInternals;
var Identicon = Package['sandstorm-identicons'].Identicon;
var meteorInstall = Package.modules.meteorInstall;
var Buffer = Package.modules.Buffer;
var process = Package.modules.process;
var Symbol = Package['ecmascript-runtime'].Symbol;
var Map = Package['ecmascript-runtime'].Map;
var Set = Package['ecmascript-runtime'].Set;
var meteorBabelHelpers = Package['babel-runtime'].meteorBabelHelpers;
var Promise = Package.promise.Promise;

/* Package-scope variables */
var Packages, DevPackages, UserActions, Grains, RoleAssignments, Contacts, Sessions, SignupKeys, ActivityStats, DeleteStats, FileTokens, SpkTokens, ApiTokens, ApiHosts, Notifications, ActivitySubscriptions, StatsTokens, Misc, Settings, Migrations, StaticAssets, AssetUploadTokens, Plans, AppIndex, KeybaseProfiles, FeatureKey, SetupSession, successfulReferralsCount, isAdmin, isAdminById, findAdminUserForToken, matchWildcardHost, makeWildcardHost, getWildcardOrigin, SandstormDb, appName;

var require = meteorInstall({"node_modules":{"meteor":{"sandstorm-db":{"db.js":["babel-runtime/helpers/typeof",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/sandstorm-db/db.js                                                                                         //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof2 = require("babel-runtime/helpers/typeof");                                                                //
                                                                                                                       //
var _typeof3 = _interopRequireDefault(_typeof2);                                                                       //
                                                                                                                       //
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }                      //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  // 1
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               // 2
// All rights reserved.                                                                                                // 3
//                                                                                                                     // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                     // 5
// you may not use this file except in compliance with the License.                                                    // 6
// You may obtain a copy of the License at                                                                             // 7
//                                                                                                                     // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        // 9
//                                                                                                                     // 10
// Unless required by applicable law or agreed to in writing, software                                                 // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                   // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            // 13
// See the License for the specific language governing permissions and                                                 // 14
// limitations under the License.                                                                                      // 15
// This file defines the database schema.                                                                              // 17
// Useful for debugging: Set the env variable LOG_MONGO_QUERIES to have the server write every                         // 19
// query it makes, so you can see if it's doing queries too often, etc.                                                // 20
if (Meteor.isServer && process.env.LOG_MONGO_QUERIES) {                                                                // 21
  var oldFind = Mongo.Collection.prototype.find;                                                                       // 22
                                                                                                                       //
  Mongo.Collection.prototype.find = function () {                                                                      // 23
    console.log(this._prefix, arguments);                                                                              // 24
    return oldFind.apply(this, arguments);                                                                             // 25
  };                                                                                                                   // 26
} // Helper so that we don't have to if (Meteor.isServer) before declaring indexes.                                    // 27
                                                                                                                       //
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 30
  Mongo.Collection.prototype.ensureIndexOnServer = Mongo.Collection.prototype._ensureIndex;                            // 31
} else {                                                                                                               // 32
  Mongo.Collection.prototype.ensureIndexOnServer = function () {};                                                     // 33
} // TODO(soon): Systematically go through this file and add ensureIndexOnServer() as needed.                          // 34
                                                                                                                       //
                                                                                                                       //
var collectionOptions = {                                                                                              // 38
  defineMutationMethods: Meteor.isClient                                                                               // 38
}; // Set to `true` on the client so that method simulation works. Set to `false` on the server                        // 38
// so that we can be extra certain that all mutations must go through methods.                                         // 40
// Users = new Mongo.Collection("users");                                                                              // 42
// The users collection is special and can be accessed through `Meteor.users`.                                         // 43
// See https://docs.meteor.com/#/full/meteor_users.                                                                    // 44
//                                                                                                                     // 45
// There are two distinct types of entries in the users collection: identities and accounts. An                        // 46
// identity contains personal profile information and typically includes some intrinsic method for                     // 47
// authenticating as the owner of that information.                                                                    // 48
//                                                                                                                     // 49
// An account is an owner of app actions, grains, contacts, notifications, and payment info.                           // 50
// Each account can have multiple identities linked to it. To log in as an account you must first                      // 51
// authenticate as one of its linked identities.                                                                       // 52
//                                                                                                                     // 53
// Every user contains the following fields:                                                                           // 54
//   _id: Unique string ID. For accounts, this is random. For identities, this is the globally                         // 55
//        stable SHA-256 ID of this identity, hex-encoded.                                                             // 56
//   createdAt: Date when this entry was added to the collection.                                                      // 57
//   lastActive: Date of the user's most recent interaction with this Sandstorm server.                                // 58
//   services: Object containing login data used by Meteor authentication services.                                    // 59
//   expires: Date when this user should be deleted. Only present for demo users.                                      // 60
//   upgradedFromDemo: If present, the date when this user was upgraded from being a demo user.                        // 61
//                     TODO(cleanup): Unlike other dates in our database, this is stored as a number                   // 62
//                     rather than as a Date object. We should fix that.                                               // 63
//   appDemoId: If present and non-null, then the user is a demo user who arrived via an /appdemo/                     // 64
//              link. This field contains the app ID of the app that the user started out demoing.                     // 65
//              Unlike the `expires` field, this field is not cleared when the user upgrades from                      // 66
//              being a demo user.                                                                                     // 67
//   suspended: If this exists, this account/identity is supsended. Both accounts and identities                       // 68
//              can be suspended. After some amount of time, the user will be completely deleted                       // 69
//              and removed from the DB.                                                                               // 70
//              It is an object with fields:                                                                           // 71
//                voluntary: Boolean. This is true if the user initiated it. They will have the                        // 72
//                  chance to still login and reverse the suspension/deletion.                                         // 73
//                admin: The userId of the admin who suspended the account.                                            // 74
//                timestamp: Date object. When the suspension occurred.                                                // 75
//                willDelete: Boolean. If true, this account will be deleted after some time.                          // 76
//                                                                                                                     // 77
// Identity users additionally contain the following fields:                                                           // 78
//   profile: Object containing the data that will be shared with users and grains that come into                      // 79
//            contact with this identity. Includes the following fields:                                               // 80
//       service: String containing the name of this identity's authentication method.                                 // 81
//       name: String containing the chosen display name of the identity.                                              // 82
//       handle: String containing the identity's preferred handle.                                                    // 83
//       picture: _id into the StaticAssets table for the identity's picture. If not present,                          // 84
//                an identicon will be used.                                                                           // 85
//       pronoun: One of "male", "female", "neutral", or "robot".                                                      // 86
//   unverifiedEmail: If present, a string containing an email address specified by the user.                          // 87
//   referredBy: ID of the Account that referred this Identity.                                                        // 88
//                                                                                                                     // 89
// Account users additionally contain the following fields:                                                            // 90
//   loginIdentities: Array of identity objects, each of which may include the following fields.                       // 91
//       id: The globally-stable SHA-256 ID of this identity, hex-encoded.                                             // 92
//   nonloginIdentities: Array of identity objects, of the same form as `loginIdentities`. We use                      // 93
//                       a separate array here so that we can use a Mongo index to enforce the                         // 94
//                       invariant that an identity only be a login identity for a single account.                     // 95
//   primaryEmail: String containing this account's primary email address. Must be a verified adress                   // 96
//                 of one of this account's linked identities. Call SandstormDb.getUserEmails()                        // 97
//                 to do this checking automatically.                                                                  // 98
//   isAdmin: Boolean indicating whether this account is allowed to access the Sandstorm admin panel.                  // 99
//   signupKey: If this is an invited user, then this field contains their signup key.                                 // 100
//   signupNote: If the user was invited through a link, then this field contains the note that the                    // 101
//               inviter admin attached to the key.                                                                    // 102
//   signupEmail: If the user was invited by email, then this field contains the email address that                    // 103
//                the invite was sent to.                                                                              // 104
//   hasCompletedSignup: True if this account has confirmed its profile and agreed to this server's                    // 105
//                       terms of service.                                                                             // 106
//   plan: _id of an entry in the Plans table which determines the user's quota.                                       // 107
//   planBonus: {storage, compute, grains} bonus amounts to add to the user's plan. The payments                       // 108
//              module writes data here; we merely read it. Missing fields should be treated as                        // 109
//              zeroes. Does not yet include referral bonus, which is calculated separately.                           // 110
//              TODO(cleanup): Use for referral bonus too.                                                             // 111
//   storageUsage: Number of bytes this user is currently storing.                                                     // 112
//   payments: Object defined by payments module, if loaded.                                                           // 113
//   dailySentMailCount: Number of emails sent by this user today; used to limit spam.                                 // 114
//   accessRequests: Object containing the following fields; used to limit spam.                                       // 115
//       count: Number of "request access" emails during sent during the current interval.                             // 116
//       resetOn: Date when the count should be reset.                                                                 // 117
//   referredByComplete: ID of the Account that referred this Account. If this is set, we                              // 118
//                        stop writing new referredBy values onto Identities for this account.                         // 119
//   referredCompleteDate: The Date at which the completed referral occurred.                                          // 120
//   referredIdentityIds: List of Identity IDs that this Account has referred. This is used for                        // 121
//                        reliably determining which Identity's names are safe to display.                             // 122
//   experiments: Object where each field is an experiment that the user is in, and each value                         // 123
//           is the parameters for that experiment. Typically, the value simply names which                            // 124
//           experiment group which the user is in, where "control" is one group. If an experiment                     // 125
//           is not listed, then the user should not be considered at all for the purpose of that                      // 126
//           experiment. Each experiment may define a point in time where users not already in the                     // 127
//           experiment may be added to it and assigned to a group (for example, at user creation                      // 128
//           time). Current experiments:                                                                               // 129
//       firstTimeBillingPrompt: OBSOLETE                                                                              // 130
//       freeGrainLimit: Value is "control" or or a number indicating the grain limit that the                         // 131
//               user should receive when on the "free" plan, e.g. "Infinity".                                         // 132
//   stashedOldUser: A complete copy of this user from before the accounts/identities migration.                       // 133
//                   TODO(cleanup): Delete this field once we're sure it's safe to do so.                              // 134
                                                                                                                       //
Meteor.users.ensureIndexOnServer("services.google.email", {                                                            // 136
  sparse: 1                                                                                                            // 136
});                                                                                                                    // 136
Meteor.users.ensureIndexOnServer("services.github.emails.email", {                                                     // 137
  sparse: 1                                                                                                            // 137
});                                                                                                                    // 137
Meteor.users.ensureIndexOnServer("services.email.email", {                                                             // 138
  unique: 1,                                                                                                           // 138
  sparse: 1                                                                                                            // 138
});                                                                                                                    // 138
Meteor.users.ensureIndexOnServer("loginIdentities.id", {                                                               // 139
  unique: 1,                                                                                                           // 139
  sparse: 1                                                                                                            // 139
});                                                                                                                    // 139
Meteor.users.ensureIndexOnServer("nonloginIdentities.id", {                                                            // 140
  sparse: 1                                                                                                            // 140
});                                                                                                                    // 140
Meteor.users.ensureIndexOnServer("services.google.id", {                                                               // 141
  unique: 1,                                                                                                           // 141
  sparse: 1                                                                                                            // 141
});                                                                                                                    // 141
Meteor.users.ensureIndexOnServer("services.github.id", {                                                               // 142
  unique: 1,                                                                                                           // 142
  sparse: 1                                                                                                            // 142
});                                                                                                                    // 142
Meteor.users.ensureIndexOnServer("suspended.willDelete", {                                                             // 143
  sparse: 1                                                                                                            // 143
}); // TODO(cleanup): This index is obsolete; delete it.                                                               // 143
                                                                                                                       //
Meteor.users.ensureIndexOnServer("identities.id", {                                                                    // 146
  unique: 1,                                                                                                           // 146
  sparse: 1                                                                                                            // 146
});                                                                                                                    // 146
Packages = new Mongo.Collection("packages", collectionOptions); // Packages which are installed or downloading.        // 148
//                                                                                                                     // 150
// Each contains:                                                                                                      // 151
//   _id:  128-bit prefix of SHA-256 hash of spk file, hex-encoded.                                                    // 152
//   status:  String.  One of "download", "verify", "unpack", "analyze", "ready", "failed", "delete"                   // 153
//   progress:  Float.  -1 = N/A, 0-1 = fractional progress (e.g. download percentage),                                // 154
//       >1 = download byte count.                                                                                     // 155
//   error:  If status is "failed", error message string.                                                              // 156
//   manifest:  If status is "ready", the package manifest.  See "Manifest" in package.capnp.                          // 157
//   appId:  If status is "ready", the application ID string.  Packages representing different                         // 158
//       versions of the same app have the same appId.  The spk tool defines the app ID format                         // 159
//       and can cryptographically verify that a package belongs to a particular app ID.                               // 160
//   shouldCleanup:  If true, a reference to this package was recently dropped, and the package                        // 161
//       collector should at some point check whether there are any other references and, if not,                      // 162
//       delete the package.                                                                                           // 163
//   url:  When status is "download", the URL from which the SPK can be obtained, if provided.                         // 164
//   isAutoUpdated: This package was downloaded as part of an auto-update. We shouldn't clean it up                    // 165
//     even if it has no users.                                                                                        // 166
//   authorPgpKeyFingerprint: Verified PGP key fingerprint (SHA-1, hex, all-caps) of the app                           // 167
//     packager.                                                                                                       // 168
                                                                                                                       //
DevPackages = new Mongo.Collection("devpackages", collectionOptions); // List of packages currently made available via the dev tools running on the local machine.
// This is normally empty; the only time it is non-empty is when a developer is using the spk tool                     // 172
// on the local machine to publish an under-development app to this server. That should only ever                      // 173
// happen on developers' desktop machines.                                                                             // 174
//                                                                                                                     // 175
// While a dev package is published, it automatically appears as installed by every user of the                        // 176
// server, and it overrides all packages with the same application ID. If any instances of those                       // 177
// packages are currently open, they are killed and reset on publish.                                                  // 178
//                                                                                                                     // 179
// When the dev tool disconnects, the package is automatically unpublished, and any open instances                     // 180
// are again killed and refreshed.                                                                                     // 181
//                                                                                                                     // 182
// Each contains:                                                                                                      // 183
//   _id:  The package ID string (as with Packages._id).                                                               // 184
//   appId: The app ID this package is intended to override (as with Packages.appId).                                  // 185
//   timestamp:  Time when the package was last updated. If this changes while the package is                          // 186
//     published, all running instances are reset. This is used e.g. to reset the app each time                        // 187
//     changes are made to the source code.                                                                            // 188
//   manifest:  The app's manifest, as with Packages.manifest.                                                         // 189
//   mountProc: True if the supervisor should mount /proc.                                                             // 190
                                                                                                                       //
UserActions = new Mongo.Collection("userActions", collectionOptions); // List of actions that each user has installed which create new grains.  Each app may install
// some number of actions (usually, one).                                                                              // 194
//                                                                                                                     // 195
// Each contains:                                                                                                      // 196
//   _id:  random                                                                                                      // 197
//   userId:  Account ID of the user who has installed this action.                                                    // 198
//   packageId:  Package used to run this action.                                                                      // 199
//   appId:  Same as Packages.findOne(packageId).appId; denormalized for searchability.                                // 200
//   appTitle:  Same as Packages.findOne(packageId).manifest.appTitle; denormalized so                                 // 201
//       that clients can access it without subscribing to the Packages collection.                                    // 202
//   appVersion:  Same as Packages.findOne(packageId).manifest.appVersion; denormalized for                            // 203
//       searchability.                                                                                                // 204
//   appMarketingVersion:  Human-readable presentation of the app version, e.g. "2.9.17"                               // 205
//   title: JSON-encoded LocalizedText title for this action, e.g.                                                     // 206
//       `{defaultText: "New Spreadsheet"}`.                                                                           // 207
//   nounPhrase: JSON-encoded LocalizedText describing what is created when this action is run.                        // 208
//   command:  Manifest.Command to run this action (see package.capnp).                                                // 209
                                                                                                                       //
Grains = new Mongo.Collection("grains", collectionOptions); // Grains belonging to users.                              // 211
//                                                                                                                     // 213
// Each contains:                                                                                                      // 214
//   _id:  random                                                                                                      // 215
//   packageId:  _id of the package of which this grain is an instance.                                                // 216
//   packageSalt: If present, a random string that will used in session ID generation. This field                      // 217
//       is usually updated when `packageId` is updated, triggering automatic refreshes for                            // 218
//       clients with active sessions.                                                                                 // 219
//   appId:  Same as Packages.findOne(packageId).appId; denormalized for searchability.                                // 220
//   appVersion:  Same as Packages.findOne(packageId).manifest.appVersion; denormalized for                            // 221
//       searchability.                                                                                                // 222
//   userId: The _id of the account that owns this grain.                                                              // 223
//   identityId: The identity with which the owning account prefers to open this grain.                                // 224
//   title:  Human-readable string title, as chosen by the user.                                                       // 225
//   lastUsed:  Date when the grain was last used by a user.                                                           // 226
//   private: If true, then knowledge of `_id` does not suffice to open this grain.                                    // 227
//   cachedViewInfo: The JSON-encoded result of `UiView.getViewInfo()`, cached from the most recent                    // 228
//                   time a session to this grain was opened.                                                          // 229
//   trashed: If present, the Date when this grain was moved to the trash bin. Thirty days after                       // 230
//            this date, the grain will be automatically deleted.                                                      // 231
//   suspended: If true, the owner of this grain has been suspended. They will soon be deleted,                        // 232
//              so treat this grain the same as "trashed". It is denormalized out of Users for ease                    // 233
//              of querying.                                                                                           // 234
//   ownerSeenAllActivity: True if the owner has viewed the grain since the last activity event                        // 235
//       occurred. See also ApiTokenOwner.user.seenAllActivity.                                                        // 236
//   size: On-disk size of the grain in bytes.                                                                         // 237
//                                                                                                                     // 238
// The following fields *might* also exist. These are temporary hacks used to implement e-mail and                     // 239
// web publishing functionality without powerbox support; they will be replaced once the powerbox                      // 240
// is implemented.                                                                                                     // 241
//   publicId:  An id used to publicly identify this grain. Used e.g. to route incoming e-mail and                     // 242
//       web publishing. This field is initialized when first requested by the app.                                    // 243
                                                                                                                       //
Grains.ensureIndexOnServer("cachedViewInfo.matchRequests.tags.id", {                                                   // 245
  sparse: 1                                                                                                            // 245
});                                                                                                                    // 245
RoleAssignments = new Mongo.Collection("roleAssignments", collectionOptions); // *OBSOLETE* Before `user` was a variant of ApiTokenOwner, this collection was used to store edges
// in the permissions sharing graph. This functionality has been subsumed by the ApiTokens                             // 249
// collection.                                                                                                         // 250
                                                                                                                       //
Contacts = new Mongo.Collection("contacts", collectionOptions); // Edges in the social graph.                          // 252
//                                                                                                                     // 254
// If Alice has Bob as a contact, then she is allowed to see Bob's profile information and Bob                         // 255
// will show up in her user-picker UI for actions like share-by-identity.                                              // 256
//                                                                                                                     // 257
// Contacts are not symmetric. Bob might be one of Alice's contacts even if Alice is not one of                        // 258
// Bob's.                                                                                                              // 259
//                                                                                                                     // 260
// Each contains:                                                                                                      // 261
//   _id: random                                                                                                       // 262
//   ownerId: The accountId of the user account who owns this contact.                                                 // 263
//   petname: Human-readable label chosen by and only visible to the owner. Uniquely identifies                        // 264
//            the contact to the owner.                                                                                // 265
//   created: Date when this contact was created.                                                                      // 266
//   identityId: The `_id` of the user whose contact info this contains.                                               // 267
                                                                                                                       //
Sessions = new Mongo.Collection("sessions", collectionOptions); // UI sessions open to particular grains.  A new session is created each time a user opens a grain.
//                                                                                                                     // 271
// Each contains:                                                                                                      // 272
//   _id:  String generated as a SHA256 hash of the grain ID, the user ID, a salt generated by the                     // 273
//       client, and the grain's `packageSalt`.                                                                        // 274
//   grainId:  _id of the grain to which this session is connected.                                                    // 275
//   hostId: ID part of the hostname from which this grain is being served. I.e. this replaces the                     // 276
//       '*' in WILDCARD_HOST.                                                                                         // 277
//   tabId: Random value unique to the grain tab in which this session is displayed. Typically                         // 278
//       every session has a different `tabId`, but embedded sessions (including in the powerbox)                      // 279
//       have the same `tabId` as the outer session.                                                                   // 280
//   timestamp:  Time of last keep-alive message to this session.  Sessions time out after some                        // 281
//       period.                                                                                                       // 282
//   userId:  Account ID of the user who owns this session.                                                            // 283
//   identityId:  Identity ID of the user who owns this session.                                                       // 284
//   hashedToken: If the session is owned by an anonymous user, the _id of the entry in ApiTokens                      // 285
//       that was used to open it. Note that for old-style sharing (i.e. when !grain.private),                         // 286
//       anonymous users can get access without an API token and so neither userId nor hashedToken                     // 287
//       are present.                                                                                                  // 288
//   powerboxView: Information about a server-initiated powerbox interaction taking place in this                      // 289
//       session. When the client sees a `powerboxView` appear on the session, it opens the                            // 290
//       powerbox popup according to the contents. This field is an object containing one of:                          // 291
//     offer: A capability is being offered to the user by the app. This is an object containing:                      // 292
//       token: For a non-UiView capability, the API token that can be used to restore this                            // 293
//           capability.                                                                                               // 294
//       uiView: A UiView capability. This object contains one of:                                                     // 295
//         tokenId: The _id of an ApiToken belonging to the current user.                                              // 296
//         token: A full webkey token which can be opened by an anonymous user.                                        // 297
//     fulfill: A capability is being offered which fulfills the active powerbox request. This                         // 298
//         is an object with members:                                                                                  // 299
//       token: The SturdyRef of the fulfilling capability. This token can only be used in a call                      // 300
//           to claimRequest() by the requesting                                                                       // 301
//           grain.                                                                                                    // 302
//       descriptor: Packed-base64 PowerboxDescriptor for the capability.                                              // 303
//   powerboxRequest: If present, this session is a powerbox request session. Object containing:                       // 304
//     descriptors: Array of PowerboxDescriptors representing the request.                                             // 305
//     requestingSession: Session ID of the session initiating the request.                                            // 306
//   viewInfo: The UiView.ViewInfo corresponding to the underlying UiSession. This isn't populated                     // 307
//       until newSession is called on the UiView.                                                                     // 308
//   permissions: The permissions for the current identity on this UiView. This isn't populated                        // 309
//       until newSession is called on the UiView.                                                                     // 310
//   hasLoaded: Marked as true by the proxy when the underlying UiSession has responded to its first                   // 311
//       request                                                                                                       // 312
                                                                                                                       //
SignupKeys = new Mongo.Collection("signupKeys", collectionOptions); // Invite keys which may be used by users to get access to Sandstorm.
//                                                                                                                     // 316
// Each contains:                                                                                                      // 317
//   _id:  random                                                                                                      // 318
//   used:  Boolean indicating whether this key has already been consumed.                                             // 319
//   note:  Text note assigned when creating key, to keep track of e.g. whom the key was for.                          // 320
//   email: If this key was sent as an email invite, the email address to which it was sent.                           // 321
                                                                                                                       //
ActivityStats = new Mongo.Collection("activityStats", collectionOptions); // Contains usage statistics taken on a regular interval. Each entry is a data point.
//                                                                                                                     // 325
// Each contains:                                                                                                      // 326
//   timestamp: Date when measurements were taken.                                                                     // 327
//   daily: Contains stats counts pertaining to the last day before the sample time.                                   // 328
//   weekly: Contains stats counts pertaining to the last seven days before the sample time.                           // 329
//   monthly: Contains stats counts pertaining to the last thirty days before the timestamp.                           // 330
//                                                                                                                     // 331
// Each of daily, weekly, and monthly contains:                                                                        // 332
//   activeUsers: The number of unique users who have used a grain on the server in the time                           // 333
//       interval. Only counts logged-in users.                                                                        // 334
//   demoUsers: Demo users.                                                                                            // 335
//   appDemoUsers: Users that came in through "app demo".                                                              // 336
//   activeGrains: The number of unique grains that have been used in the time interval.                               // 337
//   apps: An object indexed by app ID recording, for each app:                                                        // 338
//       owners: Number of unique owners of this app (counting only grains that still exist).                          // 339
//       sharedUsers: Number of users who have accessed other people's grains of this app (counting                    // 340
//         only grains that still exist).                                                                              // 341
//       grains: Number of active grains of this app (that still exist).                                               // 342
//       deleted: Number of non-demo grains of this app that were deleted.                                             // 343
//       demoed: Number of demo grains created and expired.                                                            // 344
//       appDemoUsers: Number of app demos initiated with this app.                                                    // 345
                                                                                                                       //
DeleteStats = new Mongo.Collection("deleteStats", collectionOptions); // Contains records of objects that were deleted, for stat-keeping purposes.
//                                                                                                                     // 349
// Each contains:                                                                                                      // 350
//   type: "grain" or "user" or "demoGrain" or "demoUser" or "appDemoUser"                                             // 351
//   lastActive: Date of the user's or grain's last activity.                                                          // 352
//   appId: For type = "grain", the app ID of the grain. For type = "appDemoUser", the app ID they                     // 353
//     arrived to demo. For others, undefined.                                                                         // 354
//   experiments: The experiments the user (or owner of the grain) was in. See user.experiments.                       // 355
                                                                                                                       //
FileTokens = new Mongo.Collection("fileTokens", collectionOptions); // Tokens corresponding to backup files that are currently stored on the server. A user receives
// a token when they create a backup file (either by uploading it, or by backing up one of their                       // 359
// grains) and may use the token to read the file (either to download it, or to restore a new                          // 360
// grain from it).                                                                                                     // 361
//                                                                                                                     // 362
// Each contains:                                                                                                      // 363
//   _id:       The unguessable token string.                                                                          // 364
//   name:      Suggested filename.                                                                                    // 365
//   timestamp: File creation time. Used to figure out when the token and file should be wiped.                        // 366
                                                                                                                       //
SpkTokens = new Mongo.Collection("spkTokens", collectionOptions); // A lot like FileTokens, but for SPK uploads.       // 368
//                                                                                                                     // 370
// Each contains:                                                                                                      // 371
//   _id:       The unguessable token string.                                                                          // 372
//   timestamp: Creation time. Used to figure out when the token should be wiped.                                      // 373
                                                                                                                       //
ApiTokens = new Mongo.Collection("apiTokens", collectionOptions); // Access tokens for APIs exported by apps.          // 375
//                                                                                                                     // 377
// Originally API tokens were only used by external users through the HTTP API endpoint. However,                      // 378
// now they are also used to implement SturdyRefs, not just held by external users, but also when                      // 379
// an app holds a SturdyRef to another app within the same server. See the various `save()`,                           // 380
// `restore()`, and `drop()` methods in `grain.capnp` (on `SandstormApi`, `AppPersistent`, and                         // 381
// `MainView`) -- the fields of type `Data` are API tokens.                                                            // 382
//                                                                                                                     // 383
// Each contains:                                                                                                      // 384
//   _id:       A SHA-256 hash of the token, base64-encoded.                                                           // 385
//   grainId:   The grain servicing this API. (Not present if the API isn't serviced by a grain.)                      // 386
//   identityId: For UiView capabilities, this is the identity for which the view is attenuated.                       // 387
//              That is, the UiView's newSession() method will intersect the requested permissions                     // 388
//              with this identity's permissions before forwarding on to the underlying app. If                        // 389
//              `identityId` is not present, then no identity attenuation is applied, i.e. this is                     // 390
//              a raw UiView as implemented by the app. (The `roleAssignment` field, below, may                        // 391
//              still apply. For non-UiView capabilities, `identityId` is never present. Note that                     // 392
//              this is NOT the identity against which the `requiredPermissions` parameter of                          // 393
//              `SandstormApi.restore()` is checked; that would be `owner.grain.introducerIdentity`.                   // 394
//   accountId: For tokens where `identityId` is set, the `_id` (in the Users table) of the account                    // 395
//              that created the token.                                                                                // 396
//   roleAssignment: If this API token represents a UiView, this field contains a JSON-encoded                         // 397
//              Grain.ViewSharingLink.RoleAssignment representing the permissions it carries. These                    // 398
//              permissions will be intersected with those held by `identityId` when the view is                       // 399
//              opened.                                                                                                // 400
//   forSharing: If true, requests sent to the HTTP API endpoint with this token will be treated as                    // 401
//              anonymous rather than as directly associated with `identityId`. This has no effect                     // 402
//              on the permissions granted.                                                                            // 403
//   objectId:  If present, this token represents an arbitrary Cap'n Proto capability exported by                      // 404
//              the app or its supervisor (whereas without this it strictly represents UiView).                        // 405
//              sturdyRef is the JSON-encoded SupervisorObjectId (defined in `supervisor.capnp`).                      // 406
//              Note that if the SupervisorObjectId contains an AppObjectId, that field is                             // 407
//              treated as type AnyPointer, and so encoded as a raw Cap'n Proto message.                               // 408
//   frontendRef: If present, this token actually refers to an object implemented by the front-end,                    // 409
//              not a particular grain. (`grainId` and `identityId` are not set.) This is an object                    // 410
//              containing exactly one of the following fields:                                                        // 411
//       notificationHandle: A `Handle` for an ongoing notification, as returned by                                    // 412
//                           `NotificationTarget.addOngoing`. The value is an `_id` from the                           // 413
//                           `Notifications` collection.                                                               // 414
//       ipNetwork: An IpNetwork capability that is implemented by the frontend. Eventually, this                      // 415
//                  will be moved out of the frontend and into the backend, but we'll migrate the                      // 416
//                  database when that happens. This field contains the boolean true to signify that                   // 417
//                  it has been set.                                                                                   // 418
//       ipInterface: Ditto IpNetwork, except it's an IpInterface.                                                     // 419
//       emailVerifier: An EmailVerifier capability that is implemented by the frontend. The                           // 420
//                      value is an object containing the fields `id` and `services`. `id` is the                      // 421
//                      value returned by `EmailVerifier.getId()` and is used as part of a                             // 422
//                      powerbox query for matching verified emails. `services` is a                                   // 423
//                      list of names of identity providers that are trusted to verify addresses.                      // 424
//                      If `services` is omitted or falsy, all configured identity providers are                       // 425
//                      trusted. Note that a malicious user could specify invalid names in the                         // 426
//                      list; they should be ignored.                                                                  // 427
//       verifiedEmail: An VerifiedEmail capability that is implemented by the frontend.                               // 428
//                      An object containing `verifierId`, `tabId`, and `address`.                                     // 429
//       identity: An Identity capability. The field is the identity ID.                                               // 430
//       http: An ApiSession capability pointing to an external HTTP service. Object containing:                       // 431
//           url: Base URL of the external service.                                                                    // 432
//           auth: Authentication mechanism. Object containing one of:                                                 // 433
//               none: Value "null". Indicates no authorization.                                                       // 434
//               bearer: A bearer token to pass in the `Authorization: Bearer` header on all                           // 435
//                   requests. Encrypted with nonce 0.                                                                 // 436
//               basic: A `{username, password}` object. The password is encrypted with nonce 0.                       // 437
//                   Before encryption, the password is padded to 32 bytes by appending NUL bytes,                     // 438
//                   in order to mask the length of small passwords.                                                   // 439
//               refresh: An OAuth refresh token, which can be exchanged for an access token.                          // 440
//                   Encrypted with nonce 0.                                                                           // 441
//               TODO(security): How do we protect URLs that directly embed their secret? We don't                     // 442
//                   want to encrypt the full URL since this would make it hard to show a                              // 443
//                   meaningful audit UI, but maybe we could figure out a way to extract the key                       // 444
//                   part and encrypt it separately?                                                                   // 445
//   parentToken: If present, then this token represents exactly the capability represented by                         // 446
//              the ApiToken with _id = parentToken, except possibly (if it is a UiView) attenuated                    // 447
//              by `roleAssignment` (if present). To facilitate permissions computations, if the                       // 448
//              capability is a UiView, then `grainId` is set to the backing grain, `identityId`                       // 449
//              is set to the identity that shared the view, and `accountId` is set to the account                     // 450
//              that shared the view. Neither `objectId` nor `frontendRef` is present when                             // 451
//              `parentToken` is present.                                                                              // 452
//   parentTokenKey: The actual parent token -- whereas `parentToken` is only the parent token ID                      // 453
//              (hash). `parentTokenFull` is encrypted with nonce 0 (see below). This is needed                        // 454
//              in particular when the parent contains encrypted fields, since those would need to                     // 455
//              be decrypted using this key. If the parent contains no encrypted fields then                           // 456
//              `parentTokenKey` may be omitted from the child.                                                        // 457
//   petname:   Human-readable label for this access token, useful for identifying tokens for                          // 458
//              revocation. This should be displayed when visualizing incoming capabilities to                         // 459
//              the grain identified by `grainId`.                                                                     // 460
//   created:   Date when this token was created.                                                                      // 461
//   revoked:   If true, then this sturdyref has been revoked and can no longer be restored. It may                    // 462
//              become un-revoked in the future.                                                                       // 463
//   trashed:   If present, the Date when this token was moved to the trash bin. Thirty days after                     // 464
//              this date, the token will be automatically deleted.                                                    // 465
//   suspended: If true, the owner of this token has been suspended. They will soon be deleted,                        // 466
//              so treat this token the same as "trashed". It is denormalized out of Users for                         // 467
//              ease of querying.                                                                                      // 468
//   expires:   Optional expiration Date. If undefined, the token does not expire.                                     // 469
//   lastUsed:  Optional Date when this token was last used.                                                           // 470
//   owner:     A `ApiTokenOwner` (defined in `supervisor.capnp`, stored as a JSON object)                             // 471
//              as passed to the `save()` call that created this token. If not present, treat                          // 472
//              as `webkey` (the default for `ApiTokenOwner`).                                                         // 473
//   expiresIfUnused:                                                                                                  // 474
//              Optional Date after which the token, if it has not been used yet, expires.                             // 475
//              This field should be cleared on a token's first use.                                                   // 476
//   requirements: List of conditions which must hold for this token to be considered valid.                           // 477
//              Semantically, this list specifies the powers which were *used* to originally                           // 478
//              create the token. If any condition in the list becomes untrue, then the token must                     // 479
//              be considered revoked, and all live refs and sturdy refs obtained transitively                         // 480
//              through it must also become revoked. Each item is the JSON serialization of the                        // 481
//              `MembraneRequirement` structure defined in `supervisor.capnp`.                                         // 482
//   hasApiHost: If true, there is an entry in ApiHosts for this token, which will need to be                          // 483
//              cleaned up when the token is.                                                                          // 484
//                                                                                                                     // 485
// It is important to note that a token's owner and provider are independent from each other. To                       // 486
// illustrate, here is an approximate definition of ApiToken in pseudo Cap'n Proto schema language:                    // 487
//                                                                                                                     // 488
// struct ApiToken {                                                                                                   // 489
//   owner :ApiTokenOwner;                                                                                             // 490
//   provider :union {                                                                                                 // 491
//     grain :group {                                                                                                  // 492
//       grainId :Text;                                                                                                // 493
//       union {                                                                                                       // 494
//         uiView :group {                                                                                             // 495
//           identityId :Text;                                                                                         // 496
//           roleAssignment :RoleAssignment;                                                                           // 497
//           forSharing :Bool;                                                                                         // 498
//         }                                                                                                           // 499
//         objectId :SupervisorObjectId;                                                                               // 500
//       }                                                                                                             // 501
//     }                                                                                                               // 502
//     frontendRef :union {                                                                                            // 503
//       notificationHandle :Text;                                                                                     // 504
//       ipNetwork :Bool;                                                                                              // 505
//       ipInterface :Bool;                                                                                            // 506
//       emailVerifier :group {                                                                                        // 507
//         id :Text;                                                                                                   // 508
//         services :List(String);                                                                                     // 509
//       }                                                                                                             // 510
//       verifiedEmail :group {                                                                                        // 511
//         verifierId :Text;                                                                                           // 512
//         tabId :Text;                                                                                                // 513
//         address :Text;                                                                                              // 514
//       }                                                                                                             // 515
//       identity :Text;                                                                                               // 516
//       http :group {                                                                                                 // 517
//         url :Text;                                                                                                  // 518
//         auth :union {                                                                                               // 519
//           none :Void;                                                                                               // 520
//           bearer :Text;                                                                                             // 521
//           basic :group { username :Text; password :Text; }                                                          // 522
//           refresh :Text;                                                                                            // 523
//         }                                                                                                           // 524
//       }                                                                                                             // 525
//     }                                                                                                               // 526
//     child :group {                                                                                                  // 527
//       parentToken :Text;                                                                                            // 528
//       union {                                                                                                       // 529
//         uiView :group {                                                                                             // 530
//           grainId :Text;                                                                                            // 531
//           identityId :Text;                                                                                         // 532
//           roleAssignment :RoleAssignment = (allAccess = ());                                                        // 533
//         }                                                                                                           // 534
//         other :Void;                                                                                                // 535
//       }                                                                                                             // 536
//     }                                                                                                               // 537
//   }                                                                                                                 // 538
//   requirements: List(Supervisor.MembraneRequirement);                                                               // 539
//   ...                                                                                                               // 540
// }                                                                                                                   // 541
//                                                                                                                     // 542
// ENCRYPTION                                                                                                          // 543
//                                                                                                                     // 544
// We want to make sure that someone who obtains a copy of the database cannot use it to gain live                     // 545
// credentials.                                                                                                        // 546
//                                                                                                                     // 547
// The actual token corresponding to an ApiToken entry is not stored in the entry itself. Instead,                     // 548
// the ApiToken's `_id` is constructed as a SHA256 hash of the actual token. To use an ApiToken                        // 549
// in the live system, you must present the original token.                                                            // 550
//                                                                                                                     // 551
// Additionally, some ApiToken entries contain tokens to third-party services, e.g. OAuth tokens                       // 552
// or even passwords. Such tokens are encrypted, using the ApiToken entry's own full token (which,                     // 553
// again, is not stored in the database) as the encryption key.                                                        // 554
//                                                                                                                     // 555
// When such encryption is applied, the cipher used is ChaCha20. All API tokens are 256-bit base64                     // 556
// strings, hence can be used directly as the key. No MAC is applied, because this scheme is not                       // 557
// intended to protect against attackers who have write access to the database -- such an attacker                     // 558
// could almost certainly do more damage by modifying the non-encrypted fields anyway. (Put another                    // 559
// way, if we wanted to MAC something, we'd need to MAC the entire ApiToken structure, not just                        // 560
// the encrypted key. But we don't have a way to do that at present.)                                                  // 561
//                                                                                                                     // 562
// ChaCha20 requires a nonce. Luckily, all of the fields we wish to encrypt are immutable, so we                       // 563
// don't have to worry about tracking nonces over time -- we can just assign a static nonce to each                    // 564
// field. Moreover, many (currently, all) of these fields are mutually exclusive, so can even share                    // 565
// nonces. Currently, nonces map to fields as follows:                                                                 // 566
//                                                                                                                     // 567
// nonce 0:                                                                                                            // 568
//     parentTokenKey                                                                                                  // 569
//     frontendRef.http.auth.basic.password                                                                            // 570
//     frontendRef.http.auth.bearer                                                                                    // 571
//     frontendRef.http.auth.refresh                                                                                   // 572
                                                                                                                       //
ApiTokens.ensureIndexOnServer("grainId", {                                                                             // 574
  sparse: 1                                                                                                            // 574
});                                                                                                                    // 574
ApiTokens.ensureIndexOnServer("owner.user.identityId", {                                                               // 575
  sparse: 1                                                                                                            // 575
});                                                                                                                    // 575
ApiTokens.ensureIndexOnServer("frontendRef.emailVerifier.id", {                                                        // 576
  sparse: 1                                                                                                            // 576
});                                                                                                                    // 576
ApiHosts = new Mongo.Collection("apiHosts", collectionOptions); // Allows defining some limited static behavior for an API host when accessed unauthenticated. This
// mainly exists to allow backwards-compatibility with client applications that expect to be able                      // 580
// to probe an API host without authentication to determine capabilities such as DAV protocols                         // 581
// supported, before authenticating to perform real requests. An app can specify these properties                      // 582
// when creating an offerTemplate.                                                                                     // 583
//                                                                                                                     // 584
// Each contains:                                                                                                      // 585
//   _id:          apiHostIdHashForToken() of the corresponding API token.                                             // 586
//   hash2:        hash(hash(token)), aka hash(ApiToken._id). Used to allow ApiHosts to be cleaned                     // 587
//                 up when ApiTokens are deleted.                                                                      // 588
//   options:      Specifies how to respond to unauthenticated OPTIONS requests on this host.                          // 589
//                 This is an object containing fields:                                                                // 590
//     dav:        List of strings specifying DAV header `compliance-class`es, e.g. "1" or                             // 591
//                 "calendar-access". https://tools.ietf.org/html/rfc4918#section-10.1                                 // 592
//   resources:    Object mapping URL paths (including initial '/') to static HTTP responses to                        // 593
//                 give when those paths are accessed unauthenticated. Due to Mongo disliking '.'                      // 594
//                 and '$' in keys, these characters must be escaped as '\uFF0E' and '\uFF04'                          // 595
//                 (see SandstormDb.escapeMongoKey). Each value in this map is an object with                          // 596
//                 fields:                                                                                             // 597
//     type:       Content-Type.                                                                                       // 598
//     language:   Content-Language.                                                                                   // 599
//     encoding:   Content-Encoding.                                                                                   // 600
//     body:       Entity-body as a string or buffer.                                                                  // 601
                                                                                                                       //
Notifications = new Mongo.Collection("notifications", collectionOptions); // Notifications for a user.                 // 603
//                                                                                                                     // 605
// Each contains:                                                                                                      // 606
//   _id:          random                                                                                              // 607
//   grainId:      The grain originating this notification, if any.                                                    // 608
//   userId:       Account ID of the user receiving the notification.                                                  // 609
//   text:         The JSON-ified LocalizedText to display in the notification.                                        // 610
//   isUnread:     Boolean indicating if this notification is unread.                                                  // 611
//   timestamp:    Date when this notification was last updated                                                        // 612
//   eventType:    If this notification is due to an activity event, this is the numeric index                         // 613
//                 of the event type on the grain's ViewInfo.                                                          // 614
//   count:        The number of times this exact event has repeated. Identical events are                             // 615
//                 aggregated by incrementing the count.                                                               // 616
//   initiatingIdentity: Identity ID of the user who initiated this notification.                                      // 617
//   initiatorAnonymous: True if the initiator is an anonymous user. If neither this nor                               // 618
//                 initiatingIdentity is present, the notification is not from a user.                                 // 619
//   path:         Path inside the grain to which the user should be directed if they click on                         // 620
//                 the notification.                                                                                   // 621
//   ongoing:      If present, this is an ongoing notification, and this field contains an                             // 622
//                 ApiToken referencing the `OngoingNotification` capability.                                          // 623
//   admin:        If present, this is a notification intended for an admin.                                           // 624
//     action:     If present, this is a (string) link that the notification should direct the                         // 625
//                 admin to.                                                                                           // 626
//     type:       The type of notification -- currently can only be "reportStats".                                    // 627
//   appUpdates:   If present, this is an app update notification. It is an object with the appIds                     // 628
//                 as keys.                                                                                            // 629
//     $appId:     The appId that has an outstanding update.                                                           // 630
//       packageId: The packageId that it will update to.                                                              // 631
//       name: The name of the app. (appTitle from package.manifest)                                                   // 632
//       version: The app's version number. (appVersion from package.manifest)                                         // 633
//       marketingVersion: String marketing version of this app. (appMarketingVersion from package.manifest)           // 634
//   referral:     If this boolean field is true, then treat this notification as a referral                           // 635
//                 notification. This causes text to be ignored, since we need custom logic.                           // 636
//   mailingListBonus: Like `referral`, but notify the user about the mailing list bonus. This is                      // 637
//                 a one-time notification only to Oasis users who existed when the bonus program                      // 638
//                 was implemented.                                                                                    // 639
                                                                                                                       //
ActivitySubscriptions = new Mongo.Collection("activitySubscriptions", collectionOptions); // Activity events to which a user is subscribed.
//                                                                                                                     // 643
// Each contains:                                                                                                      // 644
//   _id:          random                                                                                              // 645
//   identityId:   Who is subscribed.                                                                                  // 646
//   grainId:      Grain to which subscription applies.                                                                // 647
//   threadPath:   If present, the subscription is on a specific thread. Otherwise, it is on the                       // 648
//                 whole grain.                                                                                        // 649
//   mute:         If true, this is an anti-subscription -- matching events should NOT notify.                         // 650
//                 This allows is useful to express:                                                                   // 651
//                 - A user wants to subscribe to a grain but mute a specific thread.                                  // 652
//                 - The owner of a grain does not want notifications (normally, they are                              // 653
//                   implicitly subscribed).                                                                           // 654
//                 - A user no longer wishes to be implicitly subscribed to threads in a grain on                      // 655
//                   which they comment, so they mute the grain.                                                       // 656
                                                                                                                       //
ActivitySubscriptions.ensureIndexOnServer("identityId");                                                               // 658
ActivitySubscriptions.ensureIndexOnServer({                                                                            // 659
  "grainId": 1,                                                                                                        // 659
  "threadPath": 1                                                                                                      // 659
});                                                                                                                    // 659
StatsTokens = new Mongo.Collection("statsTokens", collectionOptions); // Access tokens for the Stats collection        // 661
//                                                                                                                     // 663
// These tokens are used for accessing the ActivityStats collection remotely                                           // 664
// (ie. from a dashboard webapp)                                                                                       // 665
//                                                                                                                     // 666
// Each contains:                                                                                                      // 667
//   _id:       The token. At least 128 bits entropy (Random.id(22)).                                                  // 668
                                                                                                                       //
Misc = new Mongo.Collection("misc", collectionOptions); // Miscellaneous configuration and other settings              // 670
//                                                                                                                     // 672
// This table is currently only used for persisting BASE_URL from one session to the next,                             // 673
// but in general any miscellaneous settings should go in here                                                         // 674
//                                                                                                                     // 675
// Each contains:                                                                                                      // 676
//   _id:       The name of the setting. eg. "BASE_URL"                                                                // 677
//   value:     The value of the setting.                                                                              // 678
                                                                                                                       //
Settings = new Mongo.Collection("settings", collectionOptions); // Settings for this Sandstorm instance go here. They are configured through the adminSettings
// route. This collection differs from misc in that any admin user can update it through the admin                     // 682
// interface.                                                                                                          // 683
//                                                                                                                     // 684
// Each contains:                                                                                                      // 685
//   _id:       The name of the setting. eg. "smtpConfig"                                                              // 686
//   value:     The value of the setting.                                                                              // 687
//   automaticallyReset: Sometimes the server needs to automatically reset a setting. When it does                     // 688
//                       so, it will also write an object to this field indicating why the reset was                   // 689
//                       needed. That object can have the following variants:                                          // 690
//       baseUrlChangedFrom: The reset was due to BASE_URL changing. This field contains a string                      // 691
//                           with the old BASE_URL.                                                                    // 692
//   preinstalledApps: A list of objects:                                                                              // 693
//     appId: The Packages.appId of the app to install                                                                 // 694
//     status: packageId                                                                                               // 695
//     packageId: The Packages._id of the app to install                                                               // 696
//                                                                                                                     // 697
//   potentially other fields that are unique to the setting                                                           // 698
                                                                                                                       //
Migrations = new Mongo.Collection("migrations", collectionOptions); // This table tracks which migrations we have applied to this instance.
// It contains a single entry:                                                                                         // 702
//   _id:       "migrations_applied"                                                                                   // 703
//   value:     The number of migrations this instance has successfully completed.                                     // 704
                                                                                                                       //
StaticAssets = new Mongo.Collection("staticAssets", collectionOptions); // Collection of static assets served up from the Sandstorm server's "static" host. We only
// support relatively small assets: under 1MB each.                                                                    // 708
//                                                                                                                     // 709
// Each contains:                                                                                                      // 710
//   _id:       Random ID; will be used in the URL.                                                                    // 711
//   hash:      A base64-encoded SHA-256 hash of the data, used to de-dupe.                                            // 712
//   mimeType:  MIME type of the asset, suitable for Content-Type header.                                              // 713
//   encoding:  Either "gzip" or not present, suitable for Content-Encoding header.                                    // 714
//   content:   The asset content (byte buffer).                                                                       // 715
//   refcount:  Number of places where this asset's ID appears in the database. Since Mongo doesn't                    // 716
//       have transactions, this needs to bias towards over-counting; a backup GC could be used                        // 717
//       to catch leaked assets, although it's probably not a big deal in practice.                                    // 718
                                                                                                                       //
AssetUploadTokens = new Mongo.Collection("assetUploadTokens", collectionOptions); // Collection of tokens representing a single-use permission to upload an asset, such as a new
// profile picture.                                                                                                    // 722
//                                                                                                                     // 723
// Each contains:                                                                                                      // 724
//   _id:       Random ID.                                                                                             // 725
//   purpose:   Contains one of the following, indicating how the asset is to be used:                                 // 726
//       profilePicture: Indicates that the upload is a new profile picture. Contains fields:                          // 727
//           userId: Account ID of user whose picture shall be replaced.                                               // 728
//           identityId: Which of the user's identities shall be updated.                                              // 729
//   expires:   Time when this token will go away if unused.                                                           // 730
                                                                                                                       //
Plans = new Mongo.Collection("plans", collectionOptions); // Subscription plans, which determine quota.                // 732
//                                                                                                                     // 734
// Each contains:                                                                                                      // 735
//   _id: Plan ID, usually a short string like "free", "standard", "large", "mega", ...                                // 736
//   storage: Number of bytes this user is allowed to store.                                                           // 737
//   compute: Number of kilobyte-RAM-seconds this user is allowed to consume.                                          // 738
//   computeLabel: Label to display to the user describing this plan's compute units.                                  // 739
//   grains: Total number of grains this user can create (often `Infinity`).                                           // 740
//   price: Price per month in US cents.                                                                               // 741
//   hidden: If true, a user cannot switch to this plan, but some users may be on it and are                           // 742
//       allowed to switch away.                                                                                       // 743
//   title: Title from display purposes. If missing, default to capitalizing _id.                                      // 744
                                                                                                                       //
AppIndex = new Mongo.Collection("appIndex", collectionOptions); // A mirror of the data from the App Market index      // 746
//                                                                                                                     // 748
// Each contains:                                                                                                      // 749
//   _id: the appId of the app                                                                                         // 750
//  The rest of the fields are defined in src/sandstorm/app-index/app-index.capnp:AppIndexForMarket                    // 751
                                                                                                                       //
KeybaseProfiles = new Mongo.Collection("keybaseProfiles", collectionOptions); // Cache of Keybase profile information. The profile for a user is re-fetched every time a package
// by that user is installed, as well as if the keybase profile is requested and not already                           // 755
// present for some reason.                                                                                            // 756
//                                                                                                                     // 757
// Each contains:                                                                                                      // 758
//   _id: PGP key fingerprint (SHA-1, hex, all-caps)                                                                   // 759
//   displayName: Display name from Keybase. (NOT VERIFIED AT ALL.)                                                    // 760
//   handle: Keybase handle.                                                                                           // 761
//   proofs: The "proofs_summary.all" array from the Keybase lookup. See the non-existent Keybase                      // 762
//     docs for details. We also add a boolean "status" field to each proof indicating whether                         // 763
//     we have directly verified the proof ourselves. Its values may be "unverified" (Keybase                          // 764
//     returned this but we haven't checked it directly), "verified" (we verified the proof and it                     // 765
//     is valid), "invalid" (we checked the proof and it was definitely bogus), or "checking" (the                     // 766
//     server is currently actively checking this proof). Note that if a check fails due to network                    // 767
//     errors, the status goes back to "unverified".                                                                   // 768
//                                                                                                                     // 769
//     WARNING: Currently verification is NOT IMPLEMENTED, so all proofs will be "unverified"                          // 770
//       for now and we just trust Keybase.                                                                            // 771
                                                                                                                       //
FeatureKey = new Mongo.Collection("featureKey", collectionOptions); // OBSOLETE: This was used to implement the Sandstorm for Work paywall, which has been removed.
//   Collection object still defined because it could have old data in it, for servers that used                       // 775
//   to have a feature key.                                                                                            // 776
                                                                                                                       //
SetupSession = new Mongo.Collection("setupSession", collectionOptions); // Responsible for storing information about setup sessions.  Contains a single document with three
// keys:                                                                                                               // 780
//                                                                                                                     // 781
//   _id: "current-session"                                                                                            // 782
//   creationDate: Date object indicating when this session was created.                                               // 783
//   hashedSessionId: the sha256 of the secret session id that was returned to the client                              // 784
                                                                                                                       //
var DesktopNotifications = new Mongo.Collection("desktopNotifications", collectionOptions); // Responsible for very short-lived queueing of desktop notification information.
// Entries are removed when they are ~30 seconds old.  This collection is a bit                                        // 788
// odd in that it is intended primarily for edge-triggered communications, but                                         // 789
// Meteor's collections aren't really designed to support that organization.                                           // 790
// Fields for each :                                                                                                   // 791
//                                                                                                                     // 792
//   _id: String.  Used as the tag to coordinate notification merging between browser tabs.                            // 793
//   creationDate: Date object. indicating when this notification was posted.                                          // 794
//   userId: String. Account id to which this notification was published.                                              // 795
//   notificationId: String.  ID of the matching event in the Notifications table to dismiss if this                   // 796
//                            notification is activated.                                                               // 797
//   appActivity: Object with fields:                                                                                  // 798
//     user: Optional Object. Not present if this notification wasn't generated by a user. If                          // 799
//           present, it will have one of the following shapes:                                                        // 800
//       { anonymous: true } if this notification was generated by an anonymous user.  Otherwise:                      // 801
//       {                                                                                                             // 802
//         identityId: String  The user's identity ID.                                                                 // 803
//         name: String        The user's display name.                                                                // 804
//         avatarUrl: String   The URL for the user's profile picture.                                                 // 805
//       },                                                                                                            // 806
//     grainId: String,      Which grain this action took place on                                                     // 807
//     path: String,         The path of the notification.                                                             // 808
//     body: Util.LocalizedText,  The main body of the activity event.                                                 // 809
//     actionText: Util.LocalizedText, What action the user took, e.g.                                                 // 810
//                                     { defaultText: "added a comment" }                                              // 811
                                                                                                                       //
var StandaloneDomains = new Mongo.Collection("standaloneDomains", collectionOptions); // A standalone domain that points to a single share link. These domains act a little different
// than a normal shared Sandstorm grain. They completely drop any Sandstorm topbar/sidebar, and at                     // 815
// first glance look completely like a non-Sandstorm hosted webserver. The apps instead act in                         // 816
// concert with Sandstorm through the postMessage API, which allows it to do things like prompt for                    // 817
// login.                                                                                                              // 818
// Fields for each :                                                                                                   // 819
//                                                                                                                     // 820
//   _id: String. The domain name to use.                                                                              // 821
//   token: String. _id of a sharing token (it must be a webkey).                                                      // 822
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 824
  Meteor.publish("credentials", function () {                                                                          // 825
    // Data needed for isSignedUp() and isAdmin() to work.                                                             // 826
    if (this.userId) {                                                                                                 // 828
      var db = this.connection.sandstormDb;                                                                            // 829
      return [Meteor.users.find({                                                                                      // 830
        _id: this.userId                                                                                               // 831
      }, {                                                                                                             // 831
        fields: {                                                                                                      // 832
          signupKey: 1,                                                                                                // 832
          isAdmin: 1,                                                                                                  // 832
          expires: 1,                                                                                                  // 832
          storageUsage: 1,                                                                                             // 832
          plan: 1,                                                                                                     // 833
          planBonus: 1,                                                                                                // 833
          hasCompletedSignup: 1,                                                                                       // 833
          experiments: 1,                                                                                              // 833
          referredIdentityIds: 1,                                                                                      // 834
          cachedStorageQuota: 1,                                                                                       // 834
          suspended: 1                                                                                                 // 834
        }                                                                                                              // 832
      }), db.collections.plans.find()];                                                                                // 832
    } else {                                                                                                           // 837
      return [];                                                                                                       // 838
    }                                                                                                                  // 839
  });                                                                                                                  // 840
}                                                                                                                      // 841
                                                                                                                       //
var countReferrals = function (user) {                                                                                 // 843
  var referredIdentityIds = user.referredIdentityIds;                                                                  // 844
  return referredIdentityIds && referredIdentityIds.length || 0;                                                       // 845
};                                                                                                                     // 846
                                                                                                                       //
var calculateReferralBonus = function (user) {                                                                         // 848
  // This function returns an object of the form:                                                                      // 849
  //                                                                                                                   // 850
  // - {grains: 0, storage: 0}                                                                                         // 851
  //                                                                                                                   // 852
  // which are extra resources this account gets as part of participating in the referral                              // 853
  // program. (Storage is measured in bytes, as usual for plans.)                                                      // 854
  // TODO(cleanup): Consider moving referral bonus logic into Oasis payments module (since it's                        // 856
  //   payments-specific) and aggregating into `planBonus`.                                                            // 857
  // Authorization note: Only call this if accountId is the current user!                                              // 859
  var isPaid = user.plan && user.plan !== "free";                                                                      // 860
  successfulReferralsCount = countReferrals(user);                                                                     // 862
                                                                                                                       //
  if (isPaid) {                                                                                                        // 863
    var maxPaidStorageBonus = 30 * 1e9;                                                                                // 864
    return {                                                                                                           // 865
      grains: 0,                                                                                                       // 865
      storage: Math.min(successfulReferralsCount * 2 * 1e9, maxPaidStorageBonus)                                       // 866
    };                                                                                                                 // 865
  } else {                                                                                                             // 869
    var maxFreeStorageBonus = 2 * 1e9;                                                                                 // 870
    var bonus = {                                                                                                      // 871
      storage: Math.min(successfulReferralsCount * 50 * 1e6, maxFreeStorageBonus)                                      // 872
    };                                                                                                                 // 871
                                                                                                                       //
    if (successfulReferralsCount > 0) {                                                                                // 876
      bonus.grains = Infinity;                                                                                         // 877
    } else {                                                                                                           // 878
      bonus.grains = 0;                                                                                                // 879
    }                                                                                                                  // 880
                                                                                                                       //
    return bonus;                                                                                                      // 882
  }                                                                                                                    // 883
};                                                                                                                     // 884
                                                                                                                       //
isAdmin = function () {                                                                                                // 886
  // Returns true if the user is the administrator.                                                                    // 887
  var user = Meteor.user();                                                                                            // 889
                                                                                                                       //
  if (user && user.isAdmin) {                                                                                          // 890
    return true;                                                                                                       // 891
  } else {                                                                                                             // 892
    return false;                                                                                                      // 893
  }                                                                                                                    // 894
};                                                                                                                     // 895
                                                                                                                       //
isAdminById = function (id) {                                                                                          // 897
  // Returns true if the user's id is the administrator.                                                               // 898
  var user = Meteor.users.findOne({                                                                                    // 900
    _id: id                                                                                                            // 900
  }, {                                                                                                                 // 900
    fields: {                                                                                                          // 900
      isAdmin: 1                                                                                                       // 900
    }                                                                                                                  // 900
  });                                                                                                                  // 900
                                                                                                                       //
  if (user && user.isAdmin) {                                                                                          // 901
    return true;                                                                                                       // 902
  } else {                                                                                                             // 903
    return false;                                                                                                      // 904
  }                                                                                                                    // 905
};                                                                                                                     // 906
                                                                                                                       //
findAdminUserForToken = function (token) {                                                                             // 908
  if (!token.requirements) {                                                                                           // 909
    return;                                                                                                            // 910
  }                                                                                                                    // 911
                                                                                                                       //
  var requirements = token.requirements.filter(function (requirement) {                                                // 913
    return "userIsAdmin" in requirement;                                                                               // 914
  });                                                                                                                  // 915
                                                                                                                       //
  if (requirements.length > 1) {                                                                                       // 917
    return;                                                                                                            // 918
  }                                                                                                                    // 919
                                                                                                                       //
  if (requirements.length === 0) {                                                                                     // 921
    return;                                                                                                            // 922
  }                                                                                                                    // 923
                                                                                                                       //
  return requirements[0].userIsAdmin;                                                                                  // 925
};                                                                                                                     // 926
                                                                                                                       //
var wildcardHost = Meteor.settings.public.wildcardHost.toLowerCase().split("*");                                       // 928
                                                                                                                       //
if (wildcardHost.length != 2) {                                                                                        // 930
  throw new Error("Wildcard host must contain exactly one asterisk.");                                                 // 931
}                                                                                                                      // 932
                                                                                                                       //
matchWildcardHost = function (host) {                                                                                  // 934
  // See if the hostname is a member of our wildcard. If so, extract the ID.                                           // 935
  // We remove everything after the first ":" character so that our                                                    // 937
  // comparison logic ignores port numbers.                                                                            // 938
  var prefix = wildcardHost[0];                                                                                        // 939
  var suffix = wildcardHost[1].split(":")[0];                                                                          // 940
  var hostSansPort = host.split(":")[0];                                                                               // 941
                                                                                                                       //
  if (hostSansPort.lastIndexOf(prefix, 0) >= 0 && hostSansPort.indexOf(suffix, -suffix.length) >= 0 && hostSansPort.length >= prefix.length + suffix.length) {
    var id = hostSansPort.slice(prefix.length, -suffix.length);                                                        // 946
                                                                                                                       //
    if (id.match(/^[-a-z0-9]*$/)) {                                                                                    // 947
      return id;                                                                                                       // 948
    }                                                                                                                  // 949
  }                                                                                                                    // 950
                                                                                                                       //
  return null;                                                                                                         // 952
};                                                                                                                     // 953
                                                                                                                       //
makeWildcardHost = function (id) {                                                                                     // 955
  return wildcardHost[0] + id + wildcardHost[1];                                                                       // 956
};                                                                                                                     // 957
                                                                                                                       //
var isApiHostId = function (hostId) {                                                                                  // 959
  if (hostId) {                                                                                                        // 960
    var split = hostId.split("-");                                                                                     // 961
    if (split[0] === "api") return split[1] || "*";                                                                    // 962
  }                                                                                                                    // 963
                                                                                                                       //
  return false;                                                                                                        // 965
};                                                                                                                     // 966
                                                                                                                       //
var isTokenSpecificHostId = function (hostId) {                                                                        // 968
  return hostId.lastIndexOf("api-", 0) === 0;                                                                          // 969
};                                                                                                                     // 970
                                                                                                                       //
var apiHostIdHashForToken = void 0;                                                                                    // 972
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 973
  var Crypto = Npm.require("crypto");                                                                                  // 974
                                                                                                                       //
  apiHostIdHashForToken = function (token) {                                                                           // 975
    // Given an API token, compute the host ID that must be used when requesting this token.                           // 976
    // We add a leading 'x' to the hash so that knowing the hostname alone is not sufficient to                        // 978
    // find the corresponding API token in the ApiTokens table (whose _id values are also hashes                       // 979
    // of tokens). This doesn't technically add any security, but helps prove that we don't have                       // 980
    // any bugs which would allow someone who knows only the hostname to access the app API.                           // 981
    return Crypto.createHash("sha256").update("x" + token).digest("hex").slice(0, 32);                                 // 982
  };                                                                                                                   // 983
} else {                                                                                                               // 984
  apiHostIdHashForToken = function (token) {                                                                           // 985
    // Given an API token, compute the host ID that must be used when requesting this token.                           // 986
    // We add a leading 'x' to the hash so that knowing the hostname alone is not sufficient to                        // 988
    // find the corresponding API token in the ApiTokens table (whose _id values are also hashes                       // 989
    // of tokens). This doesn't technically add any security, but helps prove that we don't have                       // 990
    // any bugs which would allow someone who knows only the hostname to access the app API.                           // 991
    return SHA256("x" + token).slice(0, 32);                                                                           // 992
  };                                                                                                                   // 993
}                                                                                                                      // 994
                                                                                                                       //
var apiHostIdForToken = function (token) {                                                                             // 996
  return "api-" + apiHostIdHashForToken(token);                                                                        // 997
};                                                                                                                     // 998
                                                                                                                       //
var makeApiHost = function (token) {                                                                                   // 1000
  return makeWildcardHost(apiHostIdForToken(token));                                                                   // 1001
};                                                                                                                     // 1002
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 1004
  var Url = Npm.require("url");                                                                                        // 1005
                                                                                                                       //
  getWildcardOrigin = function () {                                                                                    // 1006
    // The wildcard URL can be something like "foo-*-bar.example.com", but sometimes when we're                        // 1007
    // trying to specify a pattern matching hostnames (say, a Content-Security-Policy directive),                      // 1008
    // an astrisk is only allowed as the first character and must be followed by a period. So we need                  // 1009
    // "*.example.com" instead -- which matches more than we actually want, but is the best we can                     // 1010
    // really do. We also add the protocol to the front (again, that's what CSP wants).                                // 1011
    // TODO(cleanup): `protocol` is computed in other files, like proxy.js. Put it somewhere common.                   // 1013
    var protocol = Url.parse(process.env.ROOT_URL).protocol;                                                           // 1014
    var dotPos = wildcardHost[1].indexOf(".");                                                                         // 1016
                                                                                                                       //
    if (dotPos < 0) {                                                                                                  // 1017
      return protocol + "//*";                                                                                         // 1018
    } else {                                                                                                           // 1019
      return protocol + "//*" + wildcardHost[1].slice(dotPos);                                                         // 1020
    }                                                                                                                  // 1021
  };                                                                                                                   // 1022
}                                                                                                                      // 1023
                                                                                                                       //
SandstormDb = function (quotaManager) {                                                                                // 1025
  // quotaManager is an object with the following method:                                                              // 1026
  //   updateUserQuota: It is provided two arguments                                                                   // 1027
  //     db: This SandstormDb object                                                                                   // 1028
  //     user: A collections.users account object                                                                      // 1029
  //   and returns a quota object:                                                                                     // 1030
  //     storage: A number (can be Infinity)                                                                           // 1031
  //     compute: A number (can be Infinity)                                                                           // 1032
  //     grains: A number (can be Infinity)                                                                            // 1033
  this.quotaManager = quotaManager;                                                                                    // 1035
  this.collections = {                                                                                                 // 1036
    // Direct access to underlying collections. DEPRECATED, but better than accessing the top-level                    // 1037
    // collection globals directly.                                                                                    // 1038
    //                                                                                                                 // 1039
    // TODO(cleanup): Over time, we will provide methods covering each supported query and remove                      // 1040
    //   direct access to the collections.                                                                             // 1041
    users: Meteor.users,                                                                                               // 1042
    packages: Packages,                                                                                                // 1044
    devPackages: DevPackages,                                                                                          // 1045
    userActions: UserActions,                                                                                          // 1046
    grains: Grains,                                                                                                    // 1047
    roleAssignments: RoleAssignments,                                                                                  // 1048
    // Deprecated, only used by the migration that eliminated it.                                                      // 1048
    contacts: Contacts,                                                                                                // 1049
    sessions: Sessions,                                                                                                // 1050
    signupKeys: SignupKeys,                                                                                            // 1051
    activityStats: ActivityStats,                                                                                      // 1052
    deleteStats: DeleteStats,                                                                                          // 1053
    fileTokens: FileTokens,                                                                                            // 1054
    spkTokens: SpkTokens,                                                                                              // 1055
    apiTokens: ApiTokens,                                                                                              // 1056
    apiHosts: ApiHosts,                                                                                                // 1057
    notifications: Notifications,                                                                                      // 1058
    activitySubscriptions: ActivitySubscriptions,                                                                      // 1059
    statsTokens: StatsTokens,                                                                                          // 1060
    misc: Misc,                                                                                                        // 1061
    settings: Settings,                                                                                                // 1062
    migrations: Migrations,                                                                                            // 1063
    staticAssets: StaticAssets,                                                                                        // 1064
    assetUploadTokens: AssetUploadTokens,                                                                              // 1065
    plans: Plans,                                                                                                      // 1066
    appIndex: AppIndex,                                                                                                // 1067
    keybaseProfiles: KeybaseProfiles,                                                                                  // 1068
    setupSession: SetupSession,                                                                                        // 1069
    desktopNotifications: DesktopNotifications,                                                                        // 1070
    standaloneDomains: StandaloneDomains                                                                               // 1071
  };                                                                                                                   // 1036
}; // TODO(cleanup): These methods should not be defined freestanding and should use collection                        // 1073
//   objects created in SandstormDb's constructor rather than globals.                                                 // 1076
                                                                                                                       //
                                                                                                                       //
_.extend(SandstormDb.prototype, {                                                                                      // 1078
  isAdmin: isAdmin,                                                                                                    // 1079
  isAdminById: isAdminById,                                                                                            // 1080
  findAdminUserForToken: findAdminUserForToken,                                                                        // 1081
  matchWildcardHost: matchWildcardHost,                                                                                // 1082
  makeWildcardHost: makeWildcardHost,                                                                                  // 1083
  isApiHostId: isApiHostId,                                                                                            // 1084
  isTokenSpecificHostId: isTokenSpecificHostId,                                                                        // 1085
  apiHostIdHashForToken: apiHostIdHashForToken,                                                                        // 1086
  apiHostIdForToken: apiHostIdForToken,                                                                                // 1087
  makeApiHost: makeApiHost,                                                                                            // 1088
  allowDevAccounts: function () {                                                                                      // 1089
    var setting = this.collections.settings.findOne({                                                                  // 1090
      _id: "devAccounts"                                                                                               // 1090
    });                                                                                                                // 1090
                                                                                                                       //
    if (setting) {                                                                                                     // 1091
      return setting.value;                                                                                            // 1092
    } else {                                                                                                           // 1093
      return Meteor.settings && Meteor.settings.public && Meteor.settings.public.allowDevAccounts;                     // 1094
    }                                                                                                                  // 1096
  },                                                                                                                   // 1097
  roleAssignmentPattern: {                                                                                             // 1099
    none: Match.Optional(null),                                                                                        // 1100
    allAccess: Match.Optional(null),                                                                                   // 1101
    roleId: Match.Optional(Match.Integer),                                                                             // 1102
    addPermissions: Match.Optional([Boolean]),                                                                         // 1103
    removePermissions: Match.Optional([Boolean])                                                                       // 1104
  },                                                                                                                   // 1099
  isDemoUser: function () {                                                                                            // 1107
    // Returns true if this is a demo user.                                                                            // 1108
    var user = Meteor.user();                                                                                          // 1110
                                                                                                                       //
    if (user && user.expires) {                                                                                        // 1111
      return true;                                                                                                     // 1112
    } else {                                                                                                           // 1113
      return false;                                                                                                    // 1114
    }                                                                                                                  // 1115
  },                                                                                                                   // 1116
  isSignedUp: function () {                                                                                            // 1118
    var user = Meteor.user();                                                                                          // 1119
    return this.isAccountSignedUp(user);                                                                               // 1120
  },                                                                                                                   // 1121
  isAccountSignedUp: function (user) {                                                                                 // 1123
    // Returns true if the user has presented an invite key.                                                           // 1124
    if (!user) return false; // not signed in                                                                          // 1126
                                                                                                                       //
    if (!user.loginIdentities) return false; // not an account                                                         // 1128
                                                                                                                       //
    if (user.expires) return false; // demo user.                                                                      // 1130
                                                                                                                       //
    if (Meteor.settings.public.allowUninvited) return true; // all accounts qualify                                    // 1132
                                                                                                                       //
    if (user.signupKey) return true; // user is invited                                                                // 1134
                                                                                                                       //
    if (this.isUserInOrganization(user)) return true;                                                                  // 1136
    return false;                                                                                                      // 1138
  },                                                                                                                   // 1139
  isSignedUpOrDemo: function () {                                                                                      // 1141
    var user = Meteor.user();                                                                                          // 1142
    return this.isAccountSignedUpOrDemo(user);                                                                         // 1143
  },                                                                                                                   // 1144
  isAccountSignedUpOrDemo: function (user) {                                                                           // 1146
    if (!user) return false; // not signed in                                                                          // 1147
                                                                                                                       //
    if (!user.loginIdentities) return false; // not an account                                                         // 1149
                                                                                                                       //
    if (user.expires) return true; // demo user.                                                                       // 1151
                                                                                                                       //
    if (Meteor.settings.public.allowUninvited) return true; // all accounts qualify                                    // 1153
                                                                                                                       //
    if (user.signupKey) return true; // user is invited                                                                // 1155
                                                                                                                       //
    if (this.isUserInOrganization(user)) return true;                                                                  // 1157
    return false;                                                                                                      // 1159
  },                                                                                                                   // 1160
  isIdentityInOrganization: function (identity) {                                                                      // 1162
    if (!identity || !identity.services) {                                                                             // 1163
      return false;                                                                                                    // 1164
    }                                                                                                                  // 1165
                                                                                                                       //
    var orgMembership = this.getOrganizationMembership();                                                              // 1167
    var googleEnabled = orgMembership && orgMembership.google && orgMembership.google.enabled;                         // 1168
    var googleDomain = orgMembership && orgMembership.google && orgMembership.google.domain;                           // 1169
    var emailEnabled = orgMembership && orgMembership.emailToken && orgMembership.emailToken.enabled;                  // 1170
    var emailDomain = orgMembership && orgMembership.emailToken && orgMembership.emailToken.domain;                    // 1171
    var ldapEnabled = orgMembership && orgMembership.ldap && orgMembership.ldap.enabled;                               // 1172
    var samlEnabled = orgMembership && orgMembership.saml && orgMembership.saml.enabled;                               // 1173
                                                                                                                       //
    if (emailEnabled && emailDomain && identity.services.email) {                                                      // 1174
      var domainSuffixes = emailDomain.split(/\s*,\s*/);                                                               // 1175
                                                                                                                       //
      for (var i = 0; i < domainSuffixes.length; i++) {                                                                // 1176
        var suffix = domainSuffixes[i];                                                                                // 1177
        var domain = identity.services.email.email.toLowerCase().split("@").pop();                                     // 1178
                                                                                                                       //
        if (suffix.startsWith("*.")) {                                                                                 // 1179
          if (domain.endsWith(suffix.substr(1))) {                                                                     // 1180
            return true;                                                                                               // 1181
          }                                                                                                            // 1182
        } else if (domain === suffix) {                                                                                // 1183
          return true;                                                                                                 // 1184
        }                                                                                                              // 1185
      }                                                                                                                // 1186
    } else if (ldapEnabled && identity.services.ldap) {                                                                // 1187
      return true;                                                                                                     // 1188
    } else if (samlEnabled && identity.services.saml) {                                                                // 1189
      return true;                                                                                                     // 1190
    } else if (googleEnabled && googleDomain && identity.services.google && identity.services.google.hd) {             // 1191
      if (identity.services.google.hd.toLowerCase() === googleDomain) {                                                // 1192
        return true;                                                                                                   // 1193
      }                                                                                                                // 1194
    }                                                                                                                  // 1195
                                                                                                                       //
    return false;                                                                                                      // 1197
  },                                                                                                                   // 1198
  isUserInOrganization: function (user) {                                                                              // 1200
    for (var i = 0; i < user.loginIdentities.length; i++) {                                                            // 1201
      var identity = Meteor.users.findOne({                                                                            // 1202
        _id: user.loginIdentities[i].id                                                                                // 1202
      });                                                                                                              // 1202
                                                                                                                       //
      if (this.isIdentityInOrganization(identity)) {                                                                   // 1203
        return true;                                                                                                   // 1204
      }                                                                                                                // 1205
    }                                                                                                                  // 1206
                                                                                                                       //
    return false;                                                                                                      // 1208
  }                                                                                                                    // 1209
});                                                                                                                    // 1078
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 1212
  SandstormDb.prototype.getWildcardOrigin = getWildcardOrigin;                                                         // 1213
                                                                                                                       //
  var _Crypto = Npm.require("crypto");                                                                                 // 1215
                                                                                                                       //
  SandstormDb.prototype.removeApiTokens = function (query) {                                                           // 1216
    var _this2 = this;                                                                                                 // 1216
                                                                                                                       //
    // Remove all API tokens matching the query, making sure to clean up ApiHosts as well.                             // 1217
    this.collections.apiTokens.find(query).forEach(function (token) {                                                  // 1219
      // Clean up ApiHosts for webkey tokens.                                                                          // 1220
      if (token.hasApiHost) {                                                                                          // 1221
        var hash2 = _Crypto.createHash("sha256").update(token._id).digest("base64");                                   // 1222
                                                                                                                       //
        _this2.collections.apiHosts.remove({                                                                           // 1223
          hash2: hash2                                                                                                 // 1223
        });                                                                                                            // 1223
      } // TODO(soon): Drop remote OAuth tokens for frontendRef.http. Unfortunately the way to do                      // 1224
      //   this is different for every service. :( Also we may need to clarify with the "bearer"                       // 1227
      //   type whether or not the token is "owned" by us...                                                           // 1228
                                                                                                                       //
    });                                                                                                                // 1229
    this.collections.apiTokens.remove(query);                                                                          // 1231
  };                                                                                                                   // 1232
} // TODO(someday): clean this up.  Logic for building static asset urls on client and server                          // 1233
// appears all over the codebase.                                                                                      // 1236
                                                                                                                       //
                                                                                                                       //
var httpProtocol = void 0;                                                                                             // 1237
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 1238
  var _Url = Npm.require("url");                                                                                       // 1239
                                                                                                                       //
  httpProtocol = _Url.parse(process.env.ROOT_URL).protocol;                                                            // 1240
} else {                                                                                                               // 1241
  httpProtocol = window.location.protocol;                                                                             // 1242
} // =======================================================================================                           // 1243
// Below this point are newly-written or refactored functions.                                                         // 1246
                                                                                                                       //
                                                                                                                       //
_.extend(SandstormDb.prototype, {                                                                                      // 1248
  getUser: function (userId) {                                                                                         // 1249
    check(userId, Match.OneOf(String, undefined, null));                                                               // 1250
                                                                                                                       //
    if (userId) {                                                                                                      // 1251
      return Meteor.users.findOne(userId);                                                                             // 1252
    }                                                                                                                  // 1253
  },                                                                                                                   // 1254
  getIdentity: function (identityId) {                                                                                 // 1256
    check(identityId, String);                                                                                         // 1257
    var identity = Meteor.users.findOne({                                                                              // 1258
      _id: identityId                                                                                                  // 1258
    });                                                                                                                // 1258
                                                                                                                       //
    if (identity) {                                                                                                    // 1259
      SandstormDb.fillInProfileDefaults(identity);                                                                     // 1260
      SandstormDb.fillInIntrinsicName(identity);                                                                       // 1261
      SandstormDb.fillInPictureUrl(identity);                                                                          // 1262
      return identity;                                                                                                 // 1263
    }                                                                                                                  // 1264
  },                                                                                                                   // 1265
  userHasIdentity: function (userId, identityId) {                                                                     // 1267
    check(userId, String);                                                                                             // 1268
    check(identityId, String);                                                                                         // 1269
    if (userId === identityId) return true;                                                                            // 1271
    var user = Meteor.users.findOne(userId);                                                                           // 1273
    return SandstormDb.getUserIdentityIds(user).indexOf(identityId) != -1;                                             // 1274
  },                                                                                                                   // 1275
  userGrains: function (userId, options) {                                                                             // 1277
    check(userId, Match.OneOf(String, undefined, null));                                                               // 1278
    check(options, Match.OneOf(undefined, null, {                                                                      // 1279
      includeTrashOnly: Match.Optional(Boolean),                                                                       // 1280
      includeTrash: Match.Optional(Boolean)                                                                            // 1280
    }));                                                                                                               // 1280
    var query = {                                                                                                      // 1282
      userId: userId                                                                                                   // 1282
    };                                                                                                                 // 1282
                                                                                                                       //
    if (options && options.includeTrashOnly) {                                                                         // 1283
      query.trashed = {                                                                                                // 1284
        $exists: true                                                                                                  // 1284
      };                                                                                                               // 1284
    } else if (options && options.includeTrash) {// Keep query as-is.                                                  // 1285
    } else {                                                                                                           // 1287
      query.trashed = {                                                                                                // 1288
        $exists: false                                                                                                 // 1288
      };                                                                                                               // 1288
    }                                                                                                                  // 1289
                                                                                                                       //
    return this.collections.grains.find(query);                                                                        // 1291
  },                                                                                                                   // 1292
  currentUserGrains: function (options) {                                                                              // 1294
    return this.userGrains(Meteor.userId(), options);                                                                  // 1295
  },                                                                                                                   // 1296
  getGrain: function (grainId) {                                                                                       // 1298
    check(grainId, String);                                                                                            // 1299
    return this.collections.grains.findOne(grainId);                                                                   // 1300
  },                                                                                                                   // 1301
  userApiTokens: function (userId, trashed) {                                                                          // 1303
    check(userId, Match.OneOf(String, undefined, null));                                                               // 1304
    check(trashed, Match.OneOf(Boolean, undefined, null));                                                             // 1305
    var identityIds = SandstormDb.getUserIdentityIds(this.getUser(userId));                                            // 1306
    return this.collections.apiTokens.find({                                                                           // 1307
      "owner.user.identityId": {                                                                                       // 1308
        $in: identityIds                                                                                               // 1308
      },                                                                                                               // 1308
      trashed: {                                                                                                       // 1309
        $exists: !!trashed                                                                                             // 1309
      }                                                                                                                // 1309
    });                                                                                                                // 1307
  },                                                                                                                   // 1311
  currentUserApiTokens: function (trashed) {                                                                           // 1313
    return this.userApiTokens(Meteor.userId(), trashed);                                                               // 1314
  },                                                                                                                   // 1315
  userActions: function (user) {                                                                                       // 1317
    return this.collections.userActions.find({                                                                         // 1318
      userId: user                                                                                                     // 1318
    });                                                                                                                // 1318
  },                                                                                                                   // 1319
  currentUserActions: function () {                                                                                    // 1321
    return this.userActions(Meteor.userId());                                                                          // 1322
  },                                                                                                                   // 1323
  iconSrcForPackage: function (pkg, usage) {                                                                           // 1325
    return Identicon.iconSrcForPackage(pkg, usage, httpProtocol + "//" + this.makeWildcardHost("static"));             // 1326
  },                                                                                                                   // 1327
  getDenormalizedGrainInfo: function (grainId) {                                                                       // 1329
    var grain = this.getGrain(grainId);                                                                                // 1330
    var pkg = this.collections.packages.findOne(grain.packageId);                                                      // 1331
                                                                                                                       //
    if (!pkg) {                                                                                                        // 1333
      pkg = this.collections.devPackages.findOne(grain.packageId);                                                     // 1334
    }                                                                                                                  // 1335
                                                                                                                       //
    var appTitle = pkg && pkg.manifest && pkg.manifest.appTitle || {                                                   // 1337
      defaultText: ""                                                                                                  // 1337
    };                                                                                                                 // 1337
    var grainInfo = {                                                                                                  // 1338
      appTitle: appTitle                                                                                               // 1338
    };                                                                                                                 // 1338
                                                                                                                       //
    if (pkg && pkg.manifest && pkg.manifest.metadata && pkg.manifest.metadata.icons) {                                 // 1340
      var icons = pkg.manifest.metadata.icons;                                                                         // 1341
      var icon = icons.grain || icons.appGrid;                                                                         // 1342
                                                                                                                       //
      if (icon) {                                                                                                      // 1343
        grainInfo.icon = icon;                                                                                         // 1344
      }                                                                                                                // 1345
    } // Only provide an app ID if we have no icon asset to provide and need to offer an identicon.                    // 1346
                                                                                                                       //
                                                                                                                       //
    if (!grainInfo.icon && pkg) {                                                                                      // 1349
      grainInfo.appId = pkg.appId;                                                                                     // 1350
    }                                                                                                                  // 1351
                                                                                                                       //
    return grainInfo;                                                                                                  // 1353
  },                                                                                                                   // 1354
  getPlan: function (id, user) {                                                                                       // 1356
    check(id, String); // `user`, if provided, is the user observing the plan. This matters only for checking if the   // 1357
    // user is in an experiment.                                                                                       // 1360
                                                                                                                       //
    var plan = this.collections.plans.findOne(id);                                                                     // 1362
                                                                                                                       //
    if (!plan) {                                                                                                       // 1363
      throw new Error("no such plan: " + id);                                                                          // 1364
    }                                                                                                                  // 1365
                                                                                                                       //
    if (plan._id === "free") {                                                                                         // 1367
      user = user || Meteor.user();                                                                                    // 1368
                                                                                                                       //
      if (user && user.experiments && typeof user.experiments.freeGrainLimit === "number") {                           // 1369
        plan.grains = user.experiments.freeGrainLimit;                                                                 // 1371
      }                                                                                                                // 1372
    }                                                                                                                  // 1373
                                                                                                                       //
    return plan;                                                                                                       // 1375
  },                                                                                                                   // 1376
  listPlans: function (user) {                                                                                         // 1378
    user = user || Meteor.user();                                                                                      // 1379
                                                                                                                       //
    if (user && user.experiments && typeof user.experiments.freeGrainLimit === "number") {                             // 1380
      return this.collections.plans.find({}, {                                                                         // 1382
        sort: {                                                                                                        // 1382
          price: 1                                                                                                     // 1382
        }                                                                                                              // 1382
      }).map(function (plan) {                                                                                         // 1382
        if (plan._id === "free") {                                                                                     // 1384
          plan.grains = user.experiments.freeGrainLimit;                                                               // 1385
        }                                                                                                              // 1386
                                                                                                                       //
        return plan;                                                                                                   // 1388
      });                                                                                                              // 1389
    } else {                                                                                                           // 1390
      return this.collections.plans.find({}, {                                                                         // 1391
        sort: {                                                                                                        // 1391
          price: 1                                                                                                     // 1391
        }                                                                                                              // 1391
      }).fetch();                                                                                                      // 1391
    }                                                                                                                  // 1392
  },                                                                                                                   // 1393
  getMyPlan: function () {                                                                                             // 1395
    var user = Meteor.user();                                                                                          // 1396
    return user && this.collections.plans.findOne(user.plan || "free");                                                // 1397
  },                                                                                                                   // 1398
  getMyReferralBonus: function (user) {                                                                                // 1400
    // This function is called from the server and from the client, similar to getMyPlan().                            // 1401
    //                                                                                                                 // 1402
    // The parameter may be omitted in which case the current user is assumed.                                         // 1403
    return calculateReferralBonus(user || Meteor.user());                                                              // 1405
  },                                                                                                                   // 1406
  getMyUsage: function (user) {                                                                                        // 1408
    user = user || Meteor.user();                                                                                      // 1409
                                                                                                                       //
    if (user && (Meteor.isServer || user.pseudoUsage)) {                                                               // 1410
      if (Meteor.isClient) {                                                                                           // 1411
        // Filled by pseudo-subscription to "getMyUsage". WARNING: The subscription is currently                       // 1412
        // not reactive.                                                                                               // 1413
        return user.pseudoUsage;                                                                                       // 1414
      } else {                                                                                                         // 1415
        return {                                                                                                       // 1416
          grains: this.collections.grains.find({                                                                       // 1417
            userId: user._id                                                                                           // 1417
          }).count(),                                                                                                  // 1417
          storage: user.storageUsage || 0,                                                                             // 1418
          compute: 0                                                                                                   // 1419
        };                                                                                                             // 1416
      }                                                                                                                // 1421
    } else {                                                                                                           // 1422
      return {                                                                                                         // 1423
        grains: 0,                                                                                                     // 1423
        storage: 0,                                                                                                    // 1423
        compute: 0                                                                                                     // 1423
      };                                                                                                               // 1423
    }                                                                                                                  // 1424
  },                                                                                                                   // 1425
  isUninvitedFreeUser: function () {                                                                                   // 1427
    if (!Meteor.settings.public.allowUninvited) return false;                                                          // 1428
    var user = Meteor.user();                                                                                          // 1430
    return user && !user.expires && (!user.plan || user.plan === "free");                                              // 1431
  },                                                                                                                   // 1432
  getSetting: function (name) {                                                                                        // 1434
    var setting = this.collections.settings.findOne(name);                                                             // 1435
    return setting && setting.value;                                                                                   // 1436
  },                                                                                                                   // 1437
  getSettingWithFallback: function (name, fallbackValue) {                                                             // 1439
    var value = this.getSetting(name);                                                                                 // 1440
                                                                                                                       //
    if (value === undefined) {                                                                                         // 1441
      return fallbackValue;                                                                                            // 1442
    }                                                                                                                  // 1443
                                                                                                                       //
    return value;                                                                                                      // 1445
  },                                                                                                                   // 1446
  addUserActions: function (userId, packageId, simulation) {                                                           // 1448
    check(userId, String);                                                                                             // 1449
    check(packageId, String);                                                                                          // 1450
    var pack = this.collections.packages.findOne({                                                                     // 1452
      _id: packageId                                                                                                   // 1452
    });                                                                                                                // 1452
                                                                                                                       //
    if (pack) {                                                                                                        // 1453
      // Remove old versions.                                                                                          // 1454
      var numRemoved = this.collections.userActions.remove({                                                           // 1455
        userId: userId,                                                                                                // 1455
        appId: pack.appId                                                                                              // 1455
      }); // Install new.                                                                                              // 1455
                                                                                                                       //
      var actions = pack.manifest.actions;                                                                             // 1458
                                                                                                                       //
      for (var i in meteorBabelHelpers.sanitizeForInObject(actions)) {                                                 // 1459
        var action = actions[i];                                                                                       // 1460
                                                                                                                       //
        if ("none" in action.input) {                                                                                  // 1461
          var userAction = {                                                                                           // 1462
            userId: userId,                                                                                            // 1463
            packageId: pack._id,                                                                                       // 1464
            appId: pack.appId,                                                                                         // 1465
            appTitle: pack.manifest.appTitle,                                                                          // 1466
            appMarketingVersion: pack.manifest.appMarketingVersion,                                                    // 1467
            appVersion: pack.manifest.appVersion,                                                                      // 1468
            title: action.title,                                                                                       // 1469
            nounPhrase: action.nounPhrase,                                                                             // 1470
            command: action.command                                                                                    // 1471
          };                                                                                                           // 1462
          this.collections.userActions.insert(userAction);                                                             // 1473
        } else {// TODO(someday):  Implement actions with capability inputs.                                           // 1474
        }                                                                                                              // 1476
      }                                                                                                                // 1477
                                                                                                                       //
      if (numRemoved > 0 && !simulation) {                                                                             // 1479
        this.deleteUnusedPackages(pack.appId);                                                                         // 1480
      }                                                                                                                // 1481
    }                                                                                                                  // 1482
  },                                                                                                                   // 1483
  sendAdminNotification: function (type, action) {                                                                     // 1485
    Meteor.users.find({                                                                                                // 1486
      isAdmin: true                                                                                                    // 1486
    }, {                                                                                                               // 1486
      fields: {                                                                                                        // 1486
        _id: 1                                                                                                         // 1486
      }                                                                                                                // 1486
    }).forEach(function (user) {                                                                                       // 1486
      Notifications.insert({                                                                                           // 1487
        admin: {                                                                                                       // 1488
          action: action,                                                                                              // 1488
          type: type                                                                                                   // 1488
        },                                                                                                             // 1488
        userId: user._id,                                                                                              // 1489
        timestamp: new Date(),                                                                                         // 1490
        isUnread: true                                                                                                 // 1491
      });                                                                                                              // 1487
    });                                                                                                                // 1493
  },                                                                                                                   // 1494
  getKeybaseProfile: function (keyFingerprint) {                                                                       // 1496
    return this.collections.keybaseProfiles.findOne(keyFingerprint) || {};                                             // 1497
  },                                                                                                                   // 1498
  getServerTitle: function () {                                                                                        // 1500
    var setting = this.collections.settings.findOne({                                                                  // 1501
      _id: "serverTitle"                                                                                               // 1501
    });                                                                                                                // 1501
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1502
  },                                                                                                                   // 1503
  getSmtpConfig: function () {                                                                                         // 1505
    var setting = this.collections.settings.findOne({                                                                  // 1506
      _id: "smtpConfig"                                                                                                // 1506
    });                                                                                                                // 1506
    return setting ? setting.value : undefined; // undefined if subscription is not ready.                             // 1507
  },                                                                                                                   // 1508
  getReturnAddress: function () {                                                                                      // 1510
    var config = this.getSmtpConfig();                                                                                 // 1511
    return config && config.returnAddress || ""; // empty if subscription is not ready.                                // 1512
  },                                                                                                                   // 1513
  getReturnAddressWithDisplayName: function (identityId) {                                                             // 1515
    check(identityId, String);                                                                                         // 1516
    var identity = this.getIdentity(identityId);                                                                       // 1517
    var displayName = identity.profile.name + " (via " + this.getServerTitle() + ")"; // First remove any instances of characters that cause trouble for SimpleSmtp. Ideally,
    // we could escape such characters with a backslash, but that does not seem to help here.                          // 1521
    // TODO(cleanup): Unclear whether this sanitization is still necessary now that we return a                        // 1522
    //   structured object and have moved to nodemailer. I'm not touching it for now.                                  // 1523
                                                                                                                       //
    var sanitized = displayName.replace(/"|<|>|\\|\r/g, "");                                                           // 1524
    return {                                                                                                           // 1526
      name: sanitized,                                                                                                 // 1526
      address: this.getReturnAddress()                                                                                 // 1526
    };                                                                                                                 // 1526
  },                                                                                                                   // 1527
  getPrimaryEmail: function (accountId, identityId) {                                                                  // 1529
    check(accountId, String);                                                                                          // 1530
    check(identityId, String);                                                                                         // 1531
    var identity = this.getIdentity(identityId);                                                                       // 1533
    var senderEmails = SandstormDb.getVerifiedEmails(identity);                                                        // 1534
                                                                                                                       //
    var senderPrimaryEmail = _.findWhere(senderEmails, {                                                               // 1535
      primary: true                                                                                                    // 1535
    });                                                                                                                // 1535
                                                                                                                       //
    var accountPrimaryEmailAddress = this.getUser(accountId).primaryEmail;                                             // 1536
                                                                                                                       //
    if (_.findWhere(senderEmails, {                                                                                    // 1537
      email: accountPrimaryEmailAddress                                                                                // 1537
    })) {                                                                                                              // 1537
      return accountPrimaryEmailAddress;                                                                               // 1538
    } else if (senderPrimaryEmail) {                                                                                   // 1539
      return senderPrimaryEmail.email;                                                                                 // 1540
    } else {                                                                                                           // 1541
      return null;                                                                                                     // 1542
    }                                                                                                                  // 1543
  },                                                                                                                   // 1544
  incrementDailySentMailCount: function (accountId) {                                                                  // 1546
    check(accountId, String);                                                                                          // 1547
    var DAILY_LIMIT = 50;                                                                                              // 1549
    var result = Meteor.users.findAndModify({                                                                          // 1550
      query: {                                                                                                         // 1551
        _id: accountId                                                                                                 // 1551
      },                                                                                                               // 1551
      update: {                                                                                                        // 1552
        $inc: {                                                                                                        // 1553
          dailySentMailCount: 1                                                                                        // 1554
        }                                                                                                              // 1553
      },                                                                                                               // 1552
      fields: {                                                                                                        // 1557
        dailySentMailCount: 1                                                                                          // 1557
      }                                                                                                                // 1557
    });                                                                                                                // 1550
                                                                                                                       //
    if (!result.ok) {                                                                                                  // 1560
      throw new Error("Couldn't update daily sent mail count.");                                                       // 1561
    }                                                                                                                  // 1562
                                                                                                                       //
    var user = result.value;                                                                                           // 1564
                                                                                                                       //
    if (user.dailySentMailCount >= DAILY_LIMIT) {                                                                      // 1565
      throw new Error("Sorry, you've reached your e-mail sending limit for today. Currently, Sandstorm " + "limits each user to " + DAILY_LIMIT + " e-mails per day for spam control reasons. " + "Please feel free to contact us if this is a problem.");
    }                                                                                                                  // 1570
  },                                                                                                                   // 1571
  getLdapUrl: function () {                                                                                            // 1573
    var setting = this.collections.settings.findOne({                                                                  // 1574
      _id: "ldapUrl"                                                                                                   // 1574
    });                                                                                                                // 1574
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1575
  },                                                                                                                   // 1576
  getLdapBase: function () {                                                                                           // 1578
    var setting = this.collections.settings.findOne({                                                                  // 1579
      _id: "ldapBase"                                                                                                  // 1579
    });                                                                                                                // 1579
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1580
  },                                                                                                                   // 1581
  getLdapDnPattern: function () {                                                                                      // 1583
    var setting = this.collections.settings.findOne({                                                                  // 1584
      _id: "ldapDnPattern"                                                                                             // 1584
    });                                                                                                                // 1584
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1585
  },                                                                                                                   // 1586
  getLdapSearchUsername: function () {                                                                                 // 1588
    var setting = this.collections.settings.findOne({                                                                  // 1589
      _id: "ldapSearchUsername"                                                                                        // 1589
    });                                                                                                                // 1589
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1590
  },                                                                                                                   // 1591
  getLdapNameField: function () {                                                                                      // 1593
    var setting = this.collections.settings.findOne({                                                                  // 1594
      _id: "ldapNameField"                                                                                             // 1594
    });                                                                                                                // 1594
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1595
  },                                                                                                                   // 1596
  getLdapEmailField: function () {                                                                                     // 1598
    var setting = this.collections.settings.findOne({                                                                  // 1599
      _id: "ldapEmailField"                                                                                            // 1599
    });                                                                                                                // 1599
    return setting ? setting.value : "mail"; // default to "mail". This setting was added later, and so could potentially be unset.
  },                                                                                                                   // 1602
  getLdapExplicitDnSelected: function () {                                                                             // 1604
    var setting = this.collections.settings.findOne({                                                                  // 1605
      _id: "ldapExplicitDnSelected"                                                                                    // 1605
    });                                                                                                                // 1605
    return setting && setting.value;                                                                                   // 1606
  },                                                                                                                   // 1607
  getLdapFilter: function () {                                                                                         // 1609
    var setting = this.collections.settings.findOne({                                                                  // 1610
      _id: "ldapFilter"                                                                                                // 1610
    });                                                                                                                // 1610
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1611
  },                                                                                                                   // 1612
  getLdapSearchBindDn: function () {                                                                                   // 1614
    var setting = this.collections.settings.findOne({                                                                  // 1615
      _id: "ldapSearchBindDn"                                                                                          // 1615
    });                                                                                                                // 1615
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1616
  },                                                                                                                   // 1617
  getLdapSearchBindPassword: function () {                                                                             // 1619
    var setting = this.collections.settings.findOne({                                                                  // 1620
      _id: "ldapSearchBindPassword"                                                                                    // 1620
    });                                                                                                                // 1620
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1621
  },                                                                                                                   // 1622
  getLdapCaCert: function () {                                                                                         // 1624
    var setting = this.collections.settings.findOne({                                                                  // 1625
      _id: "ldapCaCert"                                                                                                // 1625
    });                                                                                                                // 1625
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1626
  },                                                                                                                   // 1627
  getOrganizationMembership: function () {                                                                             // 1629
    var setting = this.collections.settings.findOne({                                                                  // 1630
      _id: "organizationMembership"                                                                                    // 1630
    });                                                                                                                // 1630
    return setting && setting.value;                                                                                   // 1631
  },                                                                                                                   // 1632
  getOrganizationEmailEnabled: function () {                                                                           // 1634
    var membership = this.getOrganizationMembership();                                                                 // 1635
    return membership && membership.emailToken && membership.emailToken.enabled;                                       // 1636
  },                                                                                                                   // 1637
  getOrganizationEmailDomain: function () {                                                                            // 1639
    var membership = this.getOrganizationMembership();                                                                 // 1640
    return membership && membership.emailToken && membership.emailToken.domain;                                        // 1641
  },                                                                                                                   // 1642
  getOrganizationGoogleEnabled: function () {                                                                          // 1644
    var membership = this.getOrganizationMembership();                                                                 // 1645
    return membership && membership.google && membership.google.enabled;                                               // 1646
  },                                                                                                                   // 1647
  getOrganizationGoogleDomain: function () {                                                                           // 1649
    var membership = this.getOrganizationMembership();                                                                 // 1650
    return membership && membership.google && membership.google.domain;                                                // 1651
  },                                                                                                                   // 1652
  getOrganizationLdapEnabled: function () {                                                                            // 1654
    var membership = this.getOrganizationMembership();                                                                 // 1655
    return membership && membership.ldap && membership.ldap.enabled;                                                   // 1656
  },                                                                                                                   // 1657
  getOrganizationSamlEnabled: function () {                                                                            // 1659
    var membership = this.getOrganizationMembership();                                                                 // 1660
    return membership && membership.saml && membership.saml.enabled;                                                   // 1661
  },                                                                                                                   // 1662
  getOrganizationDisallowGuests: function () {                                                                         // 1664
    return this.getOrganizationDisallowGuestsRaw();                                                                    // 1665
  },                                                                                                                   // 1666
  getOrganizationDisallowGuestsRaw: function () {                                                                      // 1668
    var setting = this.collections.settings.findOne({                                                                  // 1669
      _id: "organizationSettings"                                                                                      // 1669
    });                                                                                                                // 1669
    return setting && setting.value && setting.value.disallowGuests;                                                   // 1670
  },                                                                                                                   // 1671
  getOrganizationShareContacts: function () {                                                                          // 1673
    return this.getOrganizationShareContactsRaw();                                                                     // 1674
  },                                                                                                                   // 1675
  getOrganizationShareContactsRaw: function () {                                                                       // 1677
    var setting = this.collections.settings.findOne({                                                                  // 1678
      _id: "organizationSettings"                                                                                      // 1678
    });                                                                                                                // 1678
                                                                                                                       //
    if (!setting || !setting.value || setting.value.shareContacts === undefined) {                                     // 1679
      // default to true if undefined                                                                                  // 1680
      return true;                                                                                                     // 1681
    } else {                                                                                                           // 1682
      return setting.value.shareContacts;                                                                              // 1683
    }                                                                                                                  // 1684
  },                                                                                                                   // 1685
  getSamlEntryPoint: function () {                                                                                     // 1687
    var setting = this.collections.settings.findOne({                                                                  // 1688
      _id: "samlEntryPoint"                                                                                            // 1688
    });                                                                                                                // 1688
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1689
  },                                                                                                                   // 1690
  getSamlLogout: function () {                                                                                         // 1692
    var setting = this.collections.settings.findOne({                                                                  // 1693
      _id: "samlLogout"                                                                                                // 1693
    });                                                                                                                // 1693
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1694
  },                                                                                                                   // 1695
  getSamlPublicCert: function () {                                                                                     // 1697
    var setting = this.collections.settings.findOne({                                                                  // 1698
      _id: "samlPublicCert"                                                                                            // 1698
    });                                                                                                                // 1698
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1699
  },                                                                                                                   // 1700
  getSamlEntityId: function () {                                                                                       // 1702
    var setting = this.collections.settings.findOne({                                                                  // 1703
      _id: "samlEntityId"                                                                                              // 1703
    });                                                                                                                // 1703
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1704
  },                                                                                                                   // 1705
  userHasSamlLoginIdentity: function () {                                                                              // 1707
    var user = Meteor.user();                                                                                          // 1708
                                                                                                                       //
    if (!user.loginIdentities) {                                                                                       // 1709
      return false;                                                                                                    // 1710
    }                                                                                                                  // 1711
                                                                                                                       //
    var hasSaml = false;                                                                                               // 1713
    user.loginIdentities.forEach(function (identity) {                                                                 // 1714
      if (Meteor.users.findOne({                                                                                       // 1715
        _id: identity.id                                                                                               // 1715
      }).services.saml) {                                                                                              // 1715
        hasSaml = true;                                                                                                // 1716
      }                                                                                                                // 1717
    });                                                                                                                // 1718
    return hasSaml;                                                                                                    // 1720
  },                                                                                                                   // 1721
  getActivitySubscriptions: function (grainId, threadPath) {                                                           // 1723
    return this.collections.activitySubscriptions.find({                                                               // 1724
      grainId: grainId,                                                                                                // 1725
      threadPath: threadPath || {                                                                                      // 1726
        $exists: false                                                                                                 // 1726
      }                                                                                                                // 1726
    }, {                                                                                                               // 1724
      fields: {                                                                                                        // 1728
        identityId: 1,                                                                                                 // 1728
        mute: 1,                                                                                                       // 1728
        _id: 0                                                                                                         // 1728
      }                                                                                                                // 1728
    }).fetch();                                                                                                        // 1727
  },                                                                                                                   // 1730
  subscribeToActivity: function (identityId, grainId, threadPath) {                                                    // 1732
    // Subscribe the given identity to activity events with the given grainId and (optional)                           // 1733
    // threadPath -- unless the identity has previously muted this grainId/threadPath, in which                        // 1734
    // case do nothing.                                                                                                // 1735
    var record = {                                                                                                     // 1737
      identityId: identityId,                                                                                          // 1737
      grainId: grainId                                                                                                 // 1737
    };                                                                                                                 // 1737
                                                                                                                       //
    if (threadPath) {                                                                                                  // 1738
      record.threadPath = threadPath;                                                                                  // 1739
    } // The $set here is redundant since an upsert automatically initializes a new record to contain                  // 1740
    // the fields from the query, but if we try to do { $set: {} } Mongo throws an exception, and                      // 1743
    // if we try to just pass {}, Mongo interprets it as "replace the record with an empty record".                    // 1744
    // What a wonderful query language.                                                                                // 1745
                                                                                                                       //
                                                                                                                       //
    this.collections.activitySubscriptions.upsert(record, {                                                            // 1746
      $set: record                                                                                                     // 1746
    });                                                                                                                // 1746
  },                                                                                                                   // 1747
  muteActivity: function (identityId, grainId, threadPath) {                                                           // 1749
    // Mute notifications for the given identity originating from the given grainId and                                // 1750
    // (optional) threadPath.                                                                                          // 1751
    var record = {                                                                                                     // 1753
      identityId: identityId,                                                                                          // 1753
      grainId: grainId                                                                                                 // 1753
    };                                                                                                                 // 1753
                                                                                                                       //
    if (threadPath) {                                                                                                  // 1754
      record.threadPath = threadPath;                                                                                  // 1755
    }                                                                                                                  // 1756
                                                                                                                       //
    this.collections.activitySubscriptions.upsert(record, {                                                            // 1758
      $set: {                                                                                                          // 1758
        mute: true                                                                                                     // 1758
      }                                                                                                                // 1758
    });                                                                                                                // 1758
  },                                                                                                                   // 1759
  updateAppIndex: function () {                                                                                        // 1761
    var _this3 = this;                                                                                                 // 1761
                                                                                                                       //
    var appUpdatesEnabledSetting = this.collections.settings.findOne({                                                 // 1762
      _id: "appUpdatesEnabled"                                                                                         // 1762
    });                                                                                                                // 1762
    var appUpdatesEnabled = appUpdatesEnabledSetting && appUpdatesEnabledSetting.value;                                // 1763
                                                                                                                       //
    if (!appUpdatesEnabled) {                                                                                          // 1764
      // It's much simpler to check appUpdatesEnabled here rather than reactively deactivate the                       // 1765
      // timer that triggers this call.                                                                                // 1766
      return;                                                                                                          // 1767
    }                                                                                                                  // 1768
                                                                                                                       //
    var appIndexUrl = this.collections.settings.findOne({                                                              // 1770
      _id: "appIndexUrl"                                                                                               // 1770
    }).value;                                                                                                          // 1770
    var appIndex = this.collections.appIndex;                                                                          // 1771
    var data = HTTP.get(appIndexUrl + "/apps/index.json").data;                                                        // 1772
    var preinstalledAppIds = this.getAllPreinstalledAppIds(); // We make sure to get all preinstalled appIds, even ones that are currently
    // downloading/failed.                                                                                             // 1775
                                                                                                                       //
    data.apps.forEach(function (app) {                                                                                 // 1776
      app._id = app.appId;                                                                                             // 1777
      var oldApp = appIndex.findOne({                                                                                  // 1779
        _id: app.appId                                                                                                 // 1779
      });                                                                                                              // 1779
      app.hasSentNotifications = false;                                                                                // 1780
      appIndex.upsert({                                                                                                // 1781
        _id: app._id                                                                                                   // 1781
      }, app);                                                                                                         // 1781
                                                                                                                       //
      var isAppPreinstalled = _.contains(preinstalledAppIds, app.appId);                                               // 1782
                                                                                                                       //
      if ((!oldApp || app.versionNumber > oldApp.versionNumber) && (_this3.collections.userActions.findOne({           // 1783
        appId: app.appId                                                                                               // 1784
      }) || isAppPreinstalled)) {                                                                                      // 1784
        var pack = _this3.collections.packages.findOne({                                                               // 1786
          _id: app.packageId                                                                                           // 1786
        });                                                                                                            // 1786
                                                                                                                       //
        var url = appIndexUrl + "/packages/" + app.packageId;                                                          // 1787
                                                                                                                       //
        if (pack) {                                                                                                    // 1788
          if (pack.status === "ready") {                                                                               // 1789
            if (pack.appId && pack.appId !== app.appId) {                                                              // 1790
              console.error("app index returned app ID and package ID that don't match:", JSON.stringify(app));        // 1791
            } else {                                                                                                   // 1793
              _this3.sendAppUpdateNotifications(app.appId, app.packageId, app.name, app.versionNumber, app.version);   // 1794
                                                                                                                       //
              if (isAppPreinstalled) {                                                                                 // 1796
                _this3.setPreinstallAppAsReady(app.appId, app.packageId);                                              // 1797
              }                                                                                                        // 1798
            }                                                                                                          // 1799
          } else {                                                                                                     // 1800
            var result = _this3.collections.packages.findAndModify({                                                   // 1801
              query: {                                                                                                 // 1802
                _id: app.packageId                                                                                     // 1802
              },                                                                                                       // 1802
              update: {                                                                                                // 1803
                $set: {                                                                                                // 1803
                  isAutoUpdated: true                                                                                  // 1803
                }                                                                                                      // 1803
              }                                                                                                        // 1803
            });                                                                                                        // 1801
                                                                                                                       //
            if (!result.ok) {                                                                                          // 1806
              return;                                                                                                  // 1807
            }                                                                                                          // 1808
                                                                                                                       //
            var newPack = result.value;                                                                                // 1810
                                                                                                                       //
            if (newPack.status === "ready") {                                                                          // 1811
              // The package was marked as ready before we applied isAutoUpdated=true. We should send                  // 1812
              // notifications ourselves to be sure there's no timing issue (sending more than one is                  // 1813
              // fine, since it will de-dupe).                                                                         // 1814
              if (pack.appId && pack.appId !== app.appId) {                                                            // 1815
                console.error("app index returned app ID and package ID that don't match:", JSON.stringify(app));      // 1816
              } else {                                                                                                 // 1818
                _this3.sendAppUpdateNotifications(app.appId, app.packageId, app.name, app.versionNumber, app.version);
                                                                                                                       //
                if (isAppPreinstalled) {                                                                               // 1821
                  _this3.setPreinstallAppAsReady(app.appId, app.packageId);                                            // 1822
                }                                                                                                      // 1823
              }                                                                                                        // 1824
            } else if (newPack.status === "failed") {                                                                  // 1825
              // If the package has failed, retry it                                                                   // 1826
              _this3.startInstall(app.packageId, url, true, true);                                                     // 1827
            }                                                                                                          // 1828
          }                                                                                                            // 1829
        } else {                                                                                                       // 1830
          _this3.startInstall(app.packageId, url, false, true);                                                        // 1831
        }                                                                                                              // 1832
      }                                                                                                                // 1833
    });                                                                                                                // 1834
  },                                                                                                                   // 1835
  isPackagePreinstalled: function (packageId) {                                                                        // 1837
    return this.collections.settings.find({                                                                            // 1838
      _id: "preinstalledApps",                                                                                         // 1838
      "value.packageId": packageId                                                                                     // 1838
    }).count() === 1;                                                                                                  // 1838
  },                                                                                                                   // 1839
  getAppIdForPreinstalledPackage: function (packageId) {                                                               // 1841
    var setting = this.collections.settings.findOne({                                                                  // 1842
      _id: "preinstalledApps",                                                                                         // 1842
      "value.packageId": packageId                                                                                     // 1842
    }, {                                                                                                               // 1842
      fields: {                                                                                                        // 1843
        "value.$": 1                                                                                                   // 1843
      }                                                                                                                // 1843
    }); // value.$ causes mongo to transform the result and only return the first matching element in                  // 1843
    // the array                                                                                                       // 1845
                                                                                                                       //
    return setting && setting.value && setting.value[0] && setting.value[0].appId;                                     // 1846
  },                                                                                                                   // 1847
  getPackageIdForPreinstalledApp: function (appId) {                                                                   // 1849
    var setting = this.collections.settings.findOne({                                                                  // 1850
      _id: "preinstalledApps",                                                                                         // 1850
      "value.appId": appId                                                                                             // 1850
    }, {                                                                                                               // 1850
      fields: {                                                                                                        // 1851
        "value.$": 1                                                                                                   // 1851
      }                                                                                                                // 1851
    }); // value.$ causes mongo to transform the result and only return the first matching element in                  // 1851
    // the array                                                                                                       // 1853
                                                                                                                       //
    return setting && setting.value && setting.value[0] && setting.value[0].packageId;                                 // 1854
  },                                                                                                                   // 1855
  getReadyPreinstalledAppIds: function () {                                                                            // 1857
    var setting = this.collections.settings.findOne({                                                                  // 1858
      _id: "preinstalledApps"                                                                                          // 1858
    });                                                                                                                // 1858
    var ret = setting && setting.value || [];                                                                          // 1859
    return _.chain(ret).filter(function (app) {                                                                        // 1860
      return app.status === "ready";                                                                                   // 1861
    }).map(function (app) {                                                                                            // 1861
      return app.appId;                                                                                                // 1862
    }).value();                                                                                                        // 1862
  },                                                                                                                   // 1864
  getAllPreinstalledAppIds: function () {                                                                              // 1866
    var setting = this.collections.settings.findOne({                                                                  // 1867
      _id: "preinstalledApps"                                                                                          // 1867
    });                                                                                                                // 1867
    var ret = setting && setting.value || [];                                                                          // 1868
    return _.map(ret, function (app) {                                                                                 // 1869
      return app.appId;                                                                                                // 1869
    });                                                                                                                // 1869
  },                                                                                                                   // 1870
  preinstallAppsForUser: function (userId) {                                                                           // 1872
    var _this4 = this;                                                                                                 // 1872
                                                                                                                       //
    var appIds = this.getReadyPreinstalledAppIds();                                                                    // 1873
    appIds.forEach(function (appId) {                                                                                  // 1874
      try {                                                                                                            // 1875
        _this4.addUserActions(userId, _this4.getPackageIdForPreinstalledApp(appId));                                   // 1876
      } catch (e) {                                                                                                    // 1877
        console.error("failed to install app for user:", e);                                                           // 1878
      }                                                                                                                // 1879
    });                                                                                                                // 1880
  },                                                                                                                   // 1881
  setPreinstallAppAsDownloading: function (appId, packageId) {                                                         // 1883
    this.collections.settings.update({                                                                                 // 1884
      _id: "preinstalledApps",                                                                                         // 1885
      "value.appId": appId,                                                                                            // 1885
      "value.packageId": packageId                                                                                     // 1885
    }, {                                                                                                               // 1885
      $set: {                                                                                                          // 1886
        "value.$.status": "downloading"                                                                                // 1886
      }                                                                                                                // 1886
    });                                                                                                                // 1886
  },                                                                                                                   // 1887
  setPreinstallAppAsReady: function (appId, packageId) {                                                               // 1889
    // This function both sets the appId as ready and updates the packageId for the given appId                        // 1890
    // Setting the packageId is especially useful in installer.js, as it always ensures the                            // 1891
    // latest installed package will be set as ready.                                                                  // 1892
    this.collections.settings.update({                                                                                 // 1893
      _id: "preinstalledApps",                                                                                         // 1894
      "value.appId": appId                                                                                             // 1894
    }, {                                                                                                               // 1894
      $set: {                                                                                                          // 1895
        "value.$.status": "ready",                                                                                     // 1895
        "value.$.packageId": packageId                                                                                 // 1895
      }                                                                                                                // 1895
    });                                                                                                                // 1895
  },                                                                                                                   // 1896
  ensureAppPreinstall: function (appId, packageId) {                                                                   // 1898
    check(appId, String);                                                                                              // 1899
    var appIndexUrl = this.collections.settings.findOne({                                                              // 1900
      _id: "appIndexUrl"                                                                                               // 1900
    }).value;                                                                                                          // 1900
    var pack = this.collections.packages.findOne({                                                                     // 1901
      _id: packageId                                                                                                   // 1901
    });                                                                                                                // 1901
    var url = appIndexUrl + "/packages/" + packageId;                                                                  // 1902
                                                                                                                       //
    if (pack && pack.status === "ready") {                                                                             // 1903
      this.setPreinstallAppAsReady(appId, packageId);                                                                  // 1904
    } else if (pack && pack.status === "failed") {                                                                     // 1905
      this.setPreinstallAppAsDownloading(appId, packageId);                                                            // 1906
      this.startInstall(packageId, url, true, false);                                                                  // 1907
    } else {                                                                                                           // 1908
      this.setPreinstallAppAsDownloading(appId, packageId);                                                            // 1909
      this.startInstall(packageId, url, false, false);                                                                 // 1910
    }                                                                                                                  // 1911
  },                                                                                                                   // 1912
  setPreinstalledApps: function (appAndPackageIds) {                                                                   // 1914
    var _this5 = this;                                                                                                 // 1914
                                                                                                                       //
    // appAndPackageIds: A List[Object] where each element has fields:                                                 // 1915
    //     appId: The Packages.appId of the app to install                                                             // 1916
    //     packageId: The Packages._id of the app to install                                                           // 1917
    check(appAndPackageIds, [{                                                                                         // 1918
      appId: String,                                                                                                   // 1918
      packageId: String                                                                                                // 1918
    }]); // Start by clearing out the setting. We'll push appIds one by one to it                                      // 1918
                                                                                                                       //
    this.collections.settings.upsert({                                                                                 // 1921
      _id: "preinstalledApps"                                                                                          // 1921
    }, {                                                                                                               // 1921
      $set: {                                                                                                          // 1921
        value: appAndPackageIds.map(function (data) {                                                                  // 1922
          return {                                                                                                     // 1923
            appId: data.appId,                                                                                         // 1924
            status: "notReady",                                                                                        // 1925
            packageId: data.packageId                                                                                  // 1926
          };                                                                                                           // 1923
        })                                                                                                             // 1928
      }                                                                                                                // 1921
    });                                                                                                                // 1921
    appAndPackageIds.forEach(function (data) {                                                                         // 1930
      _this5.ensureAppPreinstall(data.appId, data.packageId);                                                          // 1931
    });                                                                                                                // 1932
  },                                                                                                                   // 1933
  getProductivitySuiteAppIds: function () {                                                                            // 1935
    return ["8aspz4sfjnp8u89000mh2v1xrdyx97ytn8hq71mdzv4p4d8n0n3h", // Davros                                          // 1936
    "h37dm17aa89yrd8zuqpdn36p6zntumtv08fjpu8a8zrte7q1cn60", // Etherpad                                                // 1938
    "vfnwptfn02ty21w715snyyczw0nqxkv3jvawcah10c6z7hj1hnu0", // Rocket.Chat                                             // 1939
    "m86q05rdvj14yvn78ghaxynqz7u2svw6rnttptxx49g1785cdv1h"];                                                           // 1940
  },                                                                                                                   // 1942
  getSystemSuiteAppIds: function () {                                                                                  // 1944
    return ["s3u2xgmqwznz2n3apf30sm3gw1d85y029enw5pymx734cnk5n78h"];                                                   // 1945
  },                                                                                                                   // 1948
  isPreinstalledAppsReady: function () {                                                                               // 1950
    var setting = this.collections.settings.findOne({                                                                  // 1951
      _id: "preinstalledApps"                                                                                          // 1951
    });                                                                                                                // 1951
                                                                                                                       //
    if (!setting || !setting.value) {                                                                                  // 1952
      return true;                                                                                                     // 1953
    }                                                                                                                  // 1954
                                                                                                                       //
    var packageIds = _.pluck(setting.value, "packageId");                                                              // 1956
                                                                                                                       //
    var readyApps = this.collections.packages.find({                                                                   // 1957
      _id: {                                                                                                           // 1958
        $in: packageIds                                                                                                // 1959
      },                                                                                                               // 1958
      status: "ready"                                                                                                  // 1961
    });                                                                                                                // 1957
    return readyApps.count() === packageIds.length;                                                                    // 1963
  },                                                                                                                   // 1964
  getBillingPromptUrl: function () {                                                                                   // 1966
    var setting = this.collections.settings.findOne({                                                                  // 1967
      _id: "billingPromptUrl"                                                                                          // 1967
    });                                                                                                                // 1967
    return setting && setting.value;                                                                                   // 1968
  },                                                                                                                   // 1969
  isReferralEnabled: function () {                                                                                     // 1971
    // This function is a bit weird, in that we've transitioned from                                                   // 1972
    // Meteor.settings.public.quotaEnabled to DB settings. For now,                                                    // 1973
    // Meteor.settings.public.quotaEnabled implies bothisReferralEnabled and isQuotaEnabled are true.                  // 1974
    return Meteor.settings.public.quotaEnabled;                                                                        // 1975
  },                                                                                                                   // 1976
  isHideAboutEnabled: function () {                                                                                    // 1978
    var setting = this.collections.settings.findOne({                                                                  // 1979
      _id: "whiteLabelHideAbout"                                                                                       // 1979
    });                                                                                                                // 1979
    return setting && setting.value;                                                                                   // 1980
  },                                                                                                                   // 1981
  isQuotaEnabled: function () {                                                                                        // 1983
    if (Meteor.settings.public.quotaEnabled) return true;                                                              // 1984
    var setting = this.collections.settings.findOne({                                                                  // 1986
      _id: "quotaEnabled"                                                                                              // 1986
    });                                                                                                                // 1986
    return setting && setting.value;                                                                                   // 1987
  },                                                                                                                   // 1988
  isQuotaLdapEnabled: function () {                                                                                    // 1990
    var setting = this.collections.settings.findOne({                                                                  // 1991
      _id: "quotaLdapEnabled"                                                                                          // 1991
    });                                                                                                                // 1991
    return setting && setting.value;                                                                                   // 1992
  },                                                                                                                   // 1993
  updateUserQuota: function (user) {                                                                                   // 1995
    if (this.quotaManager) {                                                                                           // 1996
      return this.quotaManager.updateUserQuota(this, user);                                                            // 1997
    }                                                                                                                  // 1998
  },                                                                                                                   // 1999
  getUserQuota: function (user) {                                                                                      // 2001
    if (this.isQuotaLdapEnabled()) {                                                                                   // 2002
      return this.quotaManager.updateUserQuota(this, user);                                                            // 2003
    } else {                                                                                                           // 2004
      var plan = this.getPlan(user.plan || "free", user);                                                              // 2005
      var referralBonus = calculateReferralBonus(user);                                                                // 2006
      var bonus = user.planBonus || {};                                                                                // 2007
      var userQuota = {                                                                                                // 2008
        storage: plan.storage + referralBonus.storage + (bonus.storage || 0),                                          // 2009
        grains: plan.grains + referralBonus.grains + (bonus.grains || 0),                                              // 2010
        compute: plan.compute + (bonus.compute || 0)                                                                   // 2011
      };                                                                                                               // 2008
      return userQuota;                                                                                                // 2013
    }                                                                                                                  // 2014
  },                                                                                                                   // 2015
  isUserOverQuota: function (user) {                                                                                   // 2017
    // Return false if user has quota space remaining, true if it is full. When this returns true,                     // 2018
    // we will not allow the user to create new grains, though they may be able to open existing ones                  // 2019
    // which may still increase their storage usage.                                                                   // 2020
    //                                                                                                                 // 2021
    // (Actually returns a string which can be fed into `billingPrompt` as the reason.)                                // 2022
    if (!this.isQuotaEnabled() || user.isAdmin) return false;                                                          // 2024
    var plan = this.getUserQuota(user);                                                                                // 2026
                                                                                                                       //
    if (plan.grains < Infinity) {                                                                                      // 2027
      var count = this.collections.grains.find({                                                                       // 2028
        userId: user._id,                                                                                              // 2028
        trashed: {                                                                                                     // 2028
          $exists: false                                                                                               // 2028
        }                                                                                                              // 2028
      }, {                                                                                                             // 2028
        fields: {},                                                                                                    // 2029
        limit: plan.grains                                                                                             // 2029
      }).count();                                                                                                      // 2029
      if (count >= plan.grains) return "outOfGrains";                                                                  // 2030
    }                                                                                                                  // 2031
                                                                                                                       //
    return plan && user.storageUsage && user.storageUsage >= plan.storage && "outOfStorage";                           // 2033
  },                                                                                                                   // 2034
  isUserExcessivelyOverQuota: function (user) {                                                                        // 2036
    // Return true if user is so far over quota that we should prevent their existing grains from                      // 2037
    // running at all.                                                                                                 // 2038
    //                                                                                                                 // 2039
    // (Actually returns a string which can be fed into `billingPrompt` as the reason.)                                // 2040
    if (!this.isQuotaEnabled() || user.isAdmin) return false;                                                          // 2042
    var quota = this.getUserQuota(user); // quota.grains = Infinity means unlimited grains. IEEE754 defines Infinity == Infinity.
                                                                                                                       //
    if (quota.grains < Infinity) {                                                                                     // 2047
      var count = this.collections.grains.find({                                                                       // 2048
        userId: user._id,                                                                                              // 2048
        trashed: {                                                                                                     // 2048
          $exists: false                                                                                               // 2048
        }                                                                                                              // 2048
      }, {                                                                                                             // 2048
        fields: {},                                                                                                    // 2049
        limit: quota.grains * 2                                                                                        // 2049
      }).count();                                                                                                      // 2049
      if (count >= quota.grains * 2) return "outOfGrains";                                                             // 2050
    }                                                                                                                  // 2051
                                                                                                                       //
    return quota && user.storageUsage && user.storageUsage >= quota.storage * 1.2 && "outOfStorage";                   // 2053
  },                                                                                                                   // 2054
  suspendIdentity: function (userId, suspension) {                                                                     // 2056
    check(userId, String);                                                                                             // 2057
    check(suspension, {                                                                                                // 2058
      timestamp: Date,                                                                                                 // 2059
      admin: Match.Optional(String),                                                                                   // 2060
      voluntary: Match.Optional(Boolean)                                                                               // 2061
    });                                                                                                                // 2058
    this.collections.users.update({                                                                                    // 2064
      _id: userId                                                                                                      // 2064
    }, {                                                                                                               // 2064
      $set: {                                                                                                          // 2064
        suspended: suspension                                                                                          // 2064
      }                                                                                                                // 2064
    });                                                                                                                // 2064
    this.collections.apiTokens.update({                                                                                // 2065
      "owner.user.identityId": userId                                                                                  // 2065
    }, {                                                                                                               // 2065
      $set: {                                                                                                          // 2066
        suspended: true                                                                                                // 2066
      }                                                                                                                // 2066
    }, {                                                                                                               // 2066
      multi: true                                                                                                      // 2066
    });                                                                                                                // 2066
  },                                                                                                                   // 2067
  unsuspendIdentity: function (userId) {                                                                               // 2069
    check(userId, String);                                                                                             // 2070
    this.collections.users.update({                                                                                    // 2072
      _id: userId                                                                                                      // 2072
    }, {                                                                                                               // 2072
      $unset: {                                                                                                        // 2072
        suspended: 1                                                                                                   // 2072
      }                                                                                                                // 2072
    });                                                                                                                // 2072
    this.collections.apiTokens.update({                                                                                // 2073
      "owner.user.identityId": userId                                                                                  // 2073
    }, {                                                                                                               // 2073
      $unset: {                                                                                                        // 2074
        suspended: true                                                                                                // 2074
      }                                                                                                                // 2074
    }, {                                                                                                               // 2074
      multi: true                                                                                                      // 2074
    });                                                                                                                // 2074
  },                                                                                                                   // 2075
  suspendAccount: function (userId, byAdminUserId, willDelete) {                                                       // 2077
    var _this6 = this;                                                                                                 // 2077
                                                                                                                       //
    check(userId, String);                                                                                             // 2078
    check(byAdminUserId, Match.OneOf(String, null, undefined));                                                        // 2079
    check(willDelete, Boolean);                                                                                        // 2080
    var user = this.collections.users.findOne({                                                                        // 2082
      _id: userId                                                                                                      // 2082
    });                                                                                                                // 2082
    var suspension = {                                                                                                 // 2083
      timestamp: new Date(),                                                                                           // 2084
      willDelete: willDelete || false                                                                                  // 2085
    };                                                                                                                 // 2083
                                                                                                                       //
    if (byAdminUserId) {                                                                                               // 2087
      suspension.admin = byAdminUserId;                                                                                // 2088
    } else {                                                                                                           // 2089
      suspension.voluntary = true;                                                                                     // 2090
    }                                                                                                                  // 2091
                                                                                                                       //
    this.collections.users.update({                                                                                    // 2093
      _id: userId                                                                                                      // 2093
    }, {                                                                                                               // 2093
      $set: {                                                                                                          // 2093
        suspended: suspension                                                                                          // 2093
      }                                                                                                                // 2093
    });                                                                                                                // 2093
    this.collections.grains.update({                                                                                   // 2094
      userId: userId                                                                                                   // 2094
    }, {                                                                                                               // 2094
      $set: {                                                                                                          // 2094
        suspended: true                                                                                                // 2094
      }                                                                                                                // 2094
    }, {                                                                                                               // 2094
      multi: true                                                                                                      // 2094
    });                                                                                                                // 2094
    delete suspension.willDelete; // Only mark the parent account for deletion. This makes the query simpler later.    // 2096
                                                                                                                       //
    user.loginIdentities.forEach(function (identity) {                                                                 // 2099
      _this6.suspendIdentity(identity.id, suspension);                                                                 // 2100
    });                                                                                                                // 2101
    user.nonloginIdentities.forEach(function (identity) {                                                              // 2102
      if (_this6.collections.users.find({                                                                              // 2103
        $or: [{                                                                                                        // 2103
          "loginIdentities.id": identity.id                                                                            // 2104
        }, {                                                                                                           // 2104
          "nonloginIdentities.id": identity.id                                                                         // 2105
        }]                                                                                                             // 2105
      }).count() === 1) {                                                                                              // 2103
        // Only suspend non-login identities that are unique to this account.                                          // 2107
        _this6.suspendIdentity(identity.id, suspension);                                                               // 2108
      }                                                                                                                // 2109
    }); // Force logout this user                                                                                      // 2110
                                                                                                                       //
    this.collections.users.update({                                                                                    // 2113
      _id: userId                                                                                                      // 2113
    }, {                                                                                                               // 2113
      $unset: {                                                                                                        // 2114
        "services.resume.loginTokens": 1                                                                               // 2114
      }                                                                                                                // 2114
    });                                                                                                                // 2114
                                                                                                                       //
    if (user && user.loginIdentities) {                                                                                // 2115
      user.loginIdentities.forEach(function (identity) {                                                               // 2116
        Meteor.users.update({                                                                                          // 2117
          _id: identity.id                                                                                             // 2117
        }, {                                                                                                           // 2117
          $unset: {                                                                                                    // 2117
            "services.resume.loginTokens": 1                                                                           // 2117
          }                                                                                                            // 2117
        });                                                                                                            // 2117
      });                                                                                                              // 2118
    }                                                                                                                  // 2119
  },                                                                                                                   // 2120
  unsuspendAccount: function (userId) {                                                                                // 2122
    var _this7 = this;                                                                                                 // 2122
                                                                                                                       //
    check(userId, String);                                                                                             // 2123
    var user = this.collections.users.findOne({                                                                        // 2125
      _id: userId                                                                                                      // 2125
    });                                                                                                                // 2125
    this.collections.users.update({                                                                                    // 2126
      _id: userId                                                                                                      // 2126
    }, {                                                                                                               // 2126
      $unset: {                                                                                                        // 2126
        suspended: 1                                                                                                   // 2126
      }                                                                                                                // 2126
    });                                                                                                                // 2126
    this.collections.grains.update({                                                                                   // 2127
      userId: userId                                                                                                   // 2127
    }, {                                                                                                               // 2127
      $unset: {                                                                                                        // 2127
        suspended: 1                                                                                                   // 2127
      }                                                                                                                // 2127
    }, {                                                                                                               // 2127
      multi: true                                                                                                      // 2127
    });                                                                                                                // 2127
    user.loginIdentities.forEach(function (identity) {                                                                 // 2129
      _this7.unsuspendIdentity(identity.id);                                                                           // 2130
    });                                                                                                                // 2131
    user.nonloginIdentities.forEach(function (identity) {                                                              // 2133
      _this7.unsuspendIdentity(identity.id);                                                                           // 2134
    });                                                                                                                // 2135
  },                                                                                                                   // 2136
  deletePendingAccounts: function (deletionCoolingOffTime, backend, cb) {                                              // 2138
    var _this8 = this;                                                                                                 // 2138
                                                                                                                       //
    check(deletionCoolingOffTime, Number);                                                                             // 2139
    var queryDate = new Date(Date.now() - deletionCoolingOffTime);                                                     // 2141
    this.collections.users.find({                                                                                      // 2142
      "suspended.willDelete": true,                                                                                    // 2143
      "suspended.timestamp": {                                                                                         // 2144
        $lt: queryDate                                                                                                 // 2144
      }                                                                                                                // 2144
    }).forEach(function (user) {                                                                                       // 2142
      if (cb) cb(_this8, user);                                                                                        // 2146
                                                                                                                       //
      _this8.deleteAccount(user._id, backend);                                                                         // 2147
    });                                                                                                                // 2148
  },                                                                                                                   // 2149
  hostIsStandalone: function (hostname) {                                                                              // 2151
    check(hostname, String);                                                                                           // 2152
    return !!this.collections.standaloneDomains.findOne({                                                              // 2154
      _id: hostname                                                                                                    // 2154
    });                                                                                                                // 2154
  }                                                                                                                    // 2155
});                                                                                                                    // 1248
                                                                                                                       //
SandstormDb.escapeMongoKey = function (key) {                                                                          // 2158
  // This incredibly poor mechanism for escaping Mongo keys is recommended by the Mongo docs here:                     // 2159
  //   https://docs.mongodb.org/manual/faq/developers/#dollar-sign-operator-escaping                                   // 2160
  // and seems to be a de facto standard, for example:                                                                 // 2161
  //   https://www.npmjs.com/package/mongo-key-escape                                                                  // 2162
  return key.replace(".", "\uFF0E").replace("$", "\uFF04");                                                            // 2163
};                                                                                                                     // 2164
                                                                                                                       //
var appNameFromPackage = function (packageObj) {                                                                       // 2166
  // This function takes a Package object from Mongo and returns an                                                    // 2167
  // app title.                                                                                                        // 2168
  var manifest = packageObj.manifest;                                                                                  // 2169
  if (!manifest) return packageObj.appId || packageObj._id || "unknown";                                               // 2170
  var action = manifest.actions[0];                                                                                    // 2171
  appName = manifest.appTitle && manifest.appTitle.defaultText || appNameFromActionName(action.title.defaultText);     // 2172
  return appName;                                                                                                      // 2174
};                                                                                                                     // 2175
                                                                                                                       //
var appNameFromActionName = function (name) {                                                                          // 2177
  // Hack: Historically we only had action titles, like "New Etherpad Document", not app                               // 2178
  //   titles. But for this UI we want app titles. As a transitionary measure, try to                                  // 2179
  //   derive the app title from the action title.                                                                     // 2180
  // TODO(cleanup): Get rid of this once apps have real titles.                                                        // 2181
  if (!name) {                                                                                                         // 2182
    return "(unnamed)";                                                                                                // 2183
  }                                                                                                                    // 2184
                                                                                                                       //
  if (name.lastIndexOf("New ", 0) === 0) {                                                                             // 2186
    name = name.slice(4);                                                                                              // 2187
  }                                                                                                                    // 2188
                                                                                                                       //
  if (name.lastIndexOf("Hacker CMS", 0) === 0) {                                                                       // 2190
    name = "Hacker CMS";                                                                                               // 2191
  } else {                                                                                                             // 2192
    var space = name.indexOf(" ");                                                                                     // 2193
                                                                                                                       //
    if (space > 0) {                                                                                                   // 2194
      name = name.slice(0, space);                                                                                     // 2195
    }                                                                                                                  // 2196
  }                                                                                                                    // 2197
                                                                                                                       //
  return name;                                                                                                         // 2199
};                                                                                                                     // 2200
                                                                                                                       //
var appShortDescriptionFromPackage = function (pkg) {                                                                  // 2202
  return pkg && pkg.manifest && pkg.manifest.metadata && pkg.manifest.metadata.shortDescription && pkg.manifest.metadata.shortDescription.defaultText;
};                                                                                                                     // 2206
                                                                                                                       //
var nounPhraseForActionAndAppTitle = function (action, appTitle) {                                                     // 2208
  // A hack to deal with legacy apps not including fields in their manifests.                                          // 2209
  // I look forward to the day I can remove most of this code.                                                         // 2210
  // Attempt to figure out the appropriate noun that this action will create.                                          // 2211
  // Use an explicit noun phrase is one is available.  Apps should add these in the future.                            // 2212
  if (action.nounPhrase) return action.nounPhrase.defaultText; // Otherwise, try to guess one from the structure of the action title field
                                                                                                                       //
  if (action.title && action.title.defaultText) {                                                                      // 2215
    var text = action.title.defaultText; // Strip a leading "New "                                                     // 2216
                                                                                                                       //
    if (text.lastIndexOf("New ", 0) === 0) {                                                                           // 2218
      var candidate = text.slice(4); // Strip a leading appname too, if provided                                       // 2219
                                                                                                                       //
      if (candidate.lastIndexOf(appTitle, 0) === 0) {                                                                  // 2221
        var newCandidate = candidate.slice(appTitle.length); // Unless that leaves you with no noun, in which case, use "grain"
                                                                                                                       //
        if (newCandidate.length > 0) {                                                                                 // 2224
          return newCandidate.toLowerCase();                                                                           // 2225
        } else {                                                                                                       // 2226
          return "grain";                                                                                              // 2227
        }                                                                                                              // 2228
      }                                                                                                                // 2229
                                                                                                                       //
      return candidate.toLowerCase();                                                                                  // 2231
    } // Some other verb phrase was given.  Just use it verbatim, and hope the app author updates                      // 2232
    // the package soon.                                                                                               // 2234
                                                                                                                       //
                                                                                                                       //
    return text;                                                                                                       // 2235
  } else {                                                                                                             // 2236
    return "grain";                                                                                                    // 2237
  }                                                                                                                    // 2238
}; // Static methods on SandstormDb that don't need an instance.                                                       // 2239
// Largely things that deal with backwards-compatibility.                                                              // 2242
                                                                                                                       //
                                                                                                                       //
_.extend(SandstormDb, {                                                                                                // 2243
  appNameFromActionName: appNameFromActionName,                                                                        // 2244
  appNameFromPackage: appNameFromPackage,                                                                              // 2245
  appShortDescriptionFromPackage: appShortDescriptionFromPackage,                                                      // 2246
  nounPhraseForActionAndAppTitle: nounPhraseForActionAndAppTitle                                                       // 2247
});                                                                                                                    // 2243
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 2250
  var _Crypto2 = Npm.require("crypto");                                                                                // 2251
                                                                                                                       //
  var ContentType = Npm.require("content-type");                                                                       // 2252
                                                                                                                       //
  var Zlib = Npm.require("zlib");                                                                                      // 2253
                                                                                                                       //
  var _Url2 = Npm.require("url");                                                                                      // 2254
                                                                                                                       //
  var replicaNumber = Meteor.settings.replicaNumber || 0;                                                              // 2256
                                                                                                                       //
  var computeStagger = function (n) {                                                                                  // 2258
    // Compute a fraction in the range [0, 1) such that, for any natural number k, the values                          // 2259
    // of computeStagger(n) for all n in [1, 2^k) are uniformly distributed between 0 and 1.                           // 2260
    // The sequence looks like:                                                                                        // 2261
    //   0, 1/2, 1/4, 3/4, 1/8, 3/8, 5/8, 7/8, 1/16, ...                                                               // 2262
    //                                                                                                                 // 2263
    // We use this to determine how we'll stagger periodic events performed by this replica.                           // 2264
    // Notice that this allows us to compute a stagger which is independent of the number of                           // 2265
    // front-end replicas present; we can add more replicas to the end without affecting how the                       // 2266
    // earlier ones schedule their events.                                                                             // 2267
    var denom = 1;                                                                                                     // 2268
                                                                                                                       //
    while (denom <= n) {                                                                                               // 2269
      denom <<= 1;                                                                                                     // 2269
    }                                                                                                                  // 2269
                                                                                                                       //
    var num = n * 2 - denom + 1;                                                                                       // 2270
    return num / denom;                                                                                                // 2271
  };                                                                                                                   // 2272
                                                                                                                       //
  var stagger = computeStagger(replicaNumber);                                                                         // 2274
                                                                                                                       //
  SandstormDb.periodicCleanup = function (intervalMs, callback) {                                                      // 2276
    // Register a database cleanup function than should run periodically, roughly once every                           // 2277
    // interval of the given length.                                                                                   // 2278
    //                                                                                                                 // 2279
    // In a blackrock deployment with multiple front-ends, the frequency of the cleanup will be                        // 2280
    // scaled appropriately on the assumption that more data is being generated demanding more                         // 2281
    // frequent cleanups.                                                                                              // 2282
    check(intervalMs, Number);                                                                                         // 2284
    check(callback, Function);                                                                                         // 2285
                                                                                                                       //
    if (intervalMs < 120000) {                                                                                         // 2287
      throw new Error("less than 2-minute cleanup interval seems too fast; " + "are you using the right units?");      // 2288
    } // Schedule first cleanup to happen at the next intervalMs interval from the epoch, so that                      // 2290
    // the schedule is independent of the exact startup time.                                                          // 2293
                                                                                                                       //
                                                                                                                       //
    var first = intervalMs - Date.now() % intervalMs; // Stagger cleanups across replicas so that we don't have all replicas trying to clean the
    // same data at the same time.                                                                                     // 2297
                                                                                                                       //
    first += Math.floor(intervalMs * computeStagger(replicaNumber)); // If the stagger put us more than an interval away from now, back up.
                                                                                                                       //
    if (first > intervalMs) first -= intervalMs;                                                                       // 2301
    Meteor.setTimeout(function () {                                                                                    // 2303
      callback();                                                                                                      // 2304
      Meteor.setInterval(callback, intervalMs);                                                                        // 2305
    }, first);                                                                                                         // 2306
  }; // TODO(cleanup): Node 0.12 has a `gzipSync` but 0.10 (which Meteor still uses) does not.                         // 2307
                                                                                                                       //
                                                                                                                       //
  var gzipSync = Meteor.wrapAsync(Zlib.gzip, Zlib);                                                                    // 2310
                                                                                                                       //
  var BufferSmallerThan = function (limit) {                                                                           // 2312
    return Match.Where(function (buf) {                                                                                // 2313
      check(buf, Buffer);                                                                                              // 2314
      return buf.length < limit;                                                                                       // 2315
    });                                                                                                                // 2316
  };                                                                                                                   // 2317
                                                                                                                       //
  var DatabaseId = Match.Where(function (s) {                                                                          // 2319
    check(s, String);                                                                                                  // 2320
    return !!s.match(/^[a-zA-Z0-9_]+$/);                                                                               // 2321
  });                                                                                                                  // 2322
                                                                                                                       //
  SandstormDb.prototype.addStaticAsset = function (metadata, content) {                                                // 2324
    // Add a new static asset to the database. If `content` is a string rather than a buffer, it                       // 2325
    // will be automatically gzipped before storage; do not specify metadata.encoding in this case.                    // 2326
    if (typeof content === "string" && !metadata.encoding) {                                                           // 2328
      content = gzipSync(new Buffer(content, "utf8"));                                                                 // 2329
      metadata.encoding = "gzip";                                                                                      // 2330
    }                                                                                                                  // 2331
                                                                                                                       //
    check(metadata, {                                                                                                  // 2333
      mimeType: String,                                                                                                // 2334
      encoding: Match.Optional("gzip")                                                                                 // 2335
    });                                                                                                                // 2333
    check(content, BufferSmallerThan(1 << 20)); // Validate content type.                                              // 2337
                                                                                                                       //
    metadata.mimeType = ContentType.format(ContentType.parse(metadata.mimeType));                                      // 2340
                                                                                                                       //
    var hasher = _Crypto2.createHash("sha256");                                                                        // 2342
                                                                                                                       //
    hasher.update(metadata.mimeType + "\n" + metadata.encoding + "\n", "utf8");                                        // 2343
    hasher.update(content);                                                                                            // 2344
    var hash = hasher.digest("base64");                                                                                // 2345
    var result = this.collections.staticAssets.findAndModify({                                                         // 2347
      query: {                                                                                                         // 2348
        hash: hash,                                                                                                    // 2348
        refcount: {                                                                                                    // 2348
          $gte: 1                                                                                                      // 2348
        }                                                                                                              // 2348
      },                                                                                                               // 2348
      update: {                                                                                                        // 2349
        $inc: {                                                                                                        // 2349
          refcount: 1                                                                                                  // 2349
        }                                                                                                              // 2349
      },                                                                                                               // 2349
      fields: {                                                                                                        // 2350
        _id: 1,                                                                                                        // 2350
        refcount: 1                                                                                                    // 2350
      }                                                                                                                // 2350
    });                                                                                                                // 2347
                                                                                                                       //
    if (!result.ok) {                                                                                                  // 2353
      throw new Error("Couldn't increment refcount of asset with hash " + hash);                                       // 2354
    }                                                                                                                  // 2355
                                                                                                                       //
    var existing = result.value;                                                                                       // 2357
                                                                                                                       //
    if (existing) {                                                                                                    // 2358
      return existing._id;                                                                                             // 2359
    }                                                                                                                  // 2360
                                                                                                                       //
    return this.collections.staticAssets.insert(_.extend({                                                             // 2362
      hash: hash,                                                                                                      // 2363
      content: content,                                                                                                // 2364
      refcount: 1                                                                                                      // 2365
    }, metadata));                                                                                                     // 2362
  };                                                                                                                   // 2367
                                                                                                                       //
  SandstormDb.prototype.refStaticAsset = function (id) {                                                               // 2369
    // Increment the refcount on an existing static asset. Returns the asset on success.                               // 2370
    // If the asset does not exist, returns a falsey value.                                                            // 2371
    //                                                                                                                 // 2372
    // You must call this BEFORE adding the new reference to the DB, in case of failure between                        // 2373
    // the two calls. (This way, the failure case is a storage leak, which is probably not a big                       // 2374
    // deal and can be fixed by GC, rather than a mysteriously missing asset.)                                         // 2375
    check(id, String);                                                                                                 // 2377
    var result = this.collections.staticAssets.findAndModify({                                                         // 2379
      query: {                                                                                                         // 2380
        hash: hash                                                                                                     // 2380
      },                                                                                                               // 2380
      update: {                                                                                                        // 2381
        $inc: {                                                                                                        // 2381
          refcount: 1                                                                                                  // 2381
        }                                                                                                              // 2381
      },                                                                                                               // 2381
      fields: {                                                                                                        // 2382
        _id: 1,                                                                                                        // 2382
        content: 1,                                                                                                    // 2382
        mimeType: 1                                                                                                    // 2382
      }                                                                                                                // 2382
    });                                                                                                                // 2379
                                                                                                                       //
    if (!result.ok) {                                                                                                  // 2385
      throw new Error("Couldn't increment refcount of asset with hash " + hash);                                       // 2386
    }                                                                                                                  // 2387
                                                                                                                       //
    var existing = result.value;                                                                                       // 2389
    return existing;                                                                                                   // 2390
  };                                                                                                                   // 2391
                                                                                                                       //
  SandstormDb.prototype.unrefStaticAsset = function (id) {                                                             // 2393
    // Decrement refcount on a static asset and delete if it has reached zero.                                         // 2394
    //                                                                                                                 // 2395
    // You must call this AFTER removing the reference from the DB, in case of failure between                         // 2396
    // the two calls. (This way, the failure case is a storage leak, which is probably not a big                       // 2397
    // deal and can be fixed by GC, rather than a mysteriously missing asset.)                                         // 2398
    check(id, String);                                                                                                 // 2400
    var result = this.collections.staticAssets.findAndModify({                                                         // 2402
      query: {                                                                                                         // 2403
        _id: id                                                                                                        // 2403
      },                                                                                                               // 2403
      update: {                                                                                                        // 2404
        $inc: {                                                                                                        // 2404
          refcount: -1                                                                                                 // 2404
        }                                                                                                              // 2404
      },                                                                                                               // 2404
      fields: {                                                                                                        // 2405
        _id: 1,                                                                                                        // 2405
        refcount: 1                                                                                                    // 2405
      },                                                                                                               // 2405
      "new": true                                                                                                      // 2406
    });                                                                                                                // 2402
                                                                                                                       //
    if (!result.ok) {                                                                                                  // 2409
      throw new Error("Couldn't unref static asset " + id);                                                            // 2410
    }                                                                                                                  // 2411
                                                                                                                       //
    var existing = result.value;                                                                                       // 2413
                                                                                                                       //
    if (!existing) {                                                                                                   // 2414
      console.error(new Error("unrefStaticAsset() called on asset that doesn't exist").stack);                         // 2415
    } else if (existing.refcount <= 0) {                                                                               // 2416
      this.collections.staticAssets.remove({                                                                           // 2417
        _id: existing._id                                                                                              // 2417
      });                                                                                                              // 2417
    }                                                                                                                  // 2418
  };                                                                                                                   // 2419
                                                                                                                       //
  SandstormDb.prototype.getStaticAsset = function (id) {                                                               // 2421
    // Get a static asset's mimeType, encoding, and raw content.                                                       // 2422
    check(id, String);                                                                                                 // 2424
    var asset = this.collections.staticAssets.findOne(id, {                                                            // 2426
      fields: {                                                                                                        // 2426
        _id: 0,                                                                                                        // 2426
        mimeType: 1,                                                                                                   // 2426
        encoding: 1,                                                                                                   // 2426
        content: 1                                                                                                     // 2426
      }                                                                                                                // 2426
    });                                                                                                                // 2426
                                                                                                                       //
    if (asset) {                                                                                                       // 2427
      // TODO(perf): Mongo converts buffers to something else. Figure out a way to avoid a copy                        // 2428
      //   here.                                                                                                       // 2429
      asset.content = new Buffer(asset.content);                                                                       // 2430
    }                                                                                                                  // 2431
                                                                                                                       //
    return asset;                                                                                                      // 2433
  };                                                                                                                   // 2434
                                                                                                                       //
  SandstormDb.prototype.newAssetUpload = function (purpose) {                                                          // 2436
    check(purpose, Match.OneOf({                                                                                       // 2437
      profilePicture: {                                                                                                // 2438
        userId: DatabaseId,                                                                                            // 2438
        identityId: DatabaseId                                                                                         // 2438
      }                                                                                                                // 2438
    }, {                                                                                                               // 2438
      loginLogo: {}                                                                                                    // 2439
    }));                                                                                                               // 2439
    return this.collections.assetUploadTokens.insert({                                                                 // 2442
      purpose: purpose,                                                                                                // 2443
      expires: new Date(Date.now() + 300000)                                                                           // 2444
    });                                                                                                                // 2442
  };                                                                                                                   // 2446
                                                                                                                       //
  SandstormDb.prototype.fulfillAssetUpload = function (id) {                                                           // 2448
    // Indicates that the given asset upload has completed. It will be removed and its purpose                         // 2449
    // returned. If no matching upload exists, returns undefined.                                                      // 2450
    check(id, String);                                                                                                 // 2452
    var result = this.collections.assetUploadTokens.findAndModify({                                                    // 2454
      query: {                                                                                                         // 2455
        _id: id                                                                                                        // 2455
      },                                                                                                               // 2455
      remove: true                                                                                                     // 2456
    });                                                                                                                // 2454
                                                                                                                       //
    if (!result.ok) {                                                                                                  // 2459
      throw new Error("Failed to remove asset upload token");                                                          // 2460
    }                                                                                                                  // 2461
                                                                                                                       //
    var upload = result.value;                                                                                         // 2463
                                                                                                                       //
    if (upload.expires.valueOf() < Date.now()) {                                                                       // 2465
      return undefined; // already expired                                                                             // 2466
    } else {                                                                                                           // 2467
      return upload.purpose;                                                                                           // 2468
    }                                                                                                                  // 2469
  };                                                                                                                   // 2470
                                                                                                                       //
  SandstormDb.prototype.cleanupExpiredAssetUploads = function () {                                                     // 2472
    this.collections.assetUploadTokens.remove({                                                                        // 2473
      expires: {                                                                                                       // 2473
        $lt: Date.now()                                                                                                // 2473
      }                                                                                                                // 2473
    });                                                                                                                // 2473
  }; // TODO(cleanup): lift this out of the package so it can share with the ones in async-helpers.js                  // 2474
                                                                                                                       //
                                                                                                                       //
  var Future = Npm.require("fibers/future");                                                                           // 2477
                                                                                                                       //
  var promiseToFuture = function (promise) {                                                                           // 2478
    var result = new Future();                                                                                         // 2479
    promise.then(result.return.bind(result), result.throw.bind(result));                                               // 2480
    return result;                                                                                                     // 2481
  };                                                                                                                   // 2482
                                                                                                                       //
  var waitPromise = function (promise) {                                                                               // 2484
    return promiseToFuture(promise).wait();                                                                            // 2485
  };                                                                                                                   // 2486
                                                                                                                       //
  SandstormDb.prototype.deleteGrains = function (query, backend, type) {                                               // 2488
    var _this9 = this;                                                                                                 // 2488
                                                                                                                       //
    // Returns the number of grains deleted.                                                                           // 2489
    check(type, Match.OneOf("grain", "demoGrain"));                                                                    // 2491
    var numDeleted = 0;                                                                                                // 2493
    this.collections.grains.find(query).forEach(function (grain) {                                                     // 2494
      var user = Meteor.users.findOne(grain.userId);                                                                   // 2495
      waitPromise(backend.deleteGrain(grain._id, grain.userId));                                                       // 2497
      numDeleted += _this9.collections.grains.remove({                                                                 // 2498
        _id: grain._id                                                                                                 // 2498
      });                                                                                                              // 2498
                                                                                                                       //
      _this9.removeApiTokens({                                                                                         // 2499
        grainId: grain._id,                                                                                            // 2500
        $or: [{                                                                                                        // 2501
          owner: {                                                                                                     // 2502
            $exists: false                                                                                             // 2502
          }                                                                                                            // 2502
        }, {                                                                                                           // 2502
          owner: {                                                                                                     // 2503
            webkey: null                                                                                               // 2503
          }                                                                                                            // 2503
        }]                                                                                                             // 2503
      });                                                                                                              // 2499
                                                                                                                       //
      _this9.removeApiTokens({                                                                                         // 2507
        "owner.grain.grainId": grain._id                                                                               // 2507
      });                                                                                                              // 2507
                                                                                                                       //
      _this9.collections.activitySubscriptions.remove({                                                                // 2509
        grainId: grain._id                                                                                             // 2509
      });                                                                                                              // 2509
                                                                                                                       //
      if (grain.lastUsed) {                                                                                            // 2511
        var record = {                                                                                                 // 2512
          type: "grain",                                                                                               // 2513
          // Demo grains can never get here!                                                                           // 2513
          lastActive: grain.lastUsed,                                                                                  // 2514
          appId: grain.appId                                                                                           // 2515
        };                                                                                                             // 2512
                                                                                                                       //
        if (user && user.experiments) {                                                                                // 2517
          record.experiments = user.experiments;                                                                       // 2518
        }                                                                                                              // 2519
                                                                                                                       //
        _this9.collections.deleteStats.insert(record);                                                                 // 2521
      }                                                                                                                // 2522
                                                                                                                       //
      _this9.deleteUnusedPackages(grain.appId);                                                                        // 2524
                                                                                                                       //
      if (grain.size) {                                                                                                // 2526
        Meteor.users.update(grain.userId, {                                                                            // 2527
          $inc: {                                                                                                      // 2527
            storageUsage: -grain.size                                                                                  // 2527
          }                                                                                                            // 2527
        });                                                                                                            // 2527
      }                                                                                                                // 2528
    });                                                                                                                // 2529
    return numDeleted;                                                                                                 // 2530
  };                                                                                                                   // 2531
                                                                                                                       //
  SandstormDb.prototype.userGrainTitle = function (grainId, accountId, identityId) {                                   // 2533
    check(grainId, String);                                                                                            // 2534
    check(accountId, Match.OneOf(String, undefined, null));                                                            // 2535
    check(identityId, String);                                                                                         // 2536
    var grain = this.getGrain(grainId);                                                                                // 2538
                                                                                                                       //
    if (!grain) {                                                                                                      // 2539
      throw new Error("called userGrainTitle() for a grain that doesn't exist");                                       // 2540
    }                                                                                                                  // 2541
                                                                                                                       //
    var title = grain.title;                                                                                           // 2543
                                                                                                                       //
    if (grain.userId !== accountId) {                                                                                  // 2544
      var sharerToken = this.collections.apiTokens.findOne({                                                           // 2545
        grainId: grainId,                                                                                              // 2546
        "owner.user.identityId": identityId                                                                            // 2547
      }, {                                                                                                             // 2545
        sort: {                                                                                                        // 2549
          lastUsed: -1                                                                                                 // 2550
        }                                                                                                              // 2549
      });                                                                                                              // 2548
                                                                                                                       //
      if (sharerToken) {                                                                                               // 2553
        title = sharerToken.owner.user.title;                                                                          // 2554
      } else {                                                                                                         // 2555
        title = "shared grain";                                                                                        // 2556
      }                                                                                                                // 2557
    }                                                                                                                  // 2558
                                                                                                                       //
    return title;                                                                                                      // 2560
  };                                                                                                                   // 2561
                                                                                                                       //
  var packageCache = {}; // Package info is immutable. Let's cache to save on mongo queries.                           // 2563
                                                                                                                       //
  SandstormDb.prototype.getPackage = function (packageId) {                                                            // 2566
    // Get the given package record. Since package info is immutable, cache the data in the server                     // 2567
    // to reduce mongo query overhead, since it turns out we have to fetch specific packages a                         // 2568
    // lot.                                                                                                            // 2569
    if (packageId in packageCache) {                                                                                   // 2571
      return packageCache[packageId];                                                                                  // 2572
    }                                                                                                                  // 2573
                                                                                                                       //
    var pkg = this.collections.packages.findOne(packageId);                                                            // 2575
                                                                                                                       //
    if (pkg && pkg.status === "ready") {                                                                               // 2576
      packageCache[packageId] = pkg;                                                                                   // 2577
    }                                                                                                                  // 2578
                                                                                                                       //
    return pkg;                                                                                                        // 2580
  };                                                                                                                   // 2581
                                                                                                                       //
  SandstormDb.prototype.deleteUnusedPackages = function (appId) {                                                      // 2583
    var _this10 = this;                                                                                                // 2583
                                                                                                                       //
    check(appId, String);                                                                                              // 2584
    this.collections.packages.find({                                                                                   // 2585
      appId: appId                                                                                                     // 2585
    }).forEach(function (pkg) {                                                                                        // 2585
      // Mark package for possible deletion;                                                                           // 2586
      _this10.collections.packages.update({                                                                            // 2587
        _id: pkg._id,                                                                                                  // 2587
        status: "ready"                                                                                                // 2587
      }, {                                                                                                             // 2587
        $set: {                                                                                                        // 2587
          shouldCleanup: true                                                                                          // 2587
        }                                                                                                              // 2587
      });                                                                                                              // 2587
    });                                                                                                                // 2588
  };                                                                                                                   // 2589
                                                                                                                       //
  SandstormDb.prototype.sendAppUpdateNotifications = function (appId, packageId, name, versionNumber, marketingVersion) {
    var _this11 = this;                                                                                                // 2592
                                                                                                                       //
    var actions = this.collections.userActions.find({                                                                  // 2593
      appId: appId,                                                                                                    // 2593
      appVersion: {                                                                                                    // 2593
        $lt: versionNumber                                                                                             // 2593
      }                                                                                                                // 2593
    }, {                                                                                                               // 2593
      fields: {                                                                                                        // 2594
        userId: 1                                                                                                      // 2594
      }                                                                                                                // 2594
    });                                                                                                                // 2594
    actions.forEach(function (action) {                                                                                // 2595
      var userId = action.userId;                                                                                      // 2596
      var updater = {                                                                                                  // 2597
        timestamp: new Date(),                                                                                         // 2598
        isUnread: true                                                                                                 // 2599
      };                                                                                                               // 2597
                                                                                                                       //
      var inserter = _.extend({                                                                                        // 2601
        userId: userId,                                                                                                // 2601
        appUpdates: {}                                                                                                 // 2601
      }, updater); // Set only the appId that we care about. Use mongo's dot notation to specify only a single         // 2601
      // field inside of an object to update                                                                           // 2604
                                                                                                                       //
                                                                                                                       //
      inserter.appUpdates[appId] = updater["appUpdates." + appId] = {                                                  // 2605
        marketingVersion: marketingVersion,                                                                            // 2606
        packageId: packageId,                                                                                          // 2607
        name: name,                                                                                                    // 2608
        version: versionNumber                                                                                         // 2609
      }; // We unfortunately cannot upsert because upserts can only have field equality conditions in                  // 2605
      // the query. If we try to upsert, Mongo complaints that "$exists" isn't valid to store.                         // 2613
                                                                                                                       //
      if (_this11.collections.notifications.update({                                                                   // 2614
        userId: userId,                                                                                                // 2615
        appUpdates: {                                                                                                  // 2615
          $exists: true                                                                                                // 2615
        }                                                                                                              // 2615
      }, {                                                                                                             // 2615
        $set: updater                                                                                                  // 2616
      }) == 0) {                                                                                                       // 2616
        // Update failed; try an insert instead.                                                                       // 2617
        _this11.collections.notifications.insert(inserter);                                                            // 2618
      }                                                                                                                // 2619
    });                                                                                                                // 2620
    this.collections.appIndex.update({                                                                                 // 2622
      _id: appId                                                                                                       // 2622
    }, {                                                                                                               // 2622
      $set: {                                                                                                          // 2622
        hasSentNotifications: true                                                                                     // 2622
      }                                                                                                                // 2622
    }); // In the case where we replaced a previous notification and that was the only reference to the                // 2622
    // package, we need to clean it up                                                                                 // 2625
                                                                                                                       //
    this.deleteUnusedPackages(appId);                                                                                  // 2626
  };                                                                                                                   // 2627
                                                                                                                       //
  SandstormDb.prototype.sendReferralProgramNotification = function (userId) {                                          // 2629
    this.collections.notifications.upsert({                                                                            // 2630
      userId: userId,                                                                                                  // 2631
      referral: true                                                                                                   // 2632
    }, {                                                                                                               // 2630
      userId: userId,                                                                                                  // 2634
      referral: true,                                                                                                  // 2635
      timestamp: new Date(),                                                                                           // 2636
      isUnread: true                                                                                                   // 2637
    });                                                                                                                // 2633
  };                                                                                                                   // 2639
                                                                                                                       //
  SandstormDb.prototype.upgradeGrains = function (appId, version, packageId, backend) {                                // 2641
    check(appId, String);                                                                                              // 2642
    check(version, Match.Integer);                                                                                     // 2643
    check(packageId, String);                                                                                          // 2644
    var selector = {                                                                                                   // 2646
      userId: Meteor.userId(),                                                                                         // 2647
      appId: appId,                                                                                                    // 2648
      appVersion: {                                                                                                    // 2649
        $lte: version                                                                                                  // 2649
      },                                                                                                               // 2649
      packageId: {                                                                                                     // 2650
        $ne: packageId                                                                                                 // 2650
      }                                                                                                                // 2650
    };                                                                                                                 // 2646
    this.collections.grains.find(selector).forEach(function (grain) {                                                  // 2653
      backend.shutdownGrain(grain._id, grain.userId);                                                                  // 2654
    });                                                                                                                // 2655
    this.collections.grains.update(selector, {                                                                         // 2657
      $set: {                                                                                                          // 2658
        appVersion: version,                                                                                           // 2658
        packageId: packageId,                                                                                          // 2658
        packageSalt: Random.secret()                                                                                   // 2658
      }                                                                                                                // 2658
    }, {                                                                                                               // 2657
      multi: true                                                                                                      // 2659
    });                                                                                                                // 2659
  };                                                                                                                   // 2660
                                                                                                                       //
  SandstormDb.prototype.startInstall = function (packageId, url, retryFailed, isAutoUpdated) {                         // 2662
    // Mark package for possible installation.                                                                         // 2663
    var fields = {                                                                                                     // 2665
      status: "download",                                                                                              // 2666
      progress: 0,                                                                                                     // 2667
      url: url,                                                                                                        // 2668
      isAutoUpdated: !!isAutoUpdated                                                                                   // 2669
    };                                                                                                                 // 2665
                                                                                                                       //
    if (retryFailed) {                                                                                                 // 2672
      this.collections.packages.update({                                                                               // 2673
        _id: packageId,                                                                                                // 2673
        status: "failed"                                                                                               // 2673
      }, {                                                                                                             // 2673
        $set: fields                                                                                                   // 2673
      });                                                                                                              // 2673
    } else {                                                                                                           // 2674
      try {                                                                                                            // 2675
        fields._id = packageId;                                                                                        // 2676
        this.collections.packages.insert(fields);                                                                      // 2677
      } catch (err) {                                                                                                  // 2678
        console.error("Simultaneous startInstall()s?", err.stack);                                                     // 2679
      }                                                                                                                // 2680
    }                                                                                                                  // 2681
  };                                                                                                                   // 2682
                                                                                                                       //
  var ValidKeyFingerprint = Match.Where(function (keyFingerprint) {                                                    // 2684
    check(keyFingerprint, String);                                                                                     // 2685
    return !!keyFingerprint.match(/^[0-9A-F]{40}$/);                                                                   // 2686
  });                                                                                                                  // 2687
                                                                                                                       //
  SandstormDb.prototype.updateKeybaseProfileAsync = function (keyFingerprint) {                                        // 2689
    var _this12 = this;                                                                                                // 2689
                                                                                                                       //
    // Asynchronously fetch the given Keybase profile and populate the KeybaseProfiles collection.                     // 2690
    check(keyFingerprint, ValidKeyFingerprint);                                                                        // 2692
    console.log("fetching keybase", keyFingerprint);                                                                   // 2694
    HTTP.get("https://keybase.io/_/api/1.0/user/lookup.json?key_fingerprint=" + keyFingerprint + "&fields=basics,profile,proofs_summary", {
      timeout: 5000                                                                                                    // 2699
    }, function (err, keybaseResponse) {                                                                               // 2698
      if (err) {                                                                                                       // 2701
        console.log("keybase lookup error:", err.stack);                                                               // 2702
        return;                                                                                                        // 2703
      }                                                                                                                // 2704
                                                                                                                       //
      if (!keybaseResponse.data) {                                                                                     // 2706
        console.log("keybase didn't return JSON? Headers:", keybaseResponse.headers);                                  // 2707
        return;                                                                                                        // 2708
      }                                                                                                                // 2709
                                                                                                                       //
      var profile = (keybaseResponse.data.them || [])[0];                                                              // 2711
                                                                                                                       //
      if (profile) {                                                                                                   // 2713
        // jscs:disable requireCamelCaseOrUpperCaseIdentifiers                                                         // 2714
        var record = {                                                                                                 // 2715
          displayName: (profile.profile || {}).full_name,                                                              // 2716
          handle: (profile.basics || {}).username,                                                                     // 2717
          proofs: (profile.proofs_summary || {}).all || []                                                             // 2718
        }; // jscs:enable requireCamelCaseOrUpperCaseIdentifiers                                                       // 2715
                                                                                                                       //
        record.proofs.forEach(function (proof) {                                                                       // 2722
          // Remove potentially Mongo-incompatible stuff. (Currently Keybase returns nothing that                      // 2723
          // this would filter.)                                                                                       // 2724
          for (var field in meteorBabelHelpers.sanitizeForInObject(proof)) {                                           // 2725
            // Don't allow field names containing '.' or '$'. Also don't allow sub-objects mainly                      // 2726
            // because I'm too lazy to check the field names recursively (and Keybase doesn't                          // 2727
            // return any objects anyway).                                                                             // 2728
            if (field.match(/[.$]/) || (0, _typeof3.default)(proof[field]) === "object") {                             // 2729
              delete proof[field];                                                                                     // 2730
            }                                                                                                          // 2731
          } // Indicate not verified.                                                                                  // 2732
          // TODO(security): Asynchronously verify proofs. Presumably we can borrow code from the                      // 2735
          //   Keybase node-based CLI.                                                                                 // 2736
                                                                                                                       //
                                                                                                                       //
          proof.status = "unverified";                                                                                 // 2737
        });                                                                                                            // 2738
                                                                                                                       //
        _this12.collections.keybaseProfiles.update(keyFingerprint, {                                                   // 2740
          $set: record                                                                                                 // 2740
        }, {                                                                                                           // 2740
          upsert: true                                                                                                 // 2740
        });                                                                                                            // 2740
      } else {                                                                                                         // 2741
        // Keybase reports no match, so remove what we know of this user. We don't want to remove                      // 2742
        // the item entirely from the cache as this will cause us to repeatedly re-fetch the data                      // 2743
        // from Keybase.                                                                                               // 2744
        //                                                                                                             // 2745
        // TODO(someday): We could perhaps keep the proofs if we can still verify them directly,                       // 2746
        //   but at present we don't have the ability to verify proofs.                                                // 2747
        _this12.collections.keybaseProfiles.update(keyFingerprint, {                                                   // 2748
          $unset: {                                                                                                    // 2749
            displayName: "",                                                                                           // 2749
            handle: "",                                                                                                // 2749
            proofs: ""                                                                                                 // 2749
          }                                                                                                            // 2749
        }, {                                                                                                           // 2749
          upsert: true                                                                                                 // 2749
        });                                                                                                            // 2749
      }                                                                                                                // 2750
    });                                                                                                                // 2751
  };                                                                                                                   // 2752
                                                                                                                       //
  SandstormDb.prototype.deleteUnusedAccount = function (backend, identityId) {                                         // 2754
    // If there is an *unused* account that has `identityId` as a login identity, deletes it.                          // 2755
    check(identityId, String);                                                                                         // 2757
    var account = this.collections.users.findOne({                                                                     // 2758
      "loginIdentities.id": identityId                                                                                 // 2758
    });                                                                                                                // 2758
                                                                                                                       //
    if (account && account.loginIdentities.length == 1 && account.nonloginIdentities.length == 0 && !this.collections.grains.findOne({
      userId: account._id                                                                                              // 2762
    }) && !this.collections.apiTokens.findOne({                                                                        // 2762
      accountId: account._id                                                                                           // 2763
    }) && (!account.plan || account.plan === "free") && !(account.payments && account.payments.id) && !this.collections.contacts.findOne({
      ownerId: account._id                                                                                             // 2766
    })) {                                                                                                              // 2766
      this.collections.users.remove({                                                                                  // 2767
        _id: account._id                                                                                               // 2767
      });                                                                                                              // 2767
      backend.deleteUser(account._id);                                                                                 // 2768
    }                                                                                                                  // 2769
  };                                                                                                                   // 2770
                                                                                                                       //
  Meteor.publish("keybaseProfile", function (keyFingerprint) {                                                         // 2772
    check(keyFingerprint, ValidKeyFingerprint);                                                                        // 2773
    var db = this.connection.sandstormDb;                                                                              // 2774
    var cursor = db.collections.keybaseProfiles.find(keyFingerprint);                                                  // 2776
                                                                                                                       //
    if (cursor.count() === 0) {                                                                                        // 2777
      // Fire off async update.                                                                                        // 2778
      db.updateKeybaseProfileAsync(keyFingerprint);                                                                    // 2779
    }                                                                                                                  // 2780
                                                                                                                       //
    return cursor;                                                                                                     // 2782
  });                                                                                                                  // 2783
  Meteor.publish("appIndex", function (appId) {                                                                        // 2785
    check(appId, String);                                                                                              // 2786
    var db = this.connection.sandstormDb;                                                                              // 2787
    var cursor = db.collections.appIndex.find({                                                                        // 2788
      _id: appId                                                                                                       // 2788
    });                                                                                                                // 2788
    return cursor;                                                                                                     // 2789
  });                                                                                                                  // 2790
  Meteor.publish("userPackages", function () {                                                                         // 2792
    var _this13 = this;                                                                                                // 2792
                                                                                                                       //
    // Users should be able to see packages that are either:                                                           // 2793
    // 1. referenced by one of their userActions                                                                       // 2794
    // 2. referenced by one of their grains                                                                            // 2795
    var db = this.connection.sandstormDb; // Note that package information, once it is in the database, is static. There's no need to
    // reactively subscribe to changes to a package since they don't change. It's also unecessary                      // 2799
    // to reactively remove a package from the client side when it is removed on the server, or                        // 2800
    // when the client stops using it, because the worst case is the client has a small amount                         // 2801
    // of extra info on a no-longer-used package held in memory until they refresh Sandstorm.                          // 2802
    // So, we implement this as a cache: the first time each package ID shows up among the user's                      // 2803
    // stuff, we push the package info to the client, and then we never update it.                                     // 2804
    //                                                                                                                 // 2805
    // Alternatively, we could subscribe to each individual package query, but this would waste                        // 2806
    // lots of server-side resources watching for events that will never happen or don't matter.                       // 2807
                                                                                                                       //
    var hasPackage = {};                                                                                               // 2808
                                                                                                                       //
    var refPackage = function (packageId) {                                                                            // 2809
      // Ignore dev apps.                                                                                              // 2810
      if (packageId.lastIndexOf("dev-", 0) === 0) return;                                                              // 2811
                                                                                                                       //
      if (!hasPackage[packageId]) {                                                                                    // 2813
        hasPackage[packageId] = true;                                                                                  // 2814
        var pkg = db.getPackage(packageId);                                                                            // 2815
                                                                                                                       //
        if (pkg) {                                                                                                     // 2816
          _this13.added("packages", packageId, pkg);                                                                   // 2817
        } else {                                                                                                       // 2818
          console.error("shouldn't happen: missing package referenced by user's stuff:", packageId);                   // 2819
        }                                                                                                              // 2821
      }                                                                                                                // 2822
    }; // package source 1: packages referred to by actions                                                            // 2823
                                                                                                                       //
                                                                                                                       //
    var actions = db.userActions(this.userId);                                                                         // 2826
    var actionsHandle = actions.observe({                                                                              // 2827
      added: function (newAction) {                                                                                    // 2828
        refPackage(newAction.packageId);                                                                               // 2829
      },                                                                                                               // 2830
      changed: function (newAction, oldAction) {                                                                       // 2832
        refPackage(newAction.packageId);                                                                               // 2833
      }                                                                                                                // 2834
    }); // package source 2: packages referred to by grains directly                                                   // 2827
                                                                                                                       //
    var grains = db.userGrains(this.userId, {                                                                          // 2838
      includeTrash: true                                                                                               // 2838
    });                                                                                                                // 2838
    var grainsHandle = grains.observe({                                                                                // 2839
      added: function (newGrain) {                                                                                     // 2840
        // Watch out: DevApp grains can lack a packageId.                                                              // 2841
        if (newGrain.packageId) {                                                                                      // 2842
          refPackage(newGrain.packageId);                                                                              // 2843
        }                                                                                                              // 2844
      },                                                                                                               // 2845
      changed: function (newGrain, oldGrain) {                                                                         // 2847
        // Watch out: DevApp grains can lack a packageId.                                                              // 2848
        if (newGrain.packageId) {                                                                                      // 2849
          refPackage(newGrain.packageId);                                                                              // 2850
        }                                                                                                              // 2851
      }                                                                                                                // 2852
    });                                                                                                                // 2839
    this.onStop(function () {                                                                                          // 2855
      actionsHandle.stop();                                                                                            // 2856
      grainsHandle.stop();                                                                                             // 2857
    });                                                                                                                // 2858
    this.ready();                                                                                                      // 2860
  });                                                                                                                  // 2861
}                                                                                                                      // 2862
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 2864
  SandstormDb.prototype.deleteIdentity = function (identityId) {                                                       // 2865
    check(identityId, String);                                                                                         // 2866
    this.removeApiTokens({                                                                                             // 2868
      "owner.user.identityId": identityId                                                                              // 2868
    });                                                                                                                // 2868
    this.collections.contacts.remove({                                                                                 // 2869
      identityId: identityId                                                                                           // 2869
    });                                                                                                                // 2869
    Meteor.users.remove({                                                                                              // 2870
      _id: identityId                                                                                                  // 2870
    });                                                                                                                // 2870
  };                                                                                                                   // 2871
                                                                                                                       //
  SandstormDb.prototype.deleteAccount = function (userId, backend) {                                                   // 2873
    check(userId, String);                                                                                             // 2874
                                                                                                                       //
    var _this = this;                                                                                                  // 2876
                                                                                                                       //
    var user = Meteor.users.findOne({                                                                                  // 2877
      _id: userId                                                                                                      // 2877
    });                                                                                                                // 2877
    this.deleteGrains({                                                                                                // 2878
      userId: userId                                                                                                   // 2878
    }, backend, "grain");                                                                                              // 2878
    this.collections.userActions.remove({                                                                              // 2879
      userId: userId                                                                                                   // 2879
    });                                                                                                                // 2879
    this.collections.notifications.remove({                                                                            // 2880
      userId: userId                                                                                                   // 2880
    });                                                                                                                // 2880
    user.loginIdentities.forEach(function (identity) {                                                                 // 2881
      if (Meteor.users.find({                                                                                          // 2882
        $or: [{                                                                                                        // 2882
          "loginIdentities.id": identity.id                                                                            // 2883
        }, {                                                                                                           // 2883
          "nonloginIdentities.id": identity.id                                                                         // 2884
        }]                                                                                                             // 2884
      }).count() === 1) {                                                                                              // 2882
        // If this is the only account with the identity, then delete it                                               // 2886
        _this.deleteIdentity(identity.id);                                                                             // 2887
      }                                                                                                                // 2888
    });                                                                                                                // 2889
    user.nonloginIdentities.forEach(function (identity) {                                                              // 2890
      if (Meteor.users.find({                                                                                          // 2891
        $or: [{                                                                                                        // 2891
          "loginIdentities.id": identity.id                                                                            // 2892
        }, {                                                                                                           // 2892
          "nonloginIdentities.id": identity.id                                                                         // 2893
        }]                                                                                                             // 2893
      }).count() === 1) {                                                                                              // 2891
        // If this is the only account with the identity, then delete it                                               // 2895
        _this.deleteIdentity(identity.id);                                                                             // 2896
      }                                                                                                                // 2897
    });                                                                                                                // 2898
    this.collections.contacts.remove({                                                                                 // 2899
      ownerId: userId                                                                                                  // 2899
    });                                                                                                                // 2899
    backend.deleteUser(userId);                                                                                        // 2900
    Meteor.users.remove({                                                                                              // 2901
      _id: userId                                                                                                      // 2901
    });                                                                                                                // 2901
  };                                                                                                                   // 2902
}                                                                                                                      // 2903
                                                                                                                       //
Meteor.methods({                                                                                                       // 2905
  addUserActions: function (packageId) {                                                                               // 2906
    check(packageId, String);                                                                                          // 2907
                                                                                                                       //
    if (!this.userId || !Meteor.user().loginIdentities || !isSignedUpOrDemo()) {                                       // 2908
      throw new Meteor.Exception(403, "Must be logged in as a non-guest to add app actions.");                         // 2909
    }                                                                                                                  // 2910
                                                                                                                       //
    if (this.isSimulation) {                                                                                           // 2912
      // TODO(cleanup): Appdemo code relies on this being simulated client-side but we don't have                      // 2913
      //   a proper DB object to use.                                                                                  // 2914
      new SandstormDb().addUserActions(this.userId, packageId, true);                                                  // 2915
    } else {                                                                                                           // 2916
      this.connection.sandstormDb.addUserActions(this.userId, packageId);                                              // 2917
    }                                                                                                                  // 2918
  },                                                                                                                   // 2919
  removeUserAction: function (actionId) {                                                                              // 2921
    check(actionId, String);                                                                                           // 2922
                                                                                                                       //
    if (this.isSimulation) {                                                                                           // 2923
      UserActions.remove({                                                                                             // 2924
        _id: actionId                                                                                                  // 2924
      });                                                                                                              // 2924
    } else {                                                                                                           // 2925
      if (this.userId) {                                                                                               // 2926
        var result = this.connection.sandstormDb.collections.userActions.findAndModify({                               // 2927
          query: {                                                                                                     // 2928
            _id: actionId,                                                                                             // 2928
            userId: this.userId                                                                                        // 2928
          },                                                                                                           // 2928
          remove: true                                                                                                 // 2929
        });                                                                                                            // 2927
                                                                                                                       //
        if (!result.ok) {                                                                                              // 2932
          throw new Error("Couldn't remove user action " + actionId);                                                  // 2933
        }                                                                                                              // 2934
                                                                                                                       //
        var action = result.value;                                                                                     // 2936
                                                                                                                       //
        if (action) {                                                                                                  // 2937
          this.connection.sandstormDb.deleteUnusedPackages(action.appId);                                              // 2938
        }                                                                                                              // 2939
      }                                                                                                                // 2940
    }                                                                                                                  // 2941
  }                                                                                                                    // 2942
});                                                                                                                    // 2905
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"profile.js":function(require){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/sandstorm-db/profile.js                                                                                    //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  // 1
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                               // 2
// All rights reserved.                                                                                                // 3
//                                                                                                                     // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                     // 5
// you may not use this file except in compliance with the License.                                                    // 6
// You may obtain a copy of the License at                                                                             // 7
//                                                                                                                     // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        // 9
//                                                                                                                     // 10
// Unless required by applicable law or agreed to in writing, software                                                 // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                   // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            // 13
// See the License for the specific language governing permissions and                                                 // 14
// limitations under the License.                                                                                      // 15
var makeIdenticon = void 0;                                                                                            // 17
var httpProtocol = void 0;                                                                                             // 18
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 20
  SandstormDb.ensureSubscriberHasIdentity = function (publishHandler, identityId) {                                    // 21
    // Helper for publish functions that need to restrict access based on whether the subscriber                       // 22
    // has a given identity linked. Automatically stops the subscription if the user loses the                         // 23
    // identity. Returns a boolean indicating whether the user initially has the identity.                             // 24
    var userId = publishHandler.userId;                                                                                // 26
                                                                                                                       //
    if (userId === identityId) {                                                                                       // 27
      return true;                                                                                                     // 28
    } else {                                                                                                           // 29
      var hasIdentityCursor = Meteor.users.find({                                                                      // 30
        $or: [{                                                                                                        // 31
          _id: userId,                                                                                                 // 33
          "loginIdentities.id": identityId                                                                             // 34
        }, {                                                                                                           // 32
          _id: userId,                                                                                                 // 37
          "nonloginIdentities.id": identityId                                                                          // 38
        }]                                                                                                             // 36
      });                                                                                                              // 30
                                                                                                                       //
      if (hasIdentityCursor.count() == 0) {                                                                            // 42
        publishHandler.stop();                                                                                         // 43
        return false;                                                                                                  // 44
      }                                                                                                                // 45
                                                                                                                       //
      var handle = hasIdentityCursor.observe({                                                                         // 47
        removed: function () {                                                                                         // 47
          publishHandler.stop();                                                                                       // 47
        }                                                                                                              // 47
      });                                                                                                              // 47
      publishHandler.onStop(function () {                                                                              // 49
        handle.stop();                                                                                                 // 49
      });                                                                                                              // 49
      return true;                                                                                                     // 51
    }                                                                                                                  // 52
  };                                                                                                                   // 53
                                                                                                                       //
  Meteor.publish("identityProfile", function (identityId) {                                                            // 55
    check(identityId, String);                                                                                         // 56
    if (!SandstormDb.ensureSubscriberHasIdentity(this, identityId)) return;                                            // 57
    return Meteor.users.find({                                                                                         // 59
      _id: identityId                                                                                                  // 59
    }, {                                                                                                               // 59
      fields: {                                                                                                        // 60
        profile: 1,                                                                                                    // 61
        unverifiedEmail: 1,                                                                                            // 62
        expires: 1,                                                                                                    // 63
        createdAt: 1,                                                                                                  // 64
        "services.dev.name": 1,                                                                                        // 66
        "services.google.id": 1,                                                                                       // 68
        "services.google.email": 1,                                                                                    // 69
        "services.google.verified_email": 1,                                                                           // 70
        "services.google.name": 1,                                                                                     // 71
        "services.google.picture": 1,                                                                                  // 72
        "services.google.gender": 1,                                                                                   // 73
        "services.google.hd": 1,                                                                                       // 74
        "services.github.id": 1,                                                                                       // 76
        "services.github.email": 1,                                                                                    // 77
        "services.github.emails": 1,                                                                                   // 78
        "services.github.username": 1,                                                                                 // 79
        "services.email.email": 1,                                                                                     // 81
        "services.ldap.id": 1,                                                                                         // 83
        "services.ldap.username": 1,                                                                                   // 84
        "services.ldap.rawAttrs": 1,                                                                                   // 85
        "services.saml.id": 1,                                                                                         // 87
        "services.saml.email": 1,                                                                                      // 88
        "services.saml.displayName": 1                                                                                 // 89
      }                                                                                                                // 60
    });                                                                                                                // 60
  }), Meteor.publish("accountIdentities", function () {                                                                // 92
    // Maybe this should be folded into the "credentials" subscription?                                                // 95
    if (!this.userId) return [];                                                                                       // 97
    return Meteor.users.find({                                                                                         // 99
      _id: this.userId                                                                                                 // 100
    }, {                                                                                                               // 100
      fields: {                                                                                                        // 101
        profile: 1,                                                                                                    // 102
        verifiedEmail: 1,                                                                                              // 103
        loginIdentities: 1,                                                                                            // 104
        nonloginIdentities: 1,                                                                                         // 105
        expires: 1,                                                                                                    // 106
        primaryEmail: 1                                                                                                // 107
      }                                                                                                                // 101
    });                                                                                                                // 101
  });                                                                                                                  // 109
                                                                                                                       //
  makeIdenticon = function (id) {                                                                                      // 111
    var hash = id.slice(0, 32);                                                                                        // 112
    return httpProtocol + "//" + makeWildcardHost("static") + "/identicon/" + hash + "?s=256";                         // 113
  };                                                                                                                   // 114
                                                                                                                       //
  var Url = Npm.require("url");                                                                                        // 116
                                                                                                                       //
  httpProtocol = Url.parse(process.env.ROOT_URL).protocol;                                                             // 117
} else {                                                                                                               // 118
  var identiconCache = {};                                                                                             // 119
                                                                                                                       //
  makeIdenticon = function (id) {                                                                                      // 121
    // Given a cryptographic hash as input, generate an identicon. We always use the user's                            // 122
    // identity ID as the input hash (the same thing passed to apps as the user ID).                                   // 123
    // Pass to identicon.js exactly the hash that we'd pass to apps as X-Sandstorm-User-Id, so                         // 125
    // that apps can themselves use identicon.js to produce consistent identicons. As it turns out                     // 126
    // identicon.js doesn't use the second half of the hash even if we provide it, but slice it                        // 127
    // anyway to be safe.                                                                                              // 128
    var hash = id.slice(0, 32);                                                                                        // 129
                                                                                                                       //
    if (hash in identiconCache) {                                                                                      // 131
      return identiconCache[hash];                                                                                     // 132
    } // Unfortunately, Github's algorithm uses MD5. Whatever, we don't expect these to be secure.                     // 133
                                                                                                                       //
                                                                                                                       //
    var data = new Identicon(hash, 512).toString();                                                                    // 136
    var result = "data:image/svg+xml," + encodeURIComponent(data);                                                     // 137
    identiconCache[hash] = result;                                                                                     // 138
    return result;                                                                                                     // 139
  };                                                                                                                   // 140
                                                                                                                       //
  httpProtocol = window.location.protocol;                                                                             // 142
}                                                                                                                      // 143
                                                                                                                       //
var GENDERS = {                                                                                                        // 145
  male: "male",                                                                                                        // 145
  female: "female",                                                                                                    // 145
  neutral: "neutral",                                                                                                  // 145
  robot: "robot"                                                                                                       // 145
};                                                                                                                     // 145
                                                                                                                       //
function staticAssetUrl(id, staticHost) {                                                                              // 147
  if (id) {                                                                                                            // 148
    return staticHost + "/" + id;                                                                                      // 149
  } else {                                                                                                             // 150
    return undefined;                                                                                                  // 151
  }                                                                                                                    // 152
}                                                                                                                      // 153
                                                                                                                       //
function filterHandle(handle) {                                                                                        // 155
  // Convert disallowed letters into underscores, but no more than one underscore in a row.                            // 156
  return handle && handle.toLowerCase().split(/[^a-z0-9_]+/g).join("_");                                               // 157
}                                                                                                                      // 158
                                                                                                                       //
function emailToHandle(email) {                                                                                        // 160
  // Turn an email address into a handle.                                                                              // 161
  if (!email) return undefined; // Use the stuff before the @. Ignore stuff after '+' because it's commonly used for filters
  // on the same account.                                                                                              // 166
                                                                                                                       //
  var parts = email.split("@");                                                                                        // 167
  var base = filterHandle(parts[0].split("+")[0]);                                                                     // 168
  var domain = (parts[1] || "").split(".");                                                                            // 170
                                                                                                                       //
  if (domain[domain.length - 1] === "name") {                                                                          // 171
    // Oh, a .name domain. Let's use                                                                                   // 172
    base = filterHandle(domain.slice(0, domain.length - 1).join("."));                                                 // 173
  } else if (_.contains(["me", "self", "contact", "admin", "administrator", "root", "info", "sandstorm", "sandstormio", "inbox", "indiegogo", "mail", "email"], base)) {
    // This is probably an address at a vanity domain. Use the domain itself as the handle.                            // 180
    base = filterHandle(domain[0]);                                                                                    // 181
  }                                                                                                                    // 182
                                                                                                                       //
  return filterHandle(base);                                                                                           // 184
}                                                                                                                      // 185
                                                                                                                       //
SandstormDb.fillInProfileDefaults = function (user) {                                                                  // 187
  var profile = user.profile;                                                                                          // 188
                                                                                                                       //
  if (profile.service === "github") {                                                                                  // 189
    profile.name = profile.name || user.services.github.username || "Name Unknown";                                    // 190
    profile.handle = profile.handle || filterHandle(user.services.github.username) || filterHandle(profile.name);      // 191
  } else if (profile.service === "google") {                                                                           // 193
    profile.name = profile.name || user.services.google.name || "Name Unknown";                                        // 194
    profile.handle = profile.handle || emailToHandle(user.services.google.email) || filterHandle(profile.name);        // 195
    profile.pronoun = profile.pronoun || GENDERS[user.services.google.gender] || "neutral";                            // 197
  } else if (profile.service === "email") {                                                                            // 198
    var email = user.services.email.email;                                                                             // 199
    profile.name = profile.name || emailToHandle(email);                                                               // 200
    profile.handle = profile.handle || emailToHandle(email);                                                           // 201
  } else if (profile.service === "dev") {                                                                              // 202
    var lowerCaseName = user.services.dev.name.split(" ")[0].toLowerCase();                                            // 203
    profile.name = profile.name || user.services.dev.name;                                                             // 204
    profile.handle = profile.handle || filterHandle(lowerCaseName);                                                    // 205
    profile.pronoun = profile.pronoun || (_.contains(["alice", "carol", "eve"], lowerCaseName) ? "female" : _.contains(["bob", "dave"], lowerCaseName) ? "male" : "neutral");
  } else if (profile.service === "demo") {                                                                             // 209
    profile.name = profile.name || "Demo User";                                                                        // 210
    profile.handle = profile.handle || "demo";                                                                         // 211
  } else if (profile.service === "ldap") {                                                                             // 212
    var setting = Settings.findOne({                                                                                   // 213
      _id: "ldapNameField"                                                                                             // 213
    });                                                                                                                // 213
    var key = setting ? setting.value : "";                                                                            // 214
    profile.handle = profile.handle || user.services.ldap.username;                                                    // 215
    profile.name = profile.name || user.services.ldap.rawAttrs[key] || profile.handle;                                 // 216
  } else if (profile.service === "saml") {                                                                             // 217
    profile.handle = profile.handle || emailToHandle(user.services.saml.email);                                        // 218
    profile.name = profile.name || user.services.saml.displayName || profile.handle;                                   // 219
  } else {                                                                                                             // 220
    throw new Error("unrecognized identity service: ", profile.service);                                               // 221
  }                                                                                                                    // 222
                                                                                                                       //
  profile.pronoun = profile.pronoun || "neutral";                                                                      // 224
};                                                                                                                     // 225
                                                                                                                       //
SandstormDb.fillInIntrinsicName = function (user) {                                                                    // 227
  var profile = user.profile;                                                                                          // 228
                                                                                                                       //
  if (profile.service === "github") {                                                                                  // 229
    profile.intrinsicName = user.services.github.username;                                                             // 230
  } else if (profile.service === "google") {                                                                           // 231
    profile.intrinsicName = user.services.google.name;                                                                 // 232
    user.privateIntrinsicName = user.services.google.email;                                                            // 233
  } else if (profile.service === "email") {                                                                            // 234
    profile.intrinsicName = user.services.email.email;                                                                 // 235
  } else if (profile.service === "dev") {                                                                              // 236
    profile.intrinsicName = user.services.dev.name;                                                                    // 237
  } else if (profile.service === "demo") {                                                                             // 238
    profile.intrinsicName = "demo on " + user.createdAt.toISOString().substring(0, 10);                                // 239
  } else if (profile.service === "ldap") {                                                                             // 240
    profile.intrinsicName = user.services.ldap.username;                                                               // 241
  } else if (profile.service === "saml") {                                                                             // 242
    profile.intrinsicName = user.services.saml.id;                                                                     // 243
  } else {                                                                                                             // 244
    throw new Error("unrecognized identity service: ", profile.service);                                               // 245
  }                                                                                                                    // 246
};                                                                                                                     // 247
                                                                                                                       //
SandstormDb.fillInLoginId = function (identity) {                                                                      // 249
  var service = identity.profile.service;                                                                              // 250
  identity.loginId = Accounts.identityServices[service].getLoginId(identity);                                          // 251
};                                                                                                                     // 252
                                                                                                                       //
SandstormDb.getVerifiedEmails = function (identity) {                                                                  // 254
  if (identity.services.google && identity.services.google.email && identity.services.google.verified_email) {         // 255
    // jscs:ignore requireCamelCaseOrUpperCaseIdentifiers                                                              // 256
    return [{                                                                                                          // 257
      email: identity.services.google.email,                                                                           // 257
      primary: true                                                                                                    // 257
    }];                                                                                                                // 257
  } else if (identity.services.email) {                                                                                // 258
    return [{                                                                                                          // 259
      email: identity.services.email.email,                                                                            // 259
      primary: true                                                                                                    // 259
    }];                                                                                                                // 259
  } else if (identity.services.github && identity.services.github.emails) {                                            // 260
    return _.chain(identity.services.github.emails).filter(function (email) {                                          // 261
      return email.verified;                                                                                           // 262
    }).map(function (email) {                                                                                          // 262
      return _.pick(email, "email", "primary");                                                                        // 263
    }).value();                                                                                                        // 263
  } else if (identity.services.ldap) {                                                                                 // 265
    // TODO(cleanup): don't create a new SandstormDb here, make this non-static                                        // 266
    var email = identity.services.ldap.rawAttrs[new SandstormDb().getLdapEmailField()];                                // 267
                                                                                                                       //
    if (email) {                                                                                                       // 268
      return [{                                                                                                        // 269
        email: email,                                                                                                  // 269
        primary: true                                                                                                  // 269
      }];                                                                                                              // 269
    }                                                                                                                  // 270
  } else if (identity.services.saml && identity.services.saml.email) {                                                 // 271
    return [{                                                                                                          // 272
      email: identity.services.saml.email,                                                                             // 272
      primary: true                                                                                                    // 272
    }];                                                                                                                // 272
  }                                                                                                                    // 273
                                                                                                                       //
  return [];                                                                                                           // 275
};                                                                                                                     // 276
                                                                                                                       //
SandstormDb.prototype.findIdentitiesByEmail = function (email) {                                                       // 278
  // Returns an array of identities which have the given email address as one of their verified                        // 279
  // addresses.                                                                                                        // 280
  check(email, String); // For LDAP, the field containing the e-mail address is configurable...                        // 282
                                                                                                                       //
  var ldapQuery = {};                                                                                                  // 285
  ldapQuery["services.ldap.rawAttrs." + this.getLdapEmailField()] = email;                                             // 286
  return Meteor.users.find({                                                                                           // 288
    $or: [{                                                                                                            // 288
      "services.google.email": email                                                                                   // 289
    }, {                                                                                                               // 289
      "services.email.email": email                                                                                    // 290
    }, {                                                                                                               // 290
      "services.github.emails.email": email                                                                            // 291
    }, ldapQuery, {                                                                                                    // 291
      "services.saml.email": email                                                                                     // 293
    }]                                                                                                                 // 293
  }).fetch().filter(function (identity) {                                                                              // 288
    // Verify that the email is verified, since our query doesn't technically do that.                                 // 295
    return !!_.findWhere(SandstormDb.getVerifiedEmails(identity), {                                                    // 296
      email: email                                                                                                     // 296
    });                                                                                                                // 296
  });                                                                                                                  // 297
};                                                                                                                     // 298
                                                                                                                       //
SandstormDb.prototype.findAccountsByEmail = function (email) {                                                         // 300
  var identityIds = _.pluck(this.findIdentitiesByEmail(email), "_id");                                                 // 301
                                                                                                                       //
  return Meteor.users.find({                                                                                           // 302
    $or: [{                                                                                                            // 302
      "loginIdentities.id": {                                                                                          // 303
        $in: identityIds                                                                                               // 303
      }                                                                                                                // 303
    }, {                                                                                                               // 303
      "nonloginIdentities.id": {                                                                                       // 304
        $in: identityIds                                                                                               // 304
      }                                                                                                                // 304
    }]                                                                                                                 // 304
  }).fetch();                                                                                                          // 302
};                                                                                                                     // 306
                                                                                                                       //
SandstormDb.fillInPictureUrl = function (user) {                                                                       // 308
  var staticHost = httpProtocol + "//" + makeWildcardHost("static");                                                   // 309
  user.profile.pictureUrl = staticAssetUrl(user.profile.picture, staticHost) || makeIdenticon(user._id);               // 310
};                                                                                                                     // 312
                                                                                                                       //
SandstormDb.getUserIdentityIds = function (user) {                                                                     // 314
  // Given an account user object, returns an array containing the ID of each identity linked to the                   // 315
  // account. Always returns the most recently added login identity first.                                             // 316
  if (user && user.loginIdentities) {                                                                                  // 317
    return _.pluck(user.nonloginIdentities.concat(user.loginIdentities), "id").reverse();                              // 318
  } else {                                                                                                             // 319
    return [];                                                                                                         // 320
  }                                                                                                                    // 321
};                                                                                                                     // 322
                                                                                                                       //
SandstormDb.getUserEmails = function (user) {                                                                          // 324
  // Given a user object, returns an array containing all email addresses associated with that user.                   // 325
  // Each entry in the array is an object of the form:                                                                 // 326
  //     `{email: String, verified: Bool, primary: Optional(Bool)}`                                                    // 327
  //                                                                                                                   // 328
  // At most one entry in the result has `primary = true`.                                                             // 329
  //                                                                                                                   // 330
  // TODO(cleanup): This actually does need to query the database to fetch profile information                         // 331
  //   for linked identities, so it probably makes more sense for it to be a non-static method                         // 332
  //   on SandstormDb.                                                                                                 // 333
  var identityIds = SandstormDb.getUserIdentityIds(user);                                                              // 335
  var verifiedEmails = {};                                                                                             // 336
  var unverifiedEmails = {};                                                                                           // 337
  identityIds.forEach(function (id) {                                                                                  // 339
    var identity = Meteor.users.findOne({                                                                              // 340
      _id: id                                                                                                          // 340
    });                                                                                                                // 340
                                                                                                                       //
    if (identity && identity.services) {                                                                               // 341
      SandstormDb.getVerifiedEmails(identity).forEach(function (verifiedEmail) {                                       // 342
        if (verifiedEmail) {                                                                                           // 343
          verifiedEmails[verifiedEmail.email] = true;                                                                  // 344
        }                                                                                                              // 345
      });                                                                                                              // 346
    }                                                                                                                  // 347
                                                                                                                       //
    if (identity && identity.unverifiedEmail) {                                                                        // 349
      unverifiedEmails[identity.unverifiedEmail] = true;                                                               // 350
    }                                                                                                                  // 351
  });                                                                                                                  // 352
  var result = [];                                                                                                     // 354
                                                                                                                       //
  _.keys(verifiedEmails).map(function (email) {                                                                        // 355
    result.push({                                                                                                      // 356
      email: email,                                                                                                    // 356
      verified: true,                                                                                                  // 357
      primary: email === user.primaryEmail                                                                             // 358
    });                                                                                                                // 356
  });                                                                                                                  // 359
                                                                                                                       //
  _.keys(unverifiedEmails).map(function (email) {                                                                      // 361
    if (!(email in verifiedEmails)) {                                                                                  // 362
      result.push({                                                                                                    // 362
        email: email,                                                                                                  // 362
        verified: false                                                                                                // 362
      });                                                                                                              // 362
    }                                                                                                                  // 362
  }); // If `user.primaryEmail` is not among the verified emails, mark the first as primary.                           // 363
                                                                                                                       //
                                                                                                                       //
  if (!(user.primaryEmail in verifiedEmails) && result.length > 0) {                                                   // 366
    result[0].primary = true;                                                                                          // 367
  }                                                                                                                    // 368
                                                                                                                       //
  return result;                                                                                                       // 370
};                                                                                                                     // 371
                                                                                                                       //
SandstormDb.prototype.addContact = function () {                                                                       // 373
  function addContact(ownerId, identityId) {                                                                           // 373
    check(ownerId, String);                                                                                            // 374
    check(identityId, String);                                                                                         // 375
    var profile = this.getIdentity(identityId).profile;                                                                // 376
    this.collections.contacts.upsert({                                                                                 // 377
      ownerId: ownerId,                                                                                                // 377
      identityId: identityId                                                                                           // 377
    }, {                                                                                                               // 377
      ownerId: ownerId,                                                                                                // 378
      petname: profile && profile.name,                                                                                // 379
      created: new Date(),                                                                                             // 380
      identityId: identityId                                                                                           // 381
    });                                                                                                                // 377
  }                                                                                                                    // 383
                                                                                                                       //
  return addContact;                                                                                                   // 373
}();                                                                                                                   // 373
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}}}}},{"extensions":[".js",".json"]});
require("./node_modules/meteor/sandstorm-db/db.js");
require("./node_modules/meteor/sandstorm-db/profile.js");

/* Exports */
if (typeof Package === 'undefined') Package = {};
(function (pkg, symbols) {
  for (var s in symbols)
    (s in pkg) || (pkg[s] = symbols[s]);
})(Package['sandstorm-db'] = {}, {
  SandstormDb: SandstormDb
});

})();

//# sourceMappingURL=sandstorm-db.js.map
